// Generated by:
// target/debug/k8s-crds-codegen

pub mod monitoring_coreos_com {
    pub mod v1 {
        pub mod alertmanager {
            /// Alertmanager describes an Alertmanager cluster.
            #[derive(serde::Deserialize, Debug, PartialEq)]
            pub struct Alertmanager {
                pub metadata: k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta,
                pub spec: Spec,
                pub status: Status,
            }

            impl k8s_openapi::Resource for Alertmanager {
                type Scope = k8s_openapi::ClusterResourceScope;

                const API_VERSION: &'static str = "monitoring.coreos.com/v1";
                const GROUP: &'static str = "monitoring.coreos.com";
                const KIND: &'static str = "Alertmanager";
                const VERSION: &'static str = "v1";
                const URL_PATH_SEGMENT: &'static str = "";
            }

            impl k8s_openapi::Metadata for Alertmanager {
                type Ty = k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta;

                fn metadata(&self) -> &<Self as k8s_openapi::Metadata>::Ty {
                    &self.metadata
                }

                fn metadata_mut(&mut self) -> &mut <Self as k8s_openapi::Metadata>::Ty {
                    &mut self.metadata
                }
            }

            impl serde::Serialize for Alertmanager {
                fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
                where
                    S: serde::Serializer,
                {
                    use serde::ser::SerializeStruct;
                    let mut state = serializer.serialize_struct("Alertmanager", 5)?;
                    state.serialize_field(
                        "apiVersion",
                        <Self as k8s_openapi::Resource>::API_VERSION,
                    )?;
                    state.serialize_field("kind", <Self as k8s_openapi::Resource>::KIND)?;
                    state.serialize_field("metadata", &self.metadata)?;
                    state.serialize_field("spec", &self.spec)?;
                    state.serialize_field("status", &self.status)?;
                    state.end()
                }
            }

            /// If specified, the pod's scheduling constraints.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Affinity {
                /// Describes node affinity scheduling rules for the pod.
                pub node_affinity: NodeAffinity,
                /// Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).
                pub pod_affinity: PodAffinity,
                /// Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).
                pub pod_anti_affinity: PodAntiAffinity,
            }

            /// Namespaces to be selected for AlertmanagerConfig discovery. If nil, only check own namespace.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagerConfigNamespaceSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<AlertmanagerConfigNamespaceSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: AlertmanagerConfigNamespaceSelectorMatchLabels,
            }

            /// AlertmanagerConfigs to be selected for to merge and configure Alertmanager with.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagerConfigSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<AlertmanagerConfigSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: AlertmanagerConfigSelectorMatchLabels,
            }

            /// EXPERIMENTAL: alertmanagerConfiguration specifies the global Alertmanager configuration. If defined, it takes precedence over the `configSecret` field. This field may change in future releases.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagerConfiguration {
                /// The name of the AlertmanagerConfig resource which is used to generate the global configuration. It must be defined in the same namespace as the Alertmanager object. The operator will not enforce a `namespace` label for routes and inhibition rules.
                pub name: String,
            }

            /// The storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AllocatedResources {
                /// The storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetadataAnnotations {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetadataAnnotations {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub properties: std::collections::HashMap<String, String>,
            }

            /// AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AwsElasticBlockStore {
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).
                pub partition: i32,
                /// Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". If omitted, the default is "false". More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
                pub read_only: bool,
                /// Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
                pub volume_i_d: String,
            }

            /// AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AzureDisk {
                /// Host Caching mode: None, Read Only, Read Write.
                pub caching_mode: String,
                /// The Name of the data disk in the blob storage
                pub disk_name: String,
                /// The URI the data disk in the blob storage
                pub disk_u_r_i: String,
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Expected values Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set). defaults to shared
                pub kind: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
            }

            /// AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AzureFile {
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// the name of secret that contains Azure Storage Account Name and Key
                pub secret_name: String,
                /// Share Name
                pub share_name: String,
            }

            /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextCapabilities {
                /// Added capabilities
                pub add: Vec<String>,
                /// Removed capabilities
                pub drop: Vec<String>,
            }

            /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextCapabilities {
                /// Added capabilities
                pub add: Vec<String>,
                /// Removed capabilities
                pub drop: Vec<String>,
            }

            /// Represents the actual resources of the underlying volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Capacity {
                /// Represents the actual resources of the underlying volume.
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// CephFS represents a Ceph FS mount on the host that shares a pod's lifetime
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cephfs {
                /// Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub monitors: Vec<String>,
                /// Optional: Used as the mounted root, rather than the full Ceph tree, default is /
                pub path: String,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub read_only: bool,
                /// Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub secret_file: String,
                /// Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub secret_ref: CephfsSecretRef,
                /// Optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub user: String,
            }

            /// Cinder represents a cinder volume attached and mounted on kubelets host machine. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cinder {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub fs_type: String,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub read_only: bool,
                /// Optional: points to a secret object containing parameters used to connect to OpenStack.
                pub secret_ref: CinderSecretRef,
                /// volume id used to identify the volume in cinder. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub volume_i_d: String,
            }

            /// PersistentVolumeClaimCondition contails details about state of pvc
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ConditionsItem {
                /// Last time we probed the condition.
                pub last_probe_time: String,
                /// Last time the condition transitioned from one status to another.
                pub last_transition_time: String,
                /// Human-readable message indicating details about last transition.
                pub message: String,
                /// Unique, this should be a short, machine understandable string that gives the reason for condition's last transition. If it reports "ResizeStarted" that means the underlying persistent volume is being resized.
                pub reason: String,
                pub status: String,
                /// PersistentVolumeClaimConditionType is a valid value of PersistentVolumeClaimCondition.Type
                pub r#type: String,
            }

            /// ConfigMap represents a configMap that should populate this volume
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemConfigMap {
                /// Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<VolumesItemConfigMapItemsItem>,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its keys must be defined
                pub optional: bool,
            }

            /// information about the configMap data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemConfigMap {
                /// If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<SourcesItemConfigMapItemsItem>,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its keys must be defined
                pub optional: bool,
            }

            /// Selects a key of a ConfigMap.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromConfigMapKeyRef {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a ConfigMap.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromConfigMapKeyRef {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// The ConfigMap to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvFromItemConfigMapRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap must be defined
                pub optional: bool,
            }

            /// The ConfigMap to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvFromItemConfigMapRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap must be defined
                pub optional: bool,
            }

            /// A single application container that you want to run within a pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItem {
                /// Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub args: Vec<String>,
                /// Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub command: Vec<String>,
                /// List of environment variables to set in the container. Cannot be updated.
                pub env: Vec<ContainersItemEnvItem>,
                /// List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.
                pub env_from: Vec<ContainersItemEnvFromItem>,
                /// Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.
                pub image: String,
                /// Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images
                pub image_pull_policy: String,
                /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
                pub lifecycle: ContainersItemLifecycle,
                /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub liveness_probe: ContainersItemLivenessProbe,
                /// Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.
                pub name: String,
                /// List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Cannot be updated.
                pub ports: Vec<ContainersItemPortsItem>,
                /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub readiness_probe: ContainersItemReadinessProbe,
                /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub resources: ContainersItemResources,
                /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
                pub security_context: ContainersItemSecurityContext,
                /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub startup_probe: ContainersItemStartupProbe,
                /// Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.
                pub stdin: bool,
                /// Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false
                pub stdin_once: bool,
                /// Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.
                pub termination_message_path: String,
                /// Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.
                pub termination_message_policy: String,
                /// Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.
                pub tty: bool,
                /// volumeDevices is the list of block devices to be used by the container.
                pub volume_devices: Vec<ContainersItemVolumeDevicesItem>,
                /// Pod volumes to mount into the container's filesystem. Cannot be updated.
                pub volume_mounts: Vec<ContainersItemVolumeMountsItem>,
                /// Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.
                pub working_dir: String,
            }

            /// CSI (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Csi {
                /// Driver is the name of the CSI driver that handles this volume. Consult with your admin for the correct name as registered in the cluster.
                pub driver: String,
                /// Filesystem type to mount. Ex. "ext4", "xfs", "ntfs". If not provided, the empty value is passed to the associated CSI driver which will determine the default filesystem to apply.
                pub fs_type: String,
                /// NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.
                pub node_publish_secret_ref: NodePublishSecretRef,
                /// Specifies a read-only configuration for the volume. Defaults to false (read/write).
                pub read_only: bool,
                /// VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
                pub volume_attributes: VolumeAttributes,
            }

            /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecDataSource {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecDataSource {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecDataSource {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecDataSourceRef {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecDataSourceRef {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecDataSourceRef {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// DownwardAPI represents downward API about the pod that should populate this volume
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPI {
                /// Optional: mode bits to use on created files by default. Must be a Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// Items is a list of downward API volume file
                pub items: Vec<VolumesItemDownwardAPIItemsItem>,
            }

            /// information about the downwardAPI data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPI {
                /// Items is a list of DownwardAPIVolume file
                pub items: Vec<SourcesItemDownwardAPIItemsItem>,
            }

            /// EmptyDirVolumeSource to be used by the Prometheus StatefulSets. If specified, used in place of any volumeClaimTemplate. More info: https://kubernetes.io/docs/concepts/storage/volumes/#emptydir
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEmptyDir {
                /// What type of storage medium should back this directory. The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
                pub medium: String,
                /// Total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir
                pub size_limit: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// EmptyDir represents a temporary directory that shares a pod's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEmptyDir {
                /// What type of storage medium should back this directory. The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
                pub medium: String,
                /// Total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir
                pub size_limit: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// EnvFromSource represents the source of a set of ConfigMaps
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvFromItem {
                /// The ConfigMap to select from
                pub config_map_ref: ContainersItemEnvFromItemConfigMapRef,
                /// An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.
                pub prefix: String,
                /// The Secret to select from
                pub secret_ref: ContainersItemEnvFromItemSecretRef,
            }

            /// EnvFromSource represents the source of a set of ConfigMaps
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvFromItem {
                /// The ConfigMap to select from
                pub config_map_ref: InitContainersItemEnvFromItemConfigMapRef,
                /// An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.
                pub prefix: String,
                /// The Secret to select from
                pub secret_ref: InitContainersItemEnvFromItemSecretRef,
            }

            /// EnvVar represents an environment variable present in a Container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItem {
                /// Name of the environment variable. Must be a C_IDENTIFIER.
                pub name: String,
                /// Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "".
                pub value: String,
                /// Source for the environment variable's value. Cannot be used if value is not empty.
                pub value_from: ContainersItemEnvItemValueFrom,
            }

            /// EnvVar represents an environment variable present in a Container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItem {
                /// Name of the environment variable. Must be a C_IDENTIFIER.
                pub name: String,
                /// Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "".
                pub value: String,
                /// Source for the environment variable's value. Cannot be used if value is not empty.
                pub value_from: InitContainersItemEnvItemValueFrom,
            }

            /// EphemeralVolumeSource to be used by the Prometheus StatefulSets. This is a beta field in k8s 1.21, for lower versions, starting with k8s 1.19, it requires enabling the GenericEphemeralVolume feature gate. More info: https://kubernetes.io/docs/concepts/storage/ephemeral-volumes/#generic-ephemeral-volumes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeral {
                /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
                ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
                ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
                ///  Required, must not be nil.
                pub volume_claim_template: StorageEphemeralVolumeClaimTemplate,
            }

            /// Ephemeral represents a volume that is handled by a cluster storage driver. The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts, and deleted when the pod is removed.
            ///  Use this if: a) the volume is only needed while the pod runs, b) features of normal volumes like restoring from snapshot or capacity tracking are needed, c) the storage driver is specified through a storage class, and d) the storage driver supports dynamic volume provisioning through a PersistentVolumeClaim (see EphemeralVolumeSource for more information on the connection between this volume type and PersistentVolumeClaim).
            ///  Use PersistentVolumeClaim or one of the vendor-specific APIs for volumes that persist for longer than the lifecycle of an individual pod.
            ///  Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to be used that way - see the documentation of the driver for more information.
            ///  A pod can use both types of ephemeral volumes and persistent volumes at the same time.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeral {
                /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
                ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
                ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
                ///  Required, must not be nil.
                pub volume_claim_template: VolumesItemEphemeralVolumeClaimTemplate,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Fc {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// Optional: FC target lun number
                pub lun: i32,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// Optional: FC target worldwide names (WWNs)
                pub target_w_w_ns: Vec<String>,
                /// Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.
                pub wwids: Vec<String>,
            }

            /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPIItemsItemFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPIItemsItemFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct FlexVolume {
                /// Driver is the name of the driver to use for this volume.
                pub driver: String,
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.
                pub fs_type: String,
                /// Optional: Extra command options if any.
                pub options: Options,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.
                pub secret_ref: FlexVolumeSecretRef,
            }

            /// Flocker represents a Flocker volume attached to a kubelet's host machine. This depends on the Flocker control service being running
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Flocker {
                /// Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated
                pub dataset_name: String,
                /// UUID of the dataset. This is unique identifier of a Flocker dataset
                pub dataset_u_u_i_d: String,
            }

            /// GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GcePersistentDisk {
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub partition: i32,
                /// Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub pd_name: String,
                /// ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub read_only: bool,
            }

            /// GitRepo represents a git repository at a particular revision. DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GitRepo {
                /// Target directory name. Must not contain or start with '..'.  If '.' is supplied, the volume directory will be the git repository.  Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name.
                pub directory: String,
                /// Repository URL
                pub repository: String,
                /// Commit hash for the specified revision.
                pub revision: String,
            }

            /// Glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/glusterfs/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Glusterfs {
                /// EndpointsName is the endpoint name that details Glusterfs topology. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
                pub endpoints: String,
                /// Path is the Glusterfs volume path. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
                pub path: String,
                /// ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
                pub read_only: bool,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct HostAliasesItem {
                /// Hostnames for the above IP address.
                pub hostnames: Vec<String>,
                /// IP address of the host file entry.
                pub ip: String,
            }

            /// HostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath --- TODO(jonesdl) We need to restrict who can use host directory mounts and who can/can not mount host directories as read/write.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct HostPath {
                /// Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
                pub path: String,
                /// Type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
                pub r#type: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemLifecyclePostStartHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemLifecyclePreStopHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemLivenessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemReadinessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemStartupProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemLifecyclePostStartHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemLifecyclePreStopHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemLivenessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemReadinessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemStartupProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ImagePullSecretsItem {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// A single application container that you want to run within a pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItem {
                /// Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub args: Vec<String>,
                /// Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub command: Vec<String>,
                /// List of environment variables to set in the container. Cannot be updated.
                pub env: Vec<InitContainersItemEnvItem>,
                /// List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.
                pub env_from: Vec<InitContainersItemEnvFromItem>,
                /// Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.
                pub image: String,
                /// Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images
                pub image_pull_policy: String,
                /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
                pub lifecycle: InitContainersItemLifecycle,
                /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub liveness_probe: InitContainersItemLivenessProbe,
                /// Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.
                pub name: String,
                /// List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Cannot be updated.
                pub ports: Vec<InitContainersItemPortsItem>,
                /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub readiness_probe: InitContainersItemReadinessProbe,
                /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub resources: InitContainersItemResources,
                /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
                pub security_context: InitContainersItemSecurityContext,
                /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub startup_probe: InitContainersItemStartupProbe,
                /// Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.
                pub stdin: bool,
                /// Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false
                pub stdin_once: bool,
                /// Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.
                pub termination_message_path: String,
                /// Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.
                pub termination_message_policy: String,
                /// Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.
                pub tty: bool,
                /// volumeDevices is the list of block devices to be used by the container.
                pub volume_devices: Vec<InitContainersItemVolumeDevicesItem>,
                /// Pod volumes to mount into the container's filesystem. Cannot be updated.
                pub volume_mounts: Vec<InitContainersItemVolumeMountsItem>,
                /// Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.
                pub working_dir: String,
            }

            /// ISCSI represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://examples.k8s.io/volumes/iscsi/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Iscsi {
                /// whether support iSCSI Discovery CHAP authentication
                pub chap_auth_discovery: bool,
                /// whether support iSCSI Session CHAP authentication
                pub chap_auth_session: bool,
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.
                pub initiator_name: String,
                /// Target iSCSI Qualified Name.
                pub iqn: String,
                /// iSCSI Interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).
                pub iscsi_interface: String,
                /// iSCSI Target Lun number.
                pub lun: i32,
                /// iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).
                pub portals: Vec<String>,
                /// ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.
                pub read_only: bool,
                /// CHAP Secret for iSCSI target and initiator authentication
                pub secret_ref: IscsiSecretRef,
                /// iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).
                pub target_portal: String,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemConfigMapItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// DownwardAPIVolumeFile represents information to create the file containing the pod field
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPIItemsItem {
                /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
                pub field_ref: VolumesItemDownwardAPIItemsItemFieldRef,
                /// Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'
                pub path: String,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
                pub resource_field_ref: VolumesItemDownwardAPIItemsItemResourceFieldRef,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemConfigMapItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// DownwardAPIVolumeFile represents information to create the file containing the pod field
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPIItemsItem {
                /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
                pub field_ref: SourcesItemDownwardAPIItemsItemFieldRef,
                /// Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'
                pub path: String,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
                pub resource_field_ref: SourcesItemDownwardAPIItemsItemResourceFieldRef,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemSecretItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemSecretItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels,
        }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels,
        }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels,
        }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels,
        }

            /// LabelSelector is used to find matching pods. Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItemLabelSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<TopologySpreadConstraintsItemLabelSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: TopologySpreadConstraintsItemLabelSelectorMatchLabels,
            }

            /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetadataLabels {
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetadataLabels {
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecycle {
                /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub post_start: ContainersItemLifecyclePostStart,
                /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub pre_stop: ContainersItemLifecyclePreStop,
            }

            /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecycle {
                /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub post_start: InitContainersItemLifecyclePostStart,
                /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub pre_stop: InitContainersItemLifecyclePreStop,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbe {
                /// Exec specifies the action to take.
                pub exec: ContainersItemLivenessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: ContainersItemLivenessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemLivenessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: ContainersItemLivenessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbe {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemLivenessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: InitContainersItemLivenessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemLivenessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: InitContainersItemLivenessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PreferenceMatchExpressionsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelectorTermsItemMatchExpressionsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagerConfigNamespaceSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagerConfigSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItemLabelSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PreferenceMatchFieldsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelectorTermsItemMatchFieldsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagerConfigNamespaceSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagerConfigSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItemLabelSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateMetadata {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub properties: serde_json::Map<String, serde_json::Value>,
            }

            /// EmbeddedMetadata contains metadata relevant to an EmbeddedResource.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateMetadata {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub annotations: MetadataAnnotations,
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub labels: MetadataLabels,
                /// Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
                pub name: String,
            }

            /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateMetadata {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub properties: serde_json::Map<String, serde_json::Value>,
            }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels,
        }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels,
        }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels,
        }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels,
        }

            /// NFS represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Nfs {
                /// Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub path: String,
                /// ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub read_only: bool,
                /// Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub server: String,
            }

            /// Describes node affinity scheduling rules for the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeAffinity {
                /// The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.
                pub preferred_during_scheduling_ignored_during_execution:
                    Vec<NodeAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem>,
                /// If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.
                pub required_during_scheduling_ignored_during_execution:
                    RequiredDuringSchedulingIgnoredDuringExecution,
            }

            /// NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodePublishSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// Define which Nodes the Pods are scheduled on.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelector {
                /// Define which Nodes the Pods are scheduled on.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// A null or empty node selector term matches no objects. The requirements of them are ANDed. The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelectorTermsItem {
                /// A list of node selector requirements by node's labels.
                pub match_expressions: Vec<NodeSelectorTermsItemMatchExpressionsItem>,
                /// A list of node selector requirements by node's fields.
                pub match_fields: Vec<NodeSelectorTermsItemMatchFieldsItem>,
            }

            /// Optional: Extra command options if any.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Options {
                /// Optional: Extra command options if any.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PersistentVolumeClaim {
                /// ClaimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub claim_name: String,
                /// Will force the ReadOnly setting in VolumeMounts. Default false.
                pub read_only: bool,
            }

            /// PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PhotonPersistentDisk {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// ID that identifies Photon Controller persistent disk
                pub pd_i_d: String,
            }

            /// Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinity {
                /// The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.
                pub preferred_during_scheduling_ignored_during_execution:
                    Vec<PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem>,
                /// If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.
                pub required_during_scheduling_ignored_during_execution:
                    Vec<PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem>,
            }

            /// Required. A pod affinity term, associated with the corresponding weight.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm {
            /// A label query over a set of resources, in this case pods.
            pub label_selector: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector,
            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            pub namespace_selector: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector,
            /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
            pub namespaces: Vec<String>,
            /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
            pub topology_key: String,
        }

            /// Required. A pod affinity term, associated with the corresponding weight.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm {
            /// A label query over a set of resources, in this case pods.
            pub label_selector: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector,
            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            pub namespace_selector: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector,
            /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
            pub namespaces: Vec<String>,
            /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
            pub topology_key: String,
        }

            /// Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinity {
                /// The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.
                pub preferred_during_scheduling_ignored_during_execution:
                    Vec<PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem>,
                /// If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.
                pub required_during_scheduling_ignored_during_execution:
                    Vec<PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem>,
            }

            /// PodMetadata configures Labels and Annotations which are propagated to the alertmanager pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetadata {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub annotations: PodMetadataAnnotations,
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub labels: PodMetadataLabels,
                /// Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
                pub name: String,
            }

            /// ContainerPort represents a network port in a single container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemPortsItem {
                /// Number of port to expose on the pod's IP address. This must be a valid port number, 0 < x < 65536.
                pub container_port: i32,
                /// What host IP to bind the external port to.
                pub host_i_p: String,
                /// Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.
                pub host_port: i32,
                /// If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services.
                pub name: String,
                /// Protocol for port. Must be UDP, TCP, or SCTP. Defaults to "TCP".
                pub protocol: String,
            }

            /// ContainerPort represents a network port in a single container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemPortsItem {
                /// Number of port to expose on the pod's IP address. This must be a valid port number, 0 < x < 65536.
                pub container_port: i32,
                /// What host IP to bind the external port to.
                pub host_i_p: String,
                /// Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.
                pub host_port: i32,
                /// If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services.
                pub name: String,
                /// Protocol for port. Must be UDP, TCP, or SCTP. Defaults to "TCP".
                pub protocol: String,
            }

            /// PortworxVolume represents a portworx volume attached and mounted on kubelets host machine
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PortworxVolume {
                /// FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// VolumeID uniquely identifies a Portworx volume
                pub volume_i_d: String,
            }

            /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStart {
                /// Exec specifies the action to take.
                pub exec: ContainersItemLifecyclePostStartExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemLifecyclePostStartHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: ContainersItemLifecyclePostStartTcpSocket,
            }

            /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStart {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemLifecyclePostStartExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemLifecyclePostStartHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: InitContainersItemLifecyclePostStartTcpSocket,
            }

            /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStop {
                /// Exec specifies the action to take.
                pub exec: ContainersItemLifecyclePreStopExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemLifecyclePreStopHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: ContainersItemLifecyclePreStopTcpSocket,
            }

            /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStop {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemLifecyclePreStopExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemLifecyclePreStopHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: InitContainersItemLifecyclePreStopTcpSocket,
            }

            /// A node selector term, associated with the corresponding weight.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Preference {
                /// A list of node selector requirements by node's labels.
                pub match_expressions: Vec<PreferenceMatchExpressionsItem>,
                /// A list of node selector requirements by node's fields.
                pub match_fields: Vec<PreferenceMatchFieldsItem>,
            }

            /// An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it's a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem {
                /// A node selector term, associated with the corresponding weight.
                pub preference: Preference,
                /// Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100.
                pub weight: i32,
            }

            /// The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem {
                /// Required. A pod affinity term, associated with the corresponding weight.
                pub pod_affinity_term:
                    PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm,
                /// weight associated with matching the corresponding podAffinityTerm, in the range 1-100.
                pub weight: i32,
            }

            /// The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem {
            /// Required. A pod affinity term, associated with the corresponding weight.
            pub pod_affinity_term: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm,
            /// weight associated with matching the corresponding podAffinityTerm, in the range 1-100.
            pub weight: i32,
        }

            /// Items for all in one resources secrets, configmaps, and downward API
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Projected {
                /// Mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// list of volume projections
                pub sources: Vec<SourcesItem>,
            }

            /// Quobyte represents a Quobyte mount on the host that shares a pod's lifetime
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Quobyte {
                /// Group to map volume access to Default is no group
                pub group: String,
                /// ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false.
                pub read_only: bool,
                /// Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes
                pub registry: String,
                /// Tenant owning the given Quobyte volume in the Backend Used with dynamically provisioned Quobyte volumes, value is set by the plugin
                pub tenant: String,
                /// User to map volume access to Defaults to serivceaccount user
                pub user: String,
                /// Volume is a string that references an already created Quobyte volume by name.
                pub volume: String,
            }

            /// RBD represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/rbd/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Rbd {
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// The rados image name. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub image: String,
                /// Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub keyring: String,
                /// A collection of Ceph monitors. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub monitors: Vec<String>,
                /// The rados pool name. Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub pool: String,
                /// ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub read_only: bool,
                /// SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub secret_ref: RbdSecretRef,
                /// The rados user name. Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub user: String,
            }

            /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbe {
                /// Exec specifies the action to take.
                pub exec: ContainersItemReadinessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: ContainersItemReadinessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemReadinessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: ContainersItemReadinessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbe {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemReadinessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: InitContainersItemReadinessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemReadinessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: InitContainersItemReadinessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RequiredDuringSchedulingIgnoredDuringExecution {
                /// Required. A list of node selector terms. The terms are ORed.
                pub node_selector_terms: Vec<NodeSelectorTermsItem>,
            }

            /// Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem {
                /// A label query over a set of resources, in this case pods.
                pub label_selector:
                    PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector,
                /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
                pub namespace_selector:
                    PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector,
                /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
                pub namespaces: Vec<String>,
                /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
                pub topology_key: String,
            }

            /// Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem {
            /// A label query over a set of resources, in this case pods.
            pub label_selector: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector,
            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            pub namespace_selector: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector,
            /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
            pub namespaces: Vec<String>,
            /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
            pub topology_key: String,
        }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPIItemsItemResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPIItemsItemResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Define resources requests and limits for single Pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: SpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: SpecResourcesRequests,
            }

            /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: ContainersItemResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: ContainersItemResourcesRequests,
            }

            /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: InitContainersItemResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: InitContainersItemResourcesRequests,
            }

            /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: StorageEphemeralVolumeClaimTemplateSpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: StorageEphemeralVolumeClaimTemplateSpecResourcesRequests,
            }

            /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: StorageVolumeClaimTemplateSpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: StorageVolumeClaimTemplateSpecResourcesRequests,
            }

            /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: VolumesItemEphemeralVolumeClaimTemplateSpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: VolumesItemEphemeralVolumeClaimTemplateSpecResourcesRequests,
            }

            /// ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ScaleIO {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs".
                pub fs_type: String,
                /// The host address of the ScaleIO API Gateway.
                pub gateway: String,
                /// The name of the ScaleIO Protection Domain for the configured storage.
                pub protection_domain: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.
                pub secret_ref: ScaleIOSecretRef,
                /// Flag to enable/disable SSL communication with Gateway, default false
                pub ssl_enabled: bool,
                /// Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. Default is ThinProvisioned.
                pub storage_mode: String,
                /// The ScaleIO Storage Pool associated with the protection domain.
                pub storage_pool: String,
                /// The name of the storage system as configured in ScaleIO.
                pub system: String,
                /// The name of a volume already created in the ScaleIO system that is associated with this volume source.
                pub volume_name: String,
            }

            /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextSeLinuxOptions {
                /// Level is SELinux level label that applies to the container.
                pub level: String,
                /// Role is a SELinux role label that applies to the container.
                pub role: String,
                /// Type is a SELinux type label that applies to the container.
                pub r#type: String,
                /// User is a SELinux user label that applies to the container.
                pub user: String,
            }

            /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextSeLinuxOptions {
                /// Level is SELinux level label that applies to the container.
                pub level: String,
                /// Role is a SELinux role label that applies to the container.
                pub role: String,
                /// Type is a SELinux type label that applies to the container.
                pub r#type: String,
                /// User is a SELinux user label that applies to the container.
                pub user: String,
            }

            /// The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContextSeLinuxOptions {
                /// Level is SELinux level label that applies to the container.
                pub level: String,
                /// Role is a SELinux role label that applies to the container.
                pub role: String,
                /// Type is a SELinux type label that applies to the container.
                pub r#type: String,
                /// User is a SELinux user label that applies to the container.
                pub user: String,
            }

            /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextSeccompProfile {
                /// localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".
                pub localhost_profile: String,
                /// type indicates which kind of seccomp profile will be applied. Valid options are:
                ///  Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.
                pub r#type: String,
            }

            /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextSeccompProfile {
                /// localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".
                pub localhost_profile: String,
                /// type indicates which kind of seccomp profile will be applied. Valid options are:
                ///  Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.
                pub r#type: String,
            }

            /// The seccomp options to use by the containers in this pod. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContextSeccompProfile {
                /// localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".
                pub localhost_profile: String,
                /// type indicates which kind of seccomp profile will be applied. Valid options are:
                ///  Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.
                pub r#type: String,
            }

            /// Secret represents a secret that should populate this volume. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemSecret {
                /// Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<VolumesItemSecretItemsItem>,
                /// Specify whether the Secret or its keys must be defined
                pub optional: bool,
                /// Name of the secret in the pod's namespace to use. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
                pub secret_name: String,
            }

            /// information about the secret data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemSecret {
                /// If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<SourcesItemSecretItemsItem>,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a secret in the pod's namespace
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromSecretKeyRef {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a secret in the pod's namespace
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromSecretKeyRef {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The Secret to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvFromItemSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret must be defined
                pub optional: bool,
            }

            /// The Secret to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvFromItemSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret must be defined
                pub optional: bool,
            }

            /// Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CephfsSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// Optional: points to a secret object containing parameters used to connect to OpenStack.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CinderSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct FlexVolumeSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// CHAP Secret for iSCSI target and initiator authentication
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct IscsiSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RbdSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ScaleIOSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageosSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecurityContext holds pod-level security attributes and common container settings. This defaults to the default PodSecurityContext.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContext {
                /// A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:
                ///  1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----
                ///  If unset, the Kubelet will not modify the ownership and permissions of any volume. Note that this field cannot be set when spec.os.name is windows.
                pub fs_group: i64,
                /// fsGroupChangePolicy defines behavior of changing ownership and permission of the volume before being exposed inside Pod. This field will only apply to volume types which support fsGroup based ownership(and permissions). It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir. Valid values are "OnRootMismatch" and "Always". If not specified, "Always" is used. Note that this field cannot be set when spec.os.name is windows.
                pub fs_group_change_policy: String,
                /// The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_group: i64,
                /// Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_non_root: bool,
                /// The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_user: i64,
                /// The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
                pub se_linux_options: SpecSecurityContextSeLinuxOptions,
                /// The seccomp options to use by the containers in this pod. Note that this field cannot be set when spec.os.name is windows.
                pub seccomp_profile: SpecSecurityContextSeccompProfile,
                /// A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container. Note that this field cannot be set when spec.os.name is windows.
                pub supplemental_groups: Vec<i64>,
                /// Sysctls hold a list of namespaced sysctls used for the pod. Pods with unsupported sysctls (by the container runtime) might fail to launch. Note that this field cannot be set when spec.os.name is windows.
                pub sysctls: Vec<SysctlsItem>,
                /// The Windows specific settings applied to all containers. If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
                pub windows_options: SpecSecurityContextWindowsOptions,
            }

            /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContext {
                /// AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.
                pub allow_privilege_escalation: bool,
                /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
                pub capabilities: ContainersItemSecurityContextCapabilities,
                /// Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.
                pub privileged: bool,
                /// procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.
                pub proc_mount: String,
                /// Whether this container has a read-only root filesystem. Default is false. Note that this field cannot be set when spec.os.name is windows.
                pub read_only_root_filesystem: bool,
                /// The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_group: i64,
                /// Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_non_root: bool,
                /// The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_user: i64,
                /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub se_linux_options: ContainersItemSecurityContextSeLinuxOptions,
                /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
                pub seccomp_profile: ContainersItemSecurityContextSeccompProfile,
                /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
                pub windows_options: ContainersItemSecurityContextWindowsOptions,
            }

            /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContext {
                /// AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.
                pub allow_privilege_escalation: bool,
                /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
                pub capabilities: InitContainersItemSecurityContextCapabilities,
                /// Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.
                pub privileged: bool,
                /// procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.
                pub proc_mount: String,
                /// Whether this container has a read-only root filesystem. Default is false. Note that this field cannot be set when spec.os.name is windows.
                pub read_only_root_filesystem: bool,
                /// The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_group: i64,
                /// Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_non_root: bool,
                /// The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_user: i64,
                /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub se_linux_options: InitContainersItemSecurityContextSeLinuxOptions,
                /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
                pub seccomp_profile: InitContainersItemSecurityContextSeccompProfile,
                /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
                pub windows_options: InitContainersItemSecurityContextWindowsOptions,
            }

            /// A label query over volumes to consider for binding.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<StorageEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: StorageEphemeralVolumeClaimTemplateSpecSelectorMatchLabels,
            }

            /// A label query over volumes to consider for binding.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<StorageVolumeClaimTemplateSpecSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: StorageVolumeClaimTemplateSpecSelectorMatchLabels,
            }

            /// A label query over volumes to consider for binding.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchLabels,
            }

            /// information about the serviceAccountToken data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceAccountToken {
                /// Audience is the intended audience of the token. A recipient of a token must identify itself with an identifier specified in the audience of the token, and otherwise should reject the token. The audience defaults to the identifier of the apiserver.
                pub audience: String,
                /// ExpirationSeconds is the requested duration of validity of the service account token. As the token approaches expiration, the kubelet volume plugin will proactively rotate the service account token. The kubelet will start trying to rotate the token if the token is older than 80 percent of its time to live or if the token is older than 24 hours.Defaults to 1 hour and must be at least 10 minutes.
                pub expiration_seconds: i64,
                /// Path is the path relative to the mount point of the file to project the token into.
                pub path: String,
            }

            /// Projection that may be projected along with other supported volume types
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItem {
                /// information about the configMap data to project
                pub config_map: SourcesItemConfigMap,
                /// information about the downwardAPI data to project
                pub downward_a_p_i: SourcesItemDownwardAPI,
                /// information about the secret data to project
                pub secret: SourcesItemSecret,
                /// information about the serviceAccountToken data to project
                pub service_account_token: ServiceAccountToken,
            }

            /// Specification of the desired behavior of the Alertmanager cluster. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Spec {
                /// AdditionalPeers allows injecting a set of additional Alertmanagers to peer with to form a highly available cluster.
                pub additional_peers: Vec<String>,
                /// If specified, the pod's scheduling constraints.
                pub affinity: Affinity,
                /// Namespaces to be selected for AlertmanagerConfig discovery. If nil, only check own namespace.
                pub alertmanager_config_namespace_selector: AlertmanagerConfigNamespaceSelector,
                /// AlertmanagerConfigs to be selected for to merge and configure Alertmanager with.
                pub alertmanager_config_selector: AlertmanagerConfigSelector,
                /// EXPERIMENTAL: alertmanagerConfiguration specifies the global Alertmanager configuration. If defined, it takes precedence over the `configSecret` field. This field may change in future releases.
                pub alertmanager_configuration: AlertmanagerConfiguration,
                /// Base image that is used to deploy pods, without tag. Deprecated: use 'image' instead
                pub base_image: String,
                /// ClusterAdvertiseAddress is the explicit address to advertise in cluster. Needs to be provided for non RFC1918 [1] (public) addresses. [1] RFC1918: https://tools.ietf.org/html/rfc1918
                pub cluster_advertise_address: String,
                /// Interval between gossip attempts.
                pub cluster_gossip_interval: String,
                /// Timeout for cluster peering.
                pub cluster_peer_timeout: String,
                /// Interval between pushpull attempts.
                pub cluster_pushpull_interval: String,
                /// ConfigMaps is a list of ConfigMaps in the same namespace as the Alertmanager object, which shall be mounted into the Alertmanager Pods. The ConfigMaps are mounted into /etc/alertmanager/configmaps/<configmap-name>.
                pub config_maps: Vec<String>,
                /// ConfigSecret is the name of a Kubernetes Secret in the same namespace as the Alertmanager object, which contains the configuration for this Alertmanager instance. If empty, it defaults to 'alertmanager-<alertmanager-name>'.
                ///  The Alertmanager configuration should be available under the `alertmanager.yaml` key. Additional keys from the original secret are copied to the generated secret.
                ///  If either the secret or the `alertmanager.yaml` key is missing, the operator provisions an Alertmanager configuration with one empty receiver (effectively dropping alert notifications).
                pub config_secret: String,
                /// Containers allows injecting additional containers. This is meant to allow adding an authentication proxy to an Alertmanager pod. Containers described here modify an operator generated container if they share the same name and modifications are done via a strategic merge patch. The current container names are: `alertmanager` and `config-reloader`. Overriding containers is entirely outside the scope of what the maintainers will support and by doing so, you accept that this behaviour may break at any time without notice.
                pub containers: Vec<ContainersItem>,
                /// The external URL the Alertmanager instances will be available under. This is necessary to generate correct URLs. This is necessary if Alertmanager is not served from root of a DNS name.
                pub external_url: String,
                /// ForceEnableClusterMode ensures Alertmanager does not deactivate the cluster mode when running with a single replica. Use case is e.g. spanning an Alertmanager cluster across Kubernetes clusters with a single replica in each.
                pub force_enable_cluster_mode: bool,
                /// Pods' hostAliases configuration
                pub host_aliases: Vec<HostAliasesItem>,
                /// Image if specified has precedence over baseImage, tag and sha combinations. Specifying the version is still necessary to ensure the Prometheus Operator knows what version of Alertmanager is being configured.
                pub image: String,
                /// An optional list of references to secrets in the same namespace to use for pulling prometheus and alertmanager images from registries see http://kubernetes.io/docs/user-guide/images#specifying-imagepullsecrets-on-a-pod
                pub image_pull_secrets: Vec<ImagePullSecretsItem>,
                /// InitContainers allows adding initContainers to the pod definition. Those can be used to e.g. fetch secrets for injection into the Alertmanager configuration from external sources. Any errors during the execution of an initContainer will lead to a restart of the Pod. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/ Using initContainers for any use case other then secret fetching is entirely outside the scope of what the maintainers will support and by doing so, you accept that this behaviour may break at any time without notice.
                pub init_containers: Vec<InitContainersItem>,
                /// ListenLocal makes the Alertmanager server listen on loopback, so that it does not bind against the Pod IP. Note this is only for the Alertmanager UI, not the gossip communication.
                pub listen_local: bool,
                /// Log format for Alertmanager to be configured with.
                pub log_format: String,
                /// Log level for Alertmanager to be configured with.
                pub log_level: String,
                /// Minimum number of seconds for which a newly created pod should be ready without any of its container crashing for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready) This is an alpha field and requires enabling StatefulSetMinReadySeconds feature gate.
                pub min_ready_seconds: i32,
                /// Define which Nodes the Pods are scheduled on.
                pub node_selector: NodeSelector,
                /// If set to true all actions on the underlying managed objects are not goint to be performed, except for delete actions.
                pub paused: bool,
                /// PodMetadata configures Labels and Annotations which are propagated to the alertmanager pods.
                pub pod_metadata: PodMetadata,
                /// Port name used for the pods and governing service. This defaults to web
                pub port_name: String,
                /// Priority class assigned to the Pods
                pub priority_class_name: String,
                /// Size is the expected size of the alertmanager cluster. The controller will eventually make the size of the running cluster equal to the expected size.
                pub replicas: i32,
                /// Define resources requests and limits for single Pods.
                pub resources: SpecResources,
                /// Time duration Alertmanager shall retain data for. Default is '120h', and must match the regular expression `[0-9]+(ms|s|m|h)` (milliseconds seconds minutes hours).
                pub retention: String,
                /// The route prefix Alertmanager registers HTTP handlers for. This is useful, if using ExternalURL and a proxy is rewriting HTTP routes of a request, and the actual ExternalURL is still true, but the server serves requests under a different route prefix. For example for use with `kubectl proxy`.
                pub route_prefix: String,
                /// Secrets is a list of Secrets in the same namespace as the Alertmanager object, which shall be mounted into the Alertmanager Pods. The Secrets are mounted into /etc/alertmanager/secrets/<secret-name>.
                pub secrets: Vec<String>,
                /// SecurityContext holds pod-level security attributes and common container settings. This defaults to the default PodSecurityContext.
                pub security_context: SpecSecurityContext,
                /// ServiceAccountName is the name of the ServiceAccount to use to run the Prometheus Pods.
                pub service_account_name: String,
                /// SHA of Alertmanager container image to be deployed. Defaults to the value of `version`. Similar to a tag, but the SHA explicitly deploys an immutable container image. Version and Tag are ignored if SHA is set. Deprecated: use 'image' instead.  The image digest can be specified as part of the image URL.
                pub sha: String,
                /// Storage is the definition of how storage will be used by the Alertmanager instances.
                pub storage: Storage,
                /// Tag of Alertmanager container image to be deployed. Defaults to the value of `version`. Version is ignored if Tag is set. Deprecated: use 'image' instead.  The image tag can be specified as part of the image URL.
                pub tag: String,
                /// If specified, the pod's tolerations.
                pub tolerations: Vec<TolerationsItem>,
                /// If specified, the pod's topology spread constraints.
                pub topology_spread_constraints: Vec<TopologySpreadConstraintsItem>,
                /// Version the cluster should be on.
                pub version: String,
                /// VolumeMounts allows configuration of additional VolumeMounts on the output StatefulSet definition. VolumeMounts specified will be appended to other VolumeMounts in the alertmanager container, that are generated as a result of StorageSpec objects.
                pub volume_mounts: Vec<SpecVolumeMountsItem>,
                /// Volumes allows configuration of additional volumes on the output StatefulSet definition. Volumes specified will be appended to other volumes that are generated as a result of StorageSpec objects.
                pub volumes: Vec<VolumesItem>,
            }

            /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpec {
                /// AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
                pub data_source: StorageEphemeralVolumeClaimTemplateSpecDataSource,
                /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
                pub data_source_ref: StorageEphemeralVolumeClaimTemplateSpecDataSourceRef,
                /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
                pub resources: StorageEphemeralVolumeClaimTemplateSpecResources,
                /// A label query over volumes to consider for binding.
                pub selector: StorageEphemeralVolumeClaimTemplateSpecSelector,
                /// Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
                pub storage_class_name: String,
                /// volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.
                pub volume_mode: String,
                /// VolumeName is the binding reference to the PersistentVolume backing this claim.
                pub volume_name: String,
            }

            /// Spec defines the desired characteristics of a volume requested by a pod author. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpec {
                /// AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
                pub data_source: StorageVolumeClaimTemplateSpecDataSource,
                /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
                pub data_source_ref: StorageVolumeClaimTemplateSpecDataSourceRef,
                /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
                pub resources: StorageVolumeClaimTemplateSpecResources,
                /// A label query over volumes to consider for binding.
                pub selector: StorageVolumeClaimTemplateSpecSelector,
                /// Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
                pub storage_class_name: String,
                /// volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.
                pub volume_mode: String,
                /// VolumeName is the binding reference to the PersistentVolume backing this claim.
                pub volume_name: String,
            }

            /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpec {
                /// AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
                pub data_source: VolumesItemEphemeralVolumeClaimTemplateSpecDataSource,
                /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
                pub data_source_ref: VolumesItemEphemeralVolumeClaimTemplateSpecDataSourceRef,
                /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
                pub resources: VolumesItemEphemeralVolumeClaimTemplateSpecResources,
                /// A label query over volumes to consider for binding.
                pub selector: VolumesItemEphemeralVolumeClaimTemplateSpecSelector,
                /// Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
                pub storage_class_name: String,
                /// volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.
                pub volume_mode: String,
                /// VolumeName is the binding reference to the PersistentVolume backing this claim.
                pub volume_name: String,
            }

            /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbe {
                /// Exec specifies the action to take.
                pub exec: ContainersItemStartupProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: ContainersItemStartupProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemStartupProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: ContainersItemStartupProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbe {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemStartupProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: InitContainersItemStartupProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemStartupProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: InitContainersItemStartupProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Most recent observed status of the Alertmanager cluster. Read-only. Not included when requesting from the apiserver, only from the Prometheus Operator API itself. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Status {
                /// Total number of available pods (ready for at least minReadySeconds) targeted by this Alertmanager cluster.
                pub available_replicas: i32,
                /// Represents whether any actions on the underlying managed objects are being performed. Only delete actions will be performed.
                pub paused: bool,
                /// Total number of non-terminated pods targeted by this Alertmanager cluster (their labels match the selector).
                pub replicas: i32,
                /// Total number of unavailable pods targeted by this Alertmanager cluster.
                pub unavailable_replicas: i32,
                /// Total number of non-terminated pods targeted by this Alertmanager cluster that have the desired version spec.
                pub updated_replicas: i32,
            }

            /// Status represents the current information/status of a persistent volume claim. Read-only. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumeClaimTemplateStatus {
                /// AccessModes contains the actual access modes the volume backing the PVC has. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// The storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
                pub allocated_resources: AllocatedResources,
                /// Represents the actual resources of the underlying volume.
                pub capacity: Capacity,
                /// Current Condition of persistent volume claim. If underlying persistent volume is being resized then the Condition will be set to 'ResizeStarted'.
                pub conditions: Vec<ConditionsItem>,
                /// Phase represents the current phase of PersistentVolumeClaim.
                pub phase: String,
                /// ResizeStatus stores status of resize operation. ResizeStatus is not set by default but when expansion is complete resizeStatus is set to empty string by resize controller or kubelet. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
                pub resize_status: String,
            }

            /// Storage is the definition of how storage will be used by the Alertmanager instances.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Storage {
                /// Deprecated: subPath usage will be disabled by default in a future release, this option will become unnecessary. DisableMountSubPath allows to remove any subPath usage in volume mounts.
                pub disable_mount_sub_path: bool,
                /// EmptyDirVolumeSource to be used by the Prometheus StatefulSets. If specified, used in place of any volumeClaimTemplate. More info: https://kubernetes.io/docs/concepts/storage/volumes/#emptydir
                pub empty_dir: StorageEmptyDir,
                /// EphemeralVolumeSource to be used by the Prometheus StatefulSets. This is a beta field in k8s 1.21, for lower versions, starting with k8s 1.19, it requires enabling the GenericEphemeralVolume feature gate. More info: https://kubernetes.io/docs/concepts/storage/ephemeral-volumes/#generic-ephemeral-volumes
                pub ephemeral: StorageEphemeral,
                /// A PVC spec to be used by the Prometheus StatefulSets.
                pub volume_claim_template: StorageVolumeClaimTemplate,
            }

            /// StorageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Storageos {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.
                pub secret_ref: StorageosSecretRef,
                /// VolumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.
                pub volume_name: String,
                /// VolumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.
                pub volume_namespace: String,
            }

            /// Sysctl defines a kernel parameter to be set
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SysctlsItem {
                /// Name of a property to set
                pub name: String,
                /// Value of a property to set
                pub value: String,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TolerationsItem {
                /// Effect indicates the taint effect to match. Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.
                pub effect: String,
                /// Key is the taint key that the toleration applies to. Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.
                pub key: String,
                /// Operator represents a key's relationship to the value. Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.
                pub operator: String,
                /// TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.
                pub toleration_seconds: i64,
                /// Value is the taint value the toleration matches to. If the operator is Exists, the value should be empty, otherwise just a regular string.
                pub value: String,
            }

            /// TopologySpreadConstraint specifies how to spread matching pods among the given topology.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItem {
                /// LabelSelector is used to find matching pods. Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.
                pub label_selector: TopologySpreadConstraintsItemLabelSelector,
                /// MaxSkew describes the degree to which pods may be unevenly distributed. When `whenUnsatisfiable=DoNotSchedule`, it is the maximum permitted difference between the number of matching pods in the target topology and the global minimum. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 1/1/0: | zone1 | zone2 | zone3 | |   P   |   P   |       | - if MaxSkew is 1, incoming pod can only be scheduled to zone3 to become 1/1/1; scheduling it onto zone1(zone2) would make the ActualSkew(2-0) on zone1(zone2) violate MaxSkew(1). - if MaxSkew is 2, incoming pod can be scheduled onto any zone. When `whenUnsatisfiable=ScheduleAnyway`, it is used to give higher precedence to topologies that satisfy it. It's a required field. Default value is 1 and 0 is not allowed.
                pub max_skew: i32,
                /// TopologyKey is the key of node labels. Nodes that have a label with this key and identical values are considered to be in the same topology. We consider each <key, value> as a "bucket", and try to put balanced number of pods into each bucket. It's a required field.
                pub topology_key: String,
                /// WhenUnsatisfiable indicates how to deal with a pod if it doesn't satisfy the spread constraint. - DoNotSchedule (default) tells the scheduler not to schedule it. - ScheduleAnyway tells the scheduler to schedule the pod in any location, but giving higher precedence to topologies that would help reduce the skew. A constraint is considered "Unsatisfiable" for an incoming pod if and only if every possible node assignment for that pod would violate "MaxSkew" on some topology. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 3/1/1: | zone1 | zone2 | zone3 | | P P P |   P   |   P   | If WhenUnsatisfiable is set to DoNotSchedule, incoming pod can only be scheduled to zone2(zone3) to become 3/2/1(3/1/2) as ActualSkew(2-1) on zone2(zone3) satisfies MaxSkew(1). In other words, the cluster can still be imbalanced, but scheduler won't make it *more* imbalanced. It's a required field.
                pub when_unsatisfiable: String,
            }

            /// Source for the environment variable's value. Cannot be used if value is not empty.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFrom {
                /// Selects a key of a ConfigMap.
                pub config_map_key_ref: ContainersItemEnvItemValueFromConfigMapKeyRef,
                /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
                pub field_ref: ContainersItemEnvItemValueFromFieldRef,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
                pub resource_field_ref: ContainersItemEnvItemValueFromResourceFieldRef,
                /// Selects a key of a secret in the pod's namespace
                pub secret_key_ref: ContainersItemEnvItemValueFromSecretKeyRef,
            }

            /// Source for the environment variable's value. Cannot be used if value is not empty.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFrom {
                /// Selects a key of a ConfigMap.
                pub config_map_key_ref: InitContainersItemEnvItemValueFromConfigMapKeyRef,
                /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
                pub field_ref: InitContainersItemEnvItemValueFromFieldRef,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
                pub resource_field_ref: InitContainersItemEnvItemValueFromResourceFieldRef,
                /// Selects a key of a secret in the pod's namespace
                pub secret_key_ref: InitContainersItemEnvItemValueFromSecretKeyRef,
            }

            /// VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumeAttributes {
                /// VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// A PVC spec to be used by the Prometheus StatefulSets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplate {
                /// APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
                pub api_version: String,
                /// Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
                pub kind: String,
                /// EmbeddedMetadata contains metadata relevant to an EmbeddedResource.
                pub metadata: StorageVolumeClaimTemplateMetadata,
                /// Spec defines the desired characteristics of a volume requested by a pod author. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub spec: StorageVolumeClaimTemplateSpec,
                /// Status represents the current information/status of a persistent volume claim. Read-only. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub status: VolumeClaimTemplateStatus,
            }

            /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
            ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
            ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
            ///  Required, must not be nil.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplate {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub metadata: StorageEphemeralVolumeClaimTemplateMetadata,
                /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
                pub spec: StorageEphemeralVolumeClaimTemplateSpec,
            }

            /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
            ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
            ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
            ///  Required, must not be nil.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplate {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub metadata: VolumesItemEphemeralVolumeClaimTemplateMetadata,
                /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
                pub spec: VolumesItemEphemeralVolumeClaimTemplateSpec,
            }

            /// volumeDevice describes a mapping of a raw block device within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemVolumeDevicesItem {
                /// devicePath is the path inside of the container that the device will be mapped to.
                pub device_path: String,
                /// name must match the name of a persistentVolumeClaim in the pod
                pub name: String,
            }

            /// volumeDevice describes a mapping of a raw block device within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemVolumeDevicesItem {
                /// devicePath is the path inside of the container that the device will be mapped to.
                pub device_path: String,
                /// name must match the name of a persistentVolumeClaim in the pod
                pub name: String,
            }

            /// VolumeMount describes a mounting of a Volume within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecVolumeMountsItem {
                /// Path within the container at which the volume should be mounted.  Must not contain ':'.
                pub mount_path: String,
                /// mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.
                pub mount_propagation: String,
                /// This must match the Name of a Volume.
                pub name: String,
                /// Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.
                pub read_only: bool,
                /// Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).
                pub sub_path: String,
                /// Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.
                pub sub_path_expr: String,
            }

            /// VolumeMount describes a mounting of a Volume within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemVolumeMountsItem {
                /// Path within the container at which the volume should be mounted.  Must not contain ':'.
                pub mount_path: String,
                /// mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.
                pub mount_propagation: String,
                /// This must match the Name of a Volume.
                pub name: String,
                /// Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.
                pub read_only: bool,
                /// Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).
                pub sub_path: String,
                /// Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.
                pub sub_path_expr: String,
            }

            /// VolumeMount describes a mounting of a Volume within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemVolumeMountsItem {
                /// Path within the container at which the volume should be mounted.  Must not contain ':'.
                pub mount_path: String,
                /// mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.
                pub mount_propagation: String,
                /// This must match the Name of a Volume.
                pub name: String,
                /// Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.
                pub read_only: bool,
                /// Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).
                pub sub_path: String,
                /// Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.
                pub sub_path_expr: String,
            }

            /// Volume represents a named volume in a pod that may be accessed by any container in the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItem {
                /// AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
                pub aws_elastic_block_store: AwsElasticBlockStore,
                /// AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.
                pub azure_disk: AzureDisk,
                /// AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
                pub azure_file: AzureFile,
                /// CephFS represents a Ceph FS mount on the host that shares a pod's lifetime
                pub cephfs: Cephfs,
                /// Cinder represents a cinder volume attached and mounted on kubelets host machine. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub cinder: Cinder,
                /// ConfigMap represents a configMap that should populate this volume
                pub config_map: VolumesItemConfigMap,
                /// CSI (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).
                pub csi: Csi,
                /// DownwardAPI represents downward API about the pod that should populate this volume
                pub downward_a_p_i: VolumesItemDownwardAPI,
                /// EmptyDir represents a temporary directory that shares a pod's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
                pub empty_dir: VolumesItemEmptyDir,
                /// Ephemeral represents a volume that is handled by a cluster storage driver. The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts, and deleted when the pod is removed.
                ///  Use this if: a) the volume is only needed while the pod runs, b) features of normal volumes like restoring from snapshot or capacity tracking are needed, c) the storage driver is specified through a storage class, and d) the storage driver supports dynamic volume provisioning through a PersistentVolumeClaim (see EphemeralVolumeSource for more information on the connection between this volume type and PersistentVolumeClaim).
                ///  Use PersistentVolumeClaim or one of the vendor-specific APIs for volumes that persist for longer than the lifecycle of an individual pod.
                ///  Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to be used that way - see the documentation of the driver for more information.
                ///  A pod can use both types of ephemeral volumes and persistent volumes at the same time.
                pub ephemeral: VolumesItemEphemeral,
                /// FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.
                pub fc: Fc,
                /// FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.
                pub flex_volume: FlexVolume,
                /// Flocker represents a Flocker volume attached to a kubelet's host machine. This depends on the Flocker control service being running
                pub flocker: Flocker,
                /// GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub gce_persistent_disk: GcePersistentDisk,
                /// GitRepo represents a git repository at a particular revision. DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.
                pub git_repo: GitRepo,
                /// Glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/glusterfs/README.md
                pub glusterfs: Glusterfs,
                /// HostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath --- TODO(jonesdl) We need to restrict who can use host directory mounts and who can/can not mount host directories as read/write.
                pub host_path: HostPath,
                /// ISCSI represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://examples.k8s.io/volumes/iscsi/README.md
                pub iscsi: Iscsi,
                /// Volume's name. Must be a DNS_LABEL and unique within the pod. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
                pub name: String,
                /// NFS represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub nfs: Nfs,
                /// PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub persistent_volume_claim: PersistentVolumeClaim,
                /// PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine
                pub photon_persistent_disk: PhotonPersistentDisk,
                /// PortworxVolume represents a portworx volume attached and mounted on kubelets host machine
                pub portworx_volume: PortworxVolume,
                /// Items for all in one resources secrets, configmaps, and downward API
                pub projected: Projected,
                /// Quobyte represents a Quobyte mount on the host that shares a pod's lifetime
                pub quobyte: Quobyte,
                /// RBD represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/rbd/README.md
                pub rbd: Rbd,
                /// ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.
                pub scale_i_o: ScaleIO,
                /// Secret represents a secret that should populate this volume. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
                pub secret: VolumesItemSecret,
                /// StorageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.
                pub storageos: Storageos,
                /// VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine
                pub vsphere_volume: VsphereVolume,
            }

            /// VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VsphereVolume {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.
                pub storage_policy_i_d: String,
                /// Storage Policy Based Management (SPBM) profile name.
                pub storage_policy_name: String,
                /// Path that identifies vSphere volume vmdk
                pub volume_path: String,
            }

            /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextWindowsOptions {
                /// GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.
                pub gmsa_credential_spec: String,
                /// GMSACredentialSpecName is the name of the GMSA credential spec to use.
                pub gmsa_credential_spec_name: String,
                /// HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.
                pub host_process: bool,
                /// The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_user_name: String,
            }

            /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextWindowsOptions {
                /// GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.
                pub gmsa_credential_spec: String,
                /// GMSACredentialSpecName is the name of the GMSA credential spec to use.
                pub gmsa_credential_spec_name: String,
                /// HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.
                pub host_process: bool,
                /// The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_user_name: String,
            }

            /// The Windows specific settings applied to all containers. If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContextWindowsOptions {
                /// GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.
                pub gmsa_credential_spec: String,
                /// GMSACredentialSpecName is the name of the GMSA credential spec to use.
                pub gmsa_credential_spec_name: String,
                /// HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.
                pub host_process: bool,
                /// The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_user_name: String,
            }
        }
        pub mod pod_monitor {
            /// PodMonitor defines monitoring for a set of pods.
            #[derive(serde::Deserialize, Debug, PartialEq)]
            pub struct PodMonitor {
                pub metadata: k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta,
                pub spec: Spec,
            }

            impl k8s_openapi::Resource for PodMonitor {
                type Scope = k8s_openapi::ClusterResourceScope;

                const API_VERSION: &'static str = "monitoring.coreos.com/v1";
                const GROUP: &'static str = "monitoring.coreos.com";
                const KIND: &'static str = "PodMonitor";
                const VERSION: &'static str = "v1";
                const URL_PATH_SEGMENT: &'static str = "";
            }

            impl k8s_openapi::Metadata for PodMonitor {
                type Ty = k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta;

                fn metadata(&self) -> &<Self as k8s_openapi::Metadata>::Ty {
                    &self.metadata
                }

                fn metadata_mut(&mut self) -> &mut <Self as k8s_openapi::Metadata>::Ty {
                    &mut self.metadata
                }
            }

            impl serde::Serialize for PodMonitor {
                fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
                where
                    S: serde::Serializer,
                {
                    use serde::ser::SerializeStruct;
                    let mut state = serializer.serialize_struct("PodMonitor", 4)?;
                    state.serialize_field(
                        "apiVersion",
                        <Self as k8s_openapi::Resource>::API_VERSION,
                    )?;
                    state.serialize_field("kind", <Self as k8s_openapi::Resource>::KIND)?;
                    state.serialize_field("metadata", &self.metadata)?;
                    state.serialize_field("spec", &self.spec)?;
                    state.end()
                }
            }

            /// Attaches node metadata to discovered targets. Only valid for role: pod. Only valid in Prometheus versions 2.35.0 and newer.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AttachMetadata {
                /// When set to true, Prometheus must have permissions to get Nodes.
                pub node: bool,
            }

            /// Authorization section for this endpoint
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Authorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: Credentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// BasicAuth allow an endpoint to authenticate over basic authentication. More info: https://prometheus.io/docs/operating/configuration/#endpoint
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct BasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: Password,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: Username,
            }

            /// Secret to mount to read bearer token for scraping targets. The secret needs to be in the same namespace as the pod monitor and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct BearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Ca {
                /// ConfigMap containing data to use for the targets.
                pub config_map: CaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: CaSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: CertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: CertSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: ClientIdSecret,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Credentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct KeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// RelabelConfig allows dynamic rewriting of the label set, being applied to samples before ingestion. It defines `<metric_relabel_configs>`-section of Prometheus configuration. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#metric_relabel_configs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetricRelabelingsItem {
                /// Action to perform based on regex matching. Default is 'replace'
                pub action: String,
                /// Modulus to take of the hash of the source label values.
                pub modulus: i64,
                /// Regular expression against which the extracted value is matched. Default is '(.*)'
                pub regex: String,
                /// Replacement value against which a regex replace is performed if the regular expression matches. Regex capture groups are available. Default is '$1'
                pub replacement: String,
                /// Separator placed between concatenated source label values. default is ';'.
                pub separator: String,
                /// The source labels select values from existing labels. Their content is concatenated using the configured separator and matched against the configured regular expression for the replace, keep, and drop actions.
                pub source_labels: Vec<String>,
                /// Label to which the resulting value is written in a replace action. It is mandatory for replace actions. Regex capture groups are available.
                pub target_label: String,
            }

            /// Selector to select which namespaces the Endpoints objects are discovered from.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NamespaceSelector {
                /// Boolean describing whether all namespaces are selected in contrast to a list restricting them.
                pub any: bool,
                /// List of namespace names to select from.
                pub match_names: Vec<String>,
            }

            /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Oauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// Optional HTTP URL parameters
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Params {
                /// Optional HTTP URL parameters
                pub properties: std::collections::HashMap<String, Vec<String>>,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Password {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// PodMetricsEndpoint defines a scrapeable endpoint of a Kubernetes Pod serving Prometheus metrics.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetricsEndpointsItem {
                /// Authorization section for this endpoint
                pub authorization: Authorization,
                /// BasicAuth allow an endpoint to authenticate over basic authentication. More info: https://prometheus.io/docs/operating/configuration/#endpoint
                pub basic_auth: BasicAuth,
                /// Secret to mount to read bearer token for scraping targets. The secret needs to be in the same namespace as the pod monitor and accessible by the Prometheus Operator.
                pub bearer_token_secret: BearerTokenSecret,
                /// FollowRedirects configures whether scrape requests follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// HonorLabels chooses the metric's labels on collisions with target labels.
                pub honor_labels: bool,
                /// HonorTimestamps controls whether Prometheus respects the timestamps present in scraped data.
                pub honor_timestamps: bool,
                /// Interval at which metrics should be scraped If not specified Prometheus' global scrape interval is used.
                pub interval: String,
                /// MetricRelabelConfigs to apply to samples before ingestion.
                pub metric_relabelings: Vec<MetricRelabelingsItem>,
                /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
                pub oauth2: Oauth2,
                /// Optional HTTP URL parameters
                pub params: Params,
                /// HTTP path to scrape for metrics.
                pub path: String,
                /// Name of the pod port this endpoint refers to. Mutually exclusive with targetPort.
                pub port: String,
                /// ProxyURL eg http://proxyserver:2195 Directs scrapes to proxy through this endpoint.
                pub proxy_url: String,
                /// RelabelConfigs to apply to samples before scraping. Prometheus Operator automatically adds relabelings for a few standard Kubernetes fields. The original scrape job's name is available via the `__tmp_prometheus_job_name` label. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#relabel_config
                pub relabelings: Vec<RelabelingsItem>,
                /// HTTP scheme to use for scraping.
                pub scheme: String,
                /// Timeout after which the scrape is ended If not specified, the Prometheus global scrape interval is used.
                pub scrape_timeout: String,
                /// Deprecated: Use 'port' instead.
                pub target_port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// TLS configuration to use when scraping the endpoint.
                pub tls_config: TlsConfig,
            }

            /// RelabelConfig allows dynamic rewriting of the label set, being applied to samples before ingestion. It defines `<metric_relabel_configs>`-section of Prometheus configuration. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#metric_relabel_configs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RelabelingsItem {
                /// Action to perform based on regex matching. Default is 'replace'
                pub action: String,
                /// Modulus to take of the hash of the source label values.
                pub modulus: i64,
                /// Regular expression against which the extracted value is matched. Default is '(.*)'
                pub regex: String,
                /// Replacement value against which a regex replace is performed if the regular expression matches. Regex capture groups are available. Default is '$1'
                pub replacement: String,
                /// Separator placed between concatenated source label values. default is ';'.
                pub separator: String,
                /// The source labels select values from existing labels. Their content is concatenated using the configured separator and matched against the configured regular expression for the replace, keep, and drop actions.
                pub source_labels: Vec<String>,
                /// Label to which the resulting value is written in a replace action. It is mandatory for replace actions. Regex capture groups are available.
                pub target_label: String,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Selector to select Pod objects.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Selector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<MatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: MatchLabels,
            }

            /// Specification of desired Pod selection for target discovery by Prometheus.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Spec {
                /// Attaches node metadata to discovered targets. Only valid for role: pod. Only valid in Prometheus versions 2.35.0 and newer.
                pub attach_metadata: AttachMetadata,
                /// The label to use to retrieve the job name from.
                pub job_label: String,
                /// Per-scrape limit on number of labels that will be accepted for a sample. Only valid in Prometheus versions 2.27.0 and newer.
                pub label_limit: i64,
                /// Per-scrape limit on length of labels name that will be accepted for a sample. Only valid in Prometheus versions 2.27.0 and newer.
                pub label_name_length_limit: i64,
                /// Per-scrape limit on length of labels value that will be accepted for a sample. Only valid in Prometheus versions 2.27.0 and newer.
                pub label_value_length_limit: i64,
                /// Selector to select which namespaces the Endpoints objects are discovered from.
                pub namespace_selector: NamespaceSelector,
                /// A list of endpoints allowed as part of this PodMonitor.
                pub pod_metrics_endpoints: Vec<PodMetricsEndpointsItem>,
                /// PodTargetLabels transfers labels on the Kubernetes Pod onto the target.
                pub pod_target_labels: Vec<String>,
                /// SampleLimit defines per-scrape limit on number of scraped samples that will be accepted.
                pub sample_limit: i64,
                /// Selector to select Pod objects.
                pub selector: Selector,
                /// TargetLimit defines a limit on the number of scraped targets that will be accepted.
                pub target_limit: i64,
            }

            /// TLS configuration to use when scraping the endpoint.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: Ca,
                /// Struct containing the client cert file for the targets.
                pub cert: Cert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: KeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Username {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }
        }
        pub mod probe {
            /// Probe defines monitoring for a set of static targets or ingresses.
            #[derive(serde::Deserialize, Debug, PartialEq)]
            pub struct Probe {
                pub metadata: k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta,
                pub spec: Spec,
            }

            impl k8s_openapi::Resource for Probe {
                type Scope = k8s_openapi::ClusterResourceScope;

                const API_VERSION: &'static str = "monitoring.coreos.com/v1";
                const GROUP: &'static str = "monitoring.coreos.com";
                const KIND: &'static str = "Probe";
                const VERSION: &'static str = "v1";
                const URL_PATH_SEGMENT: &'static str = "";
            }

            impl k8s_openapi::Metadata for Probe {
                type Ty = k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta;

                fn metadata(&self) -> &<Self as k8s_openapi::Metadata>::Ty {
                    &self.metadata
                }

                fn metadata_mut(&mut self) -> &mut <Self as k8s_openapi::Metadata>::Ty {
                    &mut self.metadata
                }
            }

            impl serde::Serialize for Probe {
                fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
                where
                    S: serde::Serializer,
                {
                    use serde::ser::SerializeStruct;
                    let mut state = serializer.serialize_struct("Probe", 4)?;
                    state.serialize_field(
                        "apiVersion",
                        <Self as k8s_openapi::Resource>::API_VERSION,
                    )?;
                    state.serialize_field("kind", <Self as k8s_openapi::Resource>::KIND)?;
                    state.serialize_field("metadata", &self.metadata)?;
                    state.serialize_field("spec", &self.spec)?;
                    state.end()
                }
            }

            /// Authorization section for this endpoint
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Authorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: Credentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// BasicAuth allow an endpoint to authenticate over basic authentication. More info: https://prometheus.io/docs/operating/configuration/#endpoint
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct BasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: Password,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: Username,
            }

            /// Secret to mount to read bearer token for scraping targets. The secret needs to be in the same namespace as the probe and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct BearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Ca {
                /// ConfigMap containing data to use for the targets.
                pub config_map: CaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: CaSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: CertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: CertSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: ClientIdSecret,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Credentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// ingress defines the Ingress objects to probe and the relabeling configuration. If `staticConfig` is also defined, `staticConfig` takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Ingress {
                /// From which namespaces to select Ingress objects.
                pub namespace_selector: NamespaceSelector,
                /// RelabelConfigs to apply to the label set of the target before it gets scraped. The original ingress address is available via the `__tmp_prometheus_ingress_address` label. It can be used to customize the probed URL. The original scrape job's name is available via the `__tmp_prometheus_job_name` label. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#relabel_config
                pub relabeling_configs: Vec<IngressRelabelingConfigsItem>,
                /// Selector to select the Ingress objects.
                pub selector: Selector,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct KeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Labels assigned to all metrics scraped from the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Labels {
                /// Labels assigned to all metrics scraped from the targets.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// RelabelConfig allows dynamic rewriting of the label set, being applied to samples before ingestion. It defines `<metric_relabel_configs>`-section of Prometheus configuration. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#metric_relabel_configs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetricRelabelingsItem {
                /// Action to perform based on regex matching. Default is 'replace'
                pub action: String,
                /// Modulus to take of the hash of the source label values.
                pub modulus: i64,
                /// Regular expression against which the extracted value is matched. Default is '(.*)'
                pub regex: String,
                /// Replacement value against which a regex replace is performed if the regular expression matches. Regex capture groups are available. Default is '$1'
                pub replacement: String,
                /// Separator placed between concatenated source label values. default is ';'.
                pub separator: String,
                /// The source labels select values from existing labels. Their content is concatenated using the configured separator and matched against the configured regular expression for the replace, keep, and drop actions.
                pub source_labels: Vec<String>,
                /// Label to which the resulting value is written in a replace action. It is mandatory for replace actions. Regex capture groups are available.
                pub target_label: String,
            }

            /// From which namespaces to select Ingress objects.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NamespaceSelector {
                /// Boolean describing whether all namespaces are selected in contrast to a list restricting them.
                pub any: bool,
                /// List of namespace names to select from.
                pub match_names: Vec<String>,
            }

            /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Oauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Password {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Specification for the prober to use for probing targets. The prober.URL parameter is required. Targets cannot be probed if left empty.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Prober {
                /// Path to collect metrics from. Defaults to `/probe`.
                pub path: String,
                /// Optional ProxyURL.
                pub proxy_url: String,
                /// HTTP scheme to use for scraping. Defaults to `http`.
                pub scheme: String,
                /// Mandatory URL of the prober.
                pub url: String,
            }

            /// RelabelConfig allows dynamic rewriting of the label set, being applied to samples before ingestion. It defines `<metric_relabel_configs>`-section of Prometheus configuration. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#metric_relabel_configs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct IngressRelabelingConfigsItem {
                /// Action to perform based on regex matching. Default is 'replace'
                pub action: String,
                /// Modulus to take of the hash of the source label values.
                pub modulus: i64,
                /// Regular expression against which the extracted value is matched. Default is '(.*)'
                pub regex: String,
                /// Replacement value against which a regex replace is performed if the regular expression matches. Regex capture groups are available. Default is '$1'
                pub replacement: String,
                /// Separator placed between concatenated source label values. default is ';'.
                pub separator: String,
                /// The source labels select values from existing labels. Their content is concatenated using the configured separator and matched against the configured regular expression for the replace, keep, and drop actions.
                pub source_labels: Vec<String>,
                /// Label to which the resulting value is written in a replace action. It is mandatory for replace actions. Regex capture groups are available.
                pub target_label: String,
            }

            /// RelabelConfig allows dynamic rewriting of the label set, being applied to samples before ingestion. It defines `<metric_relabel_configs>`-section of Prometheus configuration. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#metric_relabel_configs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StaticConfigRelabelingConfigsItem {
                /// Action to perform based on regex matching. Default is 'replace'
                pub action: String,
                /// Modulus to take of the hash of the source label values.
                pub modulus: i64,
                /// Regular expression against which the extracted value is matched. Default is '(.*)'
                pub regex: String,
                /// Replacement value against which a regex replace is performed if the regular expression matches. Regex capture groups are available. Default is '$1'
                pub replacement: String,
                /// Separator placed between concatenated source label values. default is ';'.
                pub separator: String,
                /// The source labels select values from existing labels. Their content is concatenated using the configured separator and matched against the configured regular expression for the replace, keep, and drop actions.
                pub source_labels: Vec<String>,
                /// Label to which the resulting value is written in a replace action. It is mandatory for replace actions. Regex capture groups are available.
                pub target_label: String,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Selector to select the Ingress objects.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Selector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<MatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: MatchLabels,
            }

            /// Specification of desired Ingress selection for target discovery by Prometheus.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Spec {
                /// Authorization section for this endpoint
                pub authorization: Authorization,
                /// BasicAuth allow an endpoint to authenticate over basic authentication. More info: https://prometheus.io/docs/operating/configuration/#endpoint
                pub basic_auth: BasicAuth,
                /// Secret to mount to read bearer token for scraping targets. The secret needs to be in the same namespace as the probe and accessible by the Prometheus Operator.
                pub bearer_token_secret: BearerTokenSecret,
                /// Interval at which targets are probed using the configured prober. If not specified Prometheus' global scrape interval is used.
                pub interval: String,
                /// The job name assigned to scraped metrics by default.
                pub job_name: String,
                /// Per-scrape limit on number of labels that will be accepted for a sample. Only valid in Prometheus versions 2.27.0 and newer.
                pub label_limit: i64,
                /// Per-scrape limit on length of labels name that will be accepted for a sample. Only valid in Prometheus versions 2.27.0 and newer.
                pub label_name_length_limit: i64,
                /// Per-scrape limit on length of labels value that will be accepted for a sample. Only valid in Prometheus versions 2.27.0 and newer.
                pub label_value_length_limit: i64,
                /// MetricRelabelConfigs to apply to samples before ingestion.
                pub metric_relabelings: Vec<MetricRelabelingsItem>,
                /// The module to use for probing specifying how to probe the target. Example module configuring in the blackbox exporter: https://github.com/prometheus/blackbox_exporter/blob/master/example.yml
                pub module: String,
                /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
                pub oauth2: Oauth2,
                /// Specification for the prober to use for probing targets. The prober.URL parameter is required. Targets cannot be probed if left empty.
                pub prober: Prober,
                /// SampleLimit defines per-scrape limit on number of scraped samples that will be accepted.
                pub sample_limit: i64,
                /// Timeout for scraping metrics from the Prometheus exporter. If not specified, the Prometheus global scrape interval is used.
                pub scrape_timeout: String,
                /// TargetLimit defines a limit on the number of scraped targets that will be accepted.
                pub target_limit: i64,
                /// Targets defines a set of static or dynamically discovered targets to probe.
                pub targets: Targets,
                /// TLS configuration to use when scraping the endpoint.
                pub tls_config: TlsConfig,
            }

            /// staticConfig defines the static list of targets to probe and the relabeling configuration. If `ingress` is also defined, `staticConfig` takes precedence. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#static_config.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StaticConfig {
                /// Labels assigned to all metrics scraped from the targets.
                pub labels: Labels,
                /// RelabelConfigs to apply to the label set of the targets before it gets scraped. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#relabel_config
                pub relabeling_configs: Vec<StaticConfigRelabelingConfigsItem>,
                /// The list of hosts to probe.
                pub r#static: Vec<String>,
            }

            /// Targets defines a set of static or dynamically discovered targets to probe.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Targets {
                /// ingress defines the Ingress objects to probe and the relabeling configuration. If `staticConfig` is also defined, `staticConfig` takes precedence.
                pub ingress: Ingress,
                /// staticConfig defines the static list of targets to probe and the relabeling configuration. If `ingress` is also defined, `staticConfig` takes precedence. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#static_config.
                pub static_config: StaticConfig,
            }

            /// TLS configuration to use when scraping the endpoint.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: Ca,
                /// Struct containing the client cert file for the targets.
                pub cert: Cert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: KeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Username {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }
        }
        pub mod prometheus {
            /// Prometheus defines a Prometheus deployment.
            #[derive(serde::Deserialize, Debug, PartialEq)]
            pub struct Prometheus {
                pub metadata: k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta,
                pub spec: Spec,
                pub status: Status,
            }

            impl k8s_openapi::Resource for Prometheus {
                type Scope = k8s_openapi::ClusterResourceScope;

                const API_VERSION: &'static str = "monitoring.coreos.com/v1";
                const GROUP: &'static str = "monitoring.coreos.com";
                const KIND: &'static str = "Prometheus";
                const VERSION: &'static str = "v1";
                const URL_PATH_SEGMENT: &'static str = "";
            }

            impl k8s_openapi::Metadata for Prometheus {
                type Ty = k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta;

                fn metadata(&self) -> &<Self as k8s_openapi::Metadata>::Ty {
                    &self.metadata
                }

                fn metadata_mut(&mut self) -> &mut <Self as k8s_openapi::Metadata>::Ty {
                    &mut self.metadata
                }
            }

            impl serde::Serialize for Prometheus {
                fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
                where
                    S: serde::Serializer,
                {
                    use serde::ser::SerializeStruct;
                    let mut state = serializer.serialize_struct("Prometheus", 5)?;
                    state.serialize_field(
                        "apiVersion",
                        <Self as k8s_openapi::Resource>::API_VERSION,
                    )?;
                    state.serialize_field("kind", <Self as k8s_openapi::Resource>::KIND)?;
                    state.serialize_field("metadata", &self.metadata)?;
                    state.serialize_field("spec", &self.spec)?;
                    state.serialize_field("status", &self.status)?;
                    state.end()
                }
            }

            /// AccessKey is the AWS API key. If blank, the environment variable `AWS_ACCESS_KEY_ID` is used.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AccessKey {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// AdditionalAlertManagerConfigs allows specifying a key of a Secret containing additional Prometheus AlertManager configurations. AlertManager configurations specified are appended to the configurations generated by the Prometheus Operator. Job configurations specified must have the form as specified in the official Prometheus documentation: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#alertmanager_config. As AlertManager configs are appended, the user is responsible to make sure it is valid. Note that using this feature may expose the possibility to break upgrades of Prometheus. It is advised to review Prometheus release notes to ensure that no incompatible AlertManager configs are going to break Prometheus after the upgrade.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AdditionalAlertManagerConfigs {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// AdditionalAlertRelabelConfigs allows specifying a key of a Secret containing additional Prometheus alert relabel configurations. Alert relabel configurations specified are appended to the configurations generated by the Prometheus Operator. Alert relabel configurations specified must have the form as specified in the official Prometheus documentation: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#alert_relabel_configs. As alert relabel configs are appended, the user is responsible to make sure it is valid. Note that using this feature may expose the possibility to break upgrades of Prometheus. It is advised to review Prometheus release notes to ensure that no incompatible alert relabel configs are going to break Prometheus after the upgrade.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AdditionalAlertRelabelConfigs {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// AdditionalScrapeConfigs allows specifying a key of a Secret containing additional Prometheus scrape configurations. Scrape configurations specified are appended to the configurations generated by the Prometheus Operator. Job configurations specified must have the form as specified in the official Prometheus documentation: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#scrape_config. As scrape configs are appended, the user is responsible to make sure it is valid. Note that using this feature may expose the possibility to break upgrades of Prometheus. It is advised to review Prometheus release notes to ensure that no incompatible scrape configs are going to break Prometheus after the upgrade.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AdditionalScrapeConfigs {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// If specified, the pod's scheduling constraints.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Affinity {
                /// Describes node affinity scheduling rules for the pod.
                pub node_affinity: NodeAffinity,
                /// Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).
                pub pod_affinity: PodAffinity,
                /// Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).
                pub pod_anti_affinity: PodAntiAffinity,
            }

            /// /--rules.alert.*/ command-line arguments
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Alert {
                /// Minimum duration between alert and restored 'for' state. This is maintained only for alerts with configured 'for' time greater than grace period.
                pub for_grace_period: String,
                /// Max time to tolerate prometheus outage for restoring 'for' state of alert.
                pub for_outage_tolerance: String,
                /// Minimum amount of time to wait before resending an alert to Alertmanager.
                pub resend_delay: String,
            }

            /// Define details regarding alerting.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Alerting {
                /// AlertmanagerEndpoints Prometheus should fire alerts against.
                pub alertmanagers: Vec<AlertmanagersItem>,
            }

            /// AlertmanagerEndpoints defines a selection of a single Endpoints object containing alertmanager IPs to fire alerts against.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItem {
                /// Version of the Alertmanager API that Prometheus uses to send alerts. It can be "v1" or "v2".
                pub api_version: String,
                /// Authorization section for this alertmanager endpoint
                pub authorization: AlertmanagersItemAuthorization,
                /// BearerTokenFile to read from filesystem to use when authenticating to Alertmanager.
                pub bearer_token_file: String,
                /// Name of Endpoints object in Namespace.
                pub name: String,
                /// Namespace of Endpoints object.
                pub namespace: String,
                /// Prefix for the HTTP path alerts are pushed to.
                pub path_prefix: String,
                /// Port the Alertmanager API is exposed on.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use when firing alerts.
                pub scheme: String,
                /// Timeout is a per-target Alertmanager timeout when pushing alerts.
                pub timeout: String,
                /// TLS Config to use for alertmanager connection.
                pub tls_config: AlertmanagersItemTlsConfig,
            }

            /// The storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AllocatedResources {
                /// The storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetadataAnnotations {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetadataAnnotations {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub properties: std::collections::HashMap<String, String>,
            }

            /// APIServerConfig allows specifying a host and auth methods to access apiserver. If left empty, Prometheus is assumed to run inside of the cluster and will discover API servers automatically and use the pod's CA certificate and bearer token file at /var/run/secrets/kubernetes.io/serviceaccount/.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfig {
                /// Authorization section for accessing apiserver
                pub authorization: ApiserverConfigAuthorization,
                /// BasicAuth allow an endpoint to authenticate over basic authentication
                pub basic_auth: ApiserverConfigBasicAuth,
                /// Bearer token for accessing apiserver.
                pub bearer_token: String,
                /// File to read bearer token for accessing apiserver.
                pub bearer_token_file: String,
                /// Host of apiserver. A valid string consisting of a hostname or IP followed by an optional port number
                pub host: String,
                /// TLS Config to use for accessing apiserver.
                pub tls_config: ApiserverConfigTlsConfig,
            }

            /// ArbitraryFSAccessThroughSMs configures whether configuration based on a service monitor can access arbitrary files on the file system of the Prometheus container e.g. bearer token files.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ArbitraryFSAccessThroughSMs {
                pub deny: bool,
            }

            /// Authorization section for this alertmanager endpoint
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: AlertmanagersItemAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization section for accessing apiserver
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: ApiserverConfigAuthorizationCredentials,
                /// File to read a secret from, mutually exclusive with Credentials (from SafeAuthorization)
                pub credentials_file: String,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization section for remote read
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: RemoteReadItemAuthorizationCredentials,
                /// File to read a secret from, mutually exclusive with Credentials (from SafeAuthorization)
                pub credentials_file: String,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization section for remote write
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: RemoteWriteItemAuthorizationCredentials,
                /// File to read a secret from, mutually exclusive with Credentials (from SafeAuthorization)
                pub credentials_file: String,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AwsElasticBlockStore {
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).
                pub partition: i32,
                /// Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". If omitted, the default is "false". More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
                pub read_only: bool,
                /// Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
                pub volume_i_d: String,
            }

            /// AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AzureDisk {
                /// Host Caching mode: None, Read Only, Read Write.
                pub caching_mode: String,
                /// The Name of the data disk in the blob storage
                pub disk_name: String,
                /// The URI the data disk in the blob storage
                pub disk_u_r_i: String,
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Expected values Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set). defaults to shared
                pub kind: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
            }

            /// AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AzureFile {
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// the name of secret that contains Azure Storage Account Name and Key
                pub secret_name: String,
                /// Share Name
                pub share_name: String,
            }

            /// BasicAuth allow an endpoint to authenticate over basic authentication
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: ApiserverConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: ApiserverConfigBasicAuthUsername,
            }

            /// BasicAuth for the URL.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: RemoteReadItemBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: RemoteReadItemBasicAuthUsername,
            }

            /// BasicAuth for the URL.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: RemoteWriteItemBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: RemoteWriteItemBasicAuthUsername,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: AlertmanagersItemTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: AlertmanagersItemTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: ApiserverConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: ApiserverConfigTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: RemoteReadItemTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: RemoteReadItemTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: RemoteWriteItemTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: RemoteWriteItemTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GrpcServerTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: GrpcServerTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: GrpcServerTlsConfigCaSecret,
            }

            /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextCapabilities {
                /// Added capabilities
                pub add: Vec<String>,
                /// Removed capabilities
                pub drop: Vec<String>,
            }

            /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextCapabilities {
                /// Added capabilities
                pub add: Vec<String>,
                /// Removed capabilities
                pub drop: Vec<String>,
            }

            /// Represents the actual resources of the underlying volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Capacity {
                /// Represents the actual resources of the underlying volume.
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// CephFS represents a Ceph FS mount on the host that shares a pod's lifetime
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cephfs {
                /// Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub monitors: Vec<String>,
                /// Optional: Used as the mounted root, rather than the full Ceph tree, default is /
                pub path: String,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub read_only: bool,
                /// Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub secret_file: String,
                /// Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub secret_ref: CephfsSecretRef,
                /// Optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub user: String,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: AlertmanagersItemTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: AlertmanagersItemTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: ApiserverConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: ApiserverConfigTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: RemoteReadItemTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: RemoteReadItemTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: RemoteWriteItemTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: RemoteWriteItemTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GrpcServerTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: GrpcServerTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: GrpcServerTlsConfigCertSecret,
            }

            /// Contains the TLS certificate for the server.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: WebTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: WebTlsConfigCertSecret,
            }

            /// Cinder represents a cinder volume attached and mounted on kubelets host machine. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cinder {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub fs_type: String,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub read_only: bool,
                /// Optional: points to a secret object containing parameters used to connect to OpenStack.
                pub secret_ref: CinderSecretRef,
                /// volume id used to identify the volume in cinder. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub volume_i_d: String,
            }

            /// Contains the CA certificate for client certificate authentication to the server.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: ClientCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: ClientCaSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: RemoteReadItemOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: RemoteReadItemOauth2ClientIdSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: RemoteWriteItemOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: RemoteWriteItemOauth2ClientIdSecret,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// PersistentVolumeClaimCondition contails details about state of pvc
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumeClaimTemplateStatusConditionsItem {
                /// Last time we probed the condition.
                pub last_probe_time: String,
                /// Last time the condition transitioned from one status to another.
                pub last_transition_time: String,
                /// Human-readable message indicating details about last transition.
                pub message: String,
                /// Unique, this should be a short, machine understandable string that gives the reason for condition's last transition. If it reports "ResizeStarted" that means the underlying persistent volume is being resized.
                pub reason: String,
                pub status: String,
                /// PersistentVolumeClaimConditionType is a valid value of PersistentVolumeClaimCondition.Type
                pub r#type: String,
            }

            /// PrometheusCondition represents the state of the resources associated with the Prometheus resource.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StatusConditionsItem {
                /// lastTransitionTime is the time of the last update to the current status property.
                pub last_transition_time: String,
                /// Human-readable message indicating details for the condition's last transition.
                pub message: String,
                /// Reason for the condition's last transition.
                pub reason: String,
                /// status of the condition.
                pub status: String,
                /// Type of the condition being reported.
                pub r#type: String,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GrpcServerTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GrpcServerTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap represents a configMap that should populate this volume
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemConfigMap {
                /// Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<VolumesItemConfigMapItemsItem>,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its keys must be defined
                pub optional: bool,
            }

            /// information about the configMap data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemConfigMap {
                /// If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<SourcesItemConfigMapItemsItem>,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its keys must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a ConfigMap.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromConfigMapKeyRef {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a ConfigMap.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromConfigMapKeyRef {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// The ConfigMap to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvFromItemConfigMapRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap must be defined
                pub optional: bool,
            }

            /// The ConfigMap to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvFromItemConfigMapRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap must be defined
                pub optional: bool,
            }

            /// A single application container that you want to run within a pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItem {
                /// Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub args: Vec<String>,
                /// Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub command: Vec<String>,
                /// List of environment variables to set in the container. Cannot be updated.
                pub env: Vec<ContainersItemEnvItem>,
                /// List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.
                pub env_from: Vec<ContainersItemEnvFromItem>,
                /// Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.
                pub image: String,
                /// Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images
                pub image_pull_policy: String,
                /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
                pub lifecycle: ContainersItemLifecycle,
                /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub liveness_probe: ContainersItemLivenessProbe,
                /// Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.
                pub name: String,
                /// List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Cannot be updated.
                pub ports: Vec<ContainersItemPortsItem>,
                /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub readiness_probe: ContainersItemReadinessProbe,
                /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub resources: ContainersItemResources,
                /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
                pub security_context: ContainersItemSecurityContext,
                /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub startup_probe: ContainersItemStartupProbe,
                /// Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.
                pub stdin: bool,
                /// Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false
                pub stdin_once: bool,
                /// Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.
                pub termination_message_path: String,
                /// Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.
                pub termination_message_policy: String,
                /// Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.
                pub tty: bool,
                /// volumeDevices is the list of block devices to be used by the container.
                pub volume_devices: Vec<ContainersItemVolumeDevicesItem>,
                /// Pod volumes to mount into the container's filesystem. Cannot be updated.
                pub volume_mounts: Vec<ContainersItemVolumeMountsItem>,
                /// Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.
                pub working_dir: String,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// CSI (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Csi {
                /// Driver is the name of the CSI driver that handles this volume. Consult with your admin for the correct name as registered in the cluster.
                pub driver: String,
                /// Filesystem type to mount. Ex. "ext4", "xfs", "ntfs". If not provided, the empty value is passed to the associated CSI driver which will determine the default filesystem to apply.
                pub fs_type: String,
                /// NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.
                pub node_publish_secret_ref: NodePublishSecretRef,
                /// Specifies a read-only configuration for the volume. Defaults to false (read/write).
                pub read_only: bool,
                /// VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
                pub volume_attributes: VolumeAttributes,
            }

            /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecDataSource {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecDataSource {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecDataSource {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecDataSourceRef {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecDataSourceRef {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecDataSourceRef {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// DownwardAPI represents downward API about the pod that should populate this volume
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPI {
                /// Optional: mode bits to use on created files by default. Must be a Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// Items is a list of downward API volume file
                pub items: Vec<VolumesItemDownwardAPIItemsItem>,
            }

            /// information about the downwardAPI data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPI {
                /// Items is a list of DownwardAPIVolume file
                pub items: Vec<SourcesItemDownwardAPIItemsItem>,
            }

            /// EmptyDirVolumeSource to be used by the Prometheus StatefulSets. If specified, used in place of any volumeClaimTemplate. More info: https://kubernetes.io/docs/concepts/storage/volumes/#emptydir
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEmptyDir {
                /// What type of storage medium should back this directory. The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
                pub medium: String,
                /// Total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir
                pub size_limit: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// EmptyDir represents a temporary directory that shares a pod's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEmptyDir {
                /// What type of storage medium should back this directory. The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
                pub medium: String,
                /// Total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir
                pub size_limit: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// EnvFromSource represents the source of a set of ConfigMaps
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvFromItem {
                /// The ConfigMap to select from
                pub config_map_ref: ContainersItemEnvFromItemConfigMapRef,
                /// An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.
                pub prefix: String,
                /// The Secret to select from
                pub secret_ref: ContainersItemEnvFromItemSecretRef,
            }

            /// EnvFromSource represents the source of a set of ConfigMaps
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvFromItem {
                /// The ConfigMap to select from
                pub config_map_ref: InitContainersItemEnvFromItemConfigMapRef,
                /// An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.
                pub prefix: String,
                /// The Secret to select from
                pub secret_ref: InitContainersItemEnvFromItemSecretRef,
            }

            /// EnvVar represents an environment variable present in a Container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItem {
                /// Name of the environment variable. Must be a C_IDENTIFIER.
                pub name: String,
                /// Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "".
                pub value: String,
                /// Source for the environment variable's value. Cannot be used if value is not empty.
                pub value_from: ContainersItemEnvItemValueFrom,
            }

            /// EnvVar represents an environment variable present in a Container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItem {
                /// Name of the environment variable. Must be a C_IDENTIFIER.
                pub name: String,
                /// Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "".
                pub value: String,
                /// Source for the environment variable's value. Cannot be used if value is not empty.
                pub value_from: InitContainersItemEnvItemValueFrom,
            }

            /// EphemeralVolumeSource to be used by the Prometheus StatefulSets. This is a beta field in k8s 1.21, for lower versions, starting with k8s 1.19, it requires enabling the GenericEphemeralVolume feature gate. More info: https://kubernetes.io/docs/concepts/storage/ephemeral-volumes/#generic-ephemeral-volumes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeral {
                /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
                ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
                ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
                ///  Required, must not be nil.
                pub volume_claim_template: StorageEphemeralVolumeClaimTemplate,
            }

            /// Ephemeral represents a volume that is handled by a cluster storage driver. The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts, and deleted when the pod is removed.
            ///  Use this if: a) the volume is only needed while the pod runs, b) features of normal volumes like restoring from snapshot or capacity tracking are needed, c) the storage driver is specified through a storage class, and d) the storage driver supports dynamic volume provisioning through a PersistentVolumeClaim (see EphemeralVolumeSource for more information on the connection between this volume type and PersistentVolumeClaim).
            ///  Use PersistentVolumeClaim or one of the vendor-specific APIs for volumes that persist for longer than the lifecycle of an individual pod.
            ///  Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to be used that way - see the documentation of the driver for more information.
            ///  A pod can use both types of ephemeral volumes and persistent volumes at the same time.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeral {
                /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
                ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
                ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
                ///  Required, must not be nil.
                pub volume_claim_template: VolumesItemEphemeralVolumeClaimTemplate,
            }

            /// ObjectReference references a PodMonitor, ServiceMonitor, Probe or PrometheusRule object.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ExcludedFromEnforcementItem {
                /// Group of the referent. When not specified, it defaults to `monitoring.coreos.com`
                pub group: String,
                /// Name of the referent. When not set, all resources are matched.
                pub name: String,
                /// Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/
                pub namespace: String,
                /// Resource of the referent.
                pub resource: String,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// The labels to add to any time series or alerts when communicating with external systems (federation, remote storage, Alertmanager).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ExternalLabels {
                /// The labels to add to any time series or alerts when communicating with external systems (federation, remote storage, Alertmanager).
                pub properties: std::collections::HashMap<String, String>,
            }

            /// FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Fc {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// Optional: FC target lun number
                pub lun: i32,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// Optional: FC target worldwide names (WWNs)
                pub target_w_w_ns: Vec<String>,
                /// Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.
                pub wwids: Vec<String>,
            }

            /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPIItemsItemFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPIItemsItemFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct FlexVolume {
                /// Driver is the name of the driver to use for this volume.
                pub driver: String,
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.
                pub fs_type: String,
                /// Optional: Extra command options if any.
                pub options: Options,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.
                pub secret_ref: FlexVolumeSecretRef,
            }

            /// Flocker represents a Flocker volume attached to a kubelet's host machine. This depends on the Flocker control service being running
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Flocker {
                /// Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated
                pub dataset_name: String,
                /// UUID of the dataset. This is unique identifier of a Flocker dataset
                pub dataset_u_u_i_d: String,
            }

            /// GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GcePersistentDisk {
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub partition: i32,
                /// Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub pd_name: String,
                /// ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub read_only: bool,
            }

            /// GitRepo represents a git repository at a particular revision. DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GitRepo {
                /// Target directory name. Must not contain or start with '..'.  If '.' is supplied, the volume directory will be the git repository.  Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name.
                pub directory: String,
                /// Repository URL
                pub repository: String,
                /// Commit hash for the specified revision.
                pub revision: String,
            }

            /// Glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/glusterfs/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Glusterfs {
                /// EndpointsName is the endpoint name that details Glusterfs topology. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
                pub endpoints: String,
                /// Path is the Glusterfs volume path. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
                pub path: String,
                /// ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
                pub read_only: bool,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPCServerTLSConfig configures the gRPC server from which Thanos Querier reads recorded rule data. Note: Currently only the CAFile, CertFile, and KeyFile fields are supported. Maps to the '--grpc-server-tls-*' CLI args.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GrpcServerTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: GrpcServerTlsConfigCa,
                /// Path to the CA cert in the Prometheus container to use for the targets.
                pub ca_file: String,
                /// Struct containing the client cert file for the targets.
                pub cert: GrpcServerTlsConfigCert,
                /// Path to the client cert file in the Prometheus container for the targets.
                pub cert_file: String,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Path to the client key file in the Prometheus container for the targets.
                pub key_file: String,
                /// Secret containing the client key file for the targets.
                pub key_secret: GrpcServerTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// Custom HTTP headers to be sent along with each remote read request. Be aware that headers that are set by Prometheus itself can't be overwritten. Only valid in Prometheus versions 2.26.0 and newer.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemHeaders {
                /// Custom HTTP headers to be sent along with each remote read request. Be aware that headers that are set by Prometheus itself can't be overwritten. Only valid in Prometheus versions 2.26.0 and newer.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Custom HTTP headers to be sent along with each remote write request. Be aware that headers that are set by Prometheus itself can't be overwritten. Only valid in Prometheus versions 2.25.0 and newer.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemHeaders {
                /// Custom HTTP headers to be sent along with each remote write request. Be aware that headers that are set by Prometheus itself can't be overwritten. Only valid in Prometheus versions 2.25.0 and newer.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct HostAliasesItem {
                /// Hostnames for the above IP address.
                pub hostnames: Vec<String>,
                /// IP address of the host file entry.
                pub ip: String,
            }

            /// HostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath --- TODO(jonesdl) We need to restrict who can use host directory mounts and who can/can not mount host directories as read/write.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct HostPath {
                /// Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
                pub path: String,
                /// Type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
                pub r#type: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemLifecyclePostStartHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemLifecyclePreStopHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemLivenessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemReadinessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemStartupProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemLifecyclePostStartHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemLifecyclePreStopHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemLivenessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemReadinessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemStartupProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ImagePullSecretsItem {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// A single application container that you want to run within a pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItem {
                /// Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub args: Vec<String>,
                /// Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub command: Vec<String>,
                /// List of environment variables to set in the container. Cannot be updated.
                pub env: Vec<InitContainersItemEnvItem>,
                /// List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.
                pub env_from: Vec<InitContainersItemEnvFromItem>,
                /// Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.
                pub image: String,
                /// Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images
                pub image_pull_policy: String,
                /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
                pub lifecycle: InitContainersItemLifecycle,
                /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub liveness_probe: InitContainersItemLivenessProbe,
                /// Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.
                pub name: String,
                /// List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Cannot be updated.
                pub ports: Vec<InitContainersItemPortsItem>,
                /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub readiness_probe: InitContainersItemReadinessProbe,
                /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub resources: InitContainersItemResources,
                /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
                pub security_context: InitContainersItemSecurityContext,
                /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub startup_probe: InitContainersItemStartupProbe,
                /// Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.
                pub stdin: bool,
                /// Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false
                pub stdin_once: bool,
                /// Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.
                pub termination_message_path: String,
                /// Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.
                pub termination_message_policy: String,
                /// Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.
                pub tty: bool,
                /// volumeDevices is the list of block devices to be used by the container.
                pub volume_devices: Vec<InitContainersItemVolumeDevicesItem>,
                /// Pod volumes to mount into the container's filesystem. Cannot be updated.
                pub volume_mounts: Vec<InitContainersItemVolumeMountsItem>,
                /// Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.
                pub working_dir: String,
            }

            /// ISCSI represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://examples.k8s.io/volumes/iscsi/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Iscsi {
                /// whether support iSCSI Discovery CHAP authentication
                pub chap_auth_discovery: bool,
                /// whether support iSCSI Session CHAP authentication
                pub chap_auth_session: bool,
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.
                pub initiator_name: String,
                /// Target iSCSI Qualified Name.
                pub iqn: String,
                /// iSCSI Interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).
                pub iscsi_interface: String,
                /// iSCSI Target Lun number.
                pub lun: i32,
                /// iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).
                pub portals: Vec<String>,
                /// ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.
                pub read_only: bool,
                /// CHAP Secret for iSCSI target and initiator authentication
                pub secret_ref: IscsiSecretRef,
                /// iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).
                pub target_portal: String,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemConfigMapItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// DownwardAPIVolumeFile represents information to create the file containing the pod field
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPIItemsItem {
                /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
                pub field_ref: VolumesItemDownwardAPIItemsItemFieldRef,
                /// Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'
                pub path: String,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
                pub resource_field_ref: VolumesItemDownwardAPIItemsItemResourceFieldRef,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemConfigMapItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// DownwardAPIVolumeFile represents information to create the file containing the pod field
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPIItemsItem {
                /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
                pub field_ref: SourcesItemDownwardAPIItemsItemFieldRef,
                /// Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'
                pub path: String,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
                pub resource_field_ref: SourcesItemDownwardAPIItemsItemResourceFieldRef,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemSecretItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemSecretItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GrpcServerTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the TLS key for the server.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels,
        }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels,
        }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels,
        }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels,
        }

            /// LabelSelector is used to find matching pods. Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItemLabelSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<TopologySpreadConstraintsItemLabelSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: TopologySpreadConstraintsItemLabelSelectorMatchLabels,
            }

            /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetadataLabels {
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetadataLabels {
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecycle {
                /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub post_start: ContainersItemLifecyclePostStart,
                /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub pre_stop: ContainersItemLifecyclePreStop,
            }

            /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecycle {
                /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub post_start: InitContainersItemLifecyclePostStart,
                /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub pre_stop: InitContainersItemLifecyclePreStop,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ThanosResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbe {
                /// Exec specifies the action to take.
                pub exec: ContainersItemLivenessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: ContainersItemLivenessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemLivenessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: ContainersItemLivenessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbe {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemLivenessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: InitContainersItemLivenessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemLivenessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: InitContainersItemLivenessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PreferenceMatchExpressionsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelectorTermsItemMatchExpressionsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMonitorNamespaceSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMonitorSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ProbeNamespaceSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ProbeSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleNamespaceSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceMonitorNamespaceSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceMonitorSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItemLabelSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PreferenceMatchFieldsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelectorTermsItemMatchFieldsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMonitorNamespaceSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMonitorSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ProbeNamespaceSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ProbeSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleNamespaceSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceMonitorNamespaceSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceMonitorSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItemLabelSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateMetadata {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub properties: serde_json::Map<String, serde_json::Value>,
            }

            /// EmbeddedMetadata contains metadata relevant to an EmbeddedResource.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateMetadata {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub annotations: MetadataAnnotations,
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub labels: MetadataLabels,
                /// Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
                pub name: String,
            }

            /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateMetadata {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub properties: serde_json::Map<String, serde_json::Value>,
            }

            /// MetadataConfig configures the sending of series metadata to the remote storage.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetadataConfig {
                /// Whether metric metadata is sent to the remote storage or not.
                pub send: bool,
                /// How frequently metric metadata is sent to the remote storage.
                pub send_interval: String,
            }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels,
        }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels,
        }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels,
        }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels,
        }

            /// NFS represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Nfs {
                /// Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub path: String,
                /// ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub read_only: bool,
                /// Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub server: String,
            }

            /// Describes node affinity scheduling rules for the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeAffinity {
                /// The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.
                pub preferred_during_scheduling_ignored_during_execution:
                    Vec<NodeAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem>,
                /// If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.
                pub required_during_scheduling_ignored_during_execution:
                    RequiredDuringSchedulingIgnoredDuringExecution,
            }

            /// NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodePublishSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// Define which Nodes the Pods are scheduled on.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelector {
                /// Define which Nodes the Pods are scheduled on.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// A null or empty node selector term matches no objects. The requirements of them are ANDed. The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelectorTermsItem {
                /// A list of node selector requirements by node's labels.
                pub match_expressions: Vec<NodeSelectorTermsItemMatchExpressionsItem>,
                /// A list of node selector requirements by node's fields.
                pub match_fields: Vec<NodeSelectorTermsItemMatchFieldsItem>,
            }

            /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: RemoteReadItemOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: RemoteReadItemOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: RemoteReadItemOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: RemoteWriteItemOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: RemoteWriteItemOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: RemoteWriteItemOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// ObjectStorageConfig configures object storage in Thanos. Alternative to ObjectStorageConfigFile, and lower order priority.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ObjectStorageConfig {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Optional: Extra command options if any.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Options {
                /// Optional: Extra command options if any.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PersistentVolumeClaim {
                /// ClaimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub claim_name: String,
                /// Will force the ReadOnly setting in VolumeMounts. Default false.
                pub read_only: bool,
            }

            /// PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PhotonPersistentDisk {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// ID that identifies Photon Controller persistent disk
                pub pd_i_d: String,
            }

            /// Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinity {
                /// The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.
                pub preferred_during_scheduling_ignored_during_execution:
                    Vec<PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem>,
                /// If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.
                pub required_during_scheduling_ignored_during_execution:
                    Vec<PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem>,
            }

            /// Required. A pod affinity term, associated with the corresponding weight.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm {
            /// A label query over a set of resources, in this case pods.
            pub label_selector: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector,
            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            pub namespace_selector: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector,
            /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
            pub namespaces: Vec<String>,
            /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
            pub topology_key: String,
        }

            /// Required. A pod affinity term, associated with the corresponding weight.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm {
            /// A label query over a set of resources, in this case pods.
            pub label_selector: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector,
            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            pub namespace_selector: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector,
            /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
            pub namespaces: Vec<String>,
            /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
            pub topology_key: String,
        }

            /// Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinity {
                /// The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.
                pub preferred_during_scheduling_ignored_during_execution:
                    Vec<PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem>,
                /// If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.
                pub required_during_scheduling_ignored_during_execution:
                    Vec<PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem>,
            }

            /// PodMetadata configures Labels and Annotations which are propagated to the prometheus pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetadata {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub annotations: PodMetadataAnnotations,
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub labels: PodMetadataLabels,
                /// Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
                pub name: String,
            }

            /// Namespace's labels to match for PodMonitor discovery. If nil, only check own namespace.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMonitorNamespaceSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<PodMonitorNamespaceSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: PodMonitorNamespaceSelectorMatchLabels,
            }

            /// *Experimental* PodMonitors to be selected for target discovery. *Deprecated:* if neither this nor serviceMonitorSelector are specified, configuration is unmanaged.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMonitorSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<PodMonitorSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: PodMonitorSelectorMatchLabels,
            }

            /// ContainerPort represents a network port in a single container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemPortsItem {
                /// Number of port to expose on the pod's IP address. This must be a valid port number, 0 < x < 65536.
                pub container_port: i32,
                /// What host IP to bind the external port to.
                pub host_i_p: String,
                /// Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.
                pub host_port: i32,
                /// If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services.
                pub name: String,
                /// Protocol for port. Must be UDP, TCP, or SCTP. Defaults to "TCP".
                pub protocol: String,
            }

            /// ContainerPort represents a network port in a single container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemPortsItem {
                /// Number of port to expose on the pod's IP address. This must be a valid port number, 0 < x < 65536.
                pub container_port: i32,
                /// What host IP to bind the external port to.
                pub host_i_p: String,
                /// Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.
                pub host_port: i32,
                /// If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services.
                pub name: String,
                /// Protocol for port. Must be UDP, TCP, or SCTP. Defaults to "TCP".
                pub protocol: String,
            }

            /// PortworxVolume represents a portworx volume attached and mounted on kubelets host machine
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PortworxVolume {
                /// FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// VolumeID uniquely identifies a Portworx volume
                pub volume_i_d: String,
            }

            /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStart {
                /// Exec specifies the action to take.
                pub exec: ContainersItemLifecyclePostStartExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemLifecyclePostStartHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: ContainersItemLifecyclePostStartTcpSocket,
            }

            /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStart {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemLifecyclePostStartExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemLifecyclePostStartHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: InitContainersItemLifecyclePostStartTcpSocket,
            }

            /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStop {
                /// Exec specifies the action to take.
                pub exec: ContainersItemLifecyclePreStopExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemLifecyclePreStopHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: ContainersItemLifecyclePreStopTcpSocket,
            }

            /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStop {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemLifecyclePreStopExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemLifecyclePreStopHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: InitContainersItemLifecyclePreStopTcpSocket,
            }

            /// A node selector term, associated with the corresponding weight.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Preference {
                /// A list of node selector requirements by node's labels.
                pub match_expressions: Vec<PreferenceMatchExpressionsItem>,
                /// A list of node selector requirements by node's fields.
                pub match_fields: Vec<PreferenceMatchFieldsItem>,
            }

            /// An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it's a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem {
                /// A node selector term, associated with the corresponding weight.
                pub preference: Preference,
                /// Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100.
                pub weight: i32,
            }

            /// The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem {
                /// Required. A pod affinity term, associated with the corresponding weight.
                pub pod_affinity_term:
                    PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm,
                /// weight associated with matching the corresponding podAffinityTerm, in the range 1-100.
                pub weight: i32,
            }

            /// The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem {
            /// Required. A pod affinity term, associated with the corresponding weight.
            pub pod_affinity_term: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm,
            /// weight associated with matching the corresponding podAffinityTerm, in the range 1-100.
            pub weight: i32,
        }

            /// *Experimental* Namespaces to be selected for Probe discovery. If nil, only check own namespace.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ProbeNamespaceSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<ProbeNamespaceSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: ProbeNamespaceSelectorMatchLabels,
            }

            /// *Experimental* Probes to be selected for target discovery.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ProbeSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<ProbeSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: ProbeSelectorMatchLabels,
            }

            /// Items for all in one resources secrets, configmaps, and downward API
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Projected {
                /// Mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// list of volume projections
                pub sources: Vec<SourcesItem>,
            }

            /// PrometheusRuleExcludeConfig enables users to configure excluded PrometheusRule names and their namespaces to be ignored while enforcing namespace label for alerts and metrics.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PrometheusRulesExcludedFromEnforceItem {
                /// RuleNamespace - name of excluded rule
                pub rule_name: String,
                /// RuleNamespace - namespace of excluded rule
                pub rule_namespace: String,
            }

            /// QuerySpec defines the query command line flags when starting Prometheus.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Query {
                /// The delta difference allowed for retrieving metrics during expression evaluations.
                pub lookback_delta: String,
                /// Number of concurrent queries that can be run at once.
                pub max_concurrency: i32,
                /// Maximum number of samples a single query can load into memory. Note that queries will fail if they would load more samples than this into memory, so this also limits the number of samples a query can return.
                pub max_samples: i32,
                /// Maximum time a query may take before being aborted.
                pub timeout: String,
            }

            /// QueueConfig allows tuning of the remote write queue parameters.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct QueueConfig {
                /// BatchSendDeadline is the maximum time a sample will wait in buffer.
                pub batch_send_deadline: String,
                /// Capacity is the number of samples to buffer per shard before we start dropping them.
                pub capacity: i64,
                /// MaxBackoff is the maximum retry delay.
                pub max_backoff: String,
                /// MaxRetries is the maximum number of times to retry a batch on recoverable errors.
                pub max_retries: i64,
                /// MaxSamplesPerSend is the maximum number of samples per send.
                pub max_samples_per_send: i64,
                /// MaxShards is the maximum number of shards, i.e. amount of concurrency.
                pub max_shards: i64,
                /// MinBackoff is the initial retry delay. Gets doubled for every retry.
                pub min_backoff: String,
                /// MinShards is the minimum number of shards, i.e. amount of concurrency.
                pub min_shards: i64,
                /// Retry upon receiving a 429 status code from the remote-write storage. This is experimental feature and might change in the future.
                pub retry_on_rate_limit: bool,
            }

            /// Quobyte represents a Quobyte mount on the host that shares a pod's lifetime
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Quobyte {
                /// Group to map volume access to Default is no group
                pub group: String,
                /// ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false.
                pub read_only: bool,
                /// Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes
                pub registry: String,
                /// Tenant owning the given Quobyte volume in the Backend Used with dynamically provisioned Quobyte volumes, value is set by the plugin
                pub tenant: String,
                /// User to map volume access to Defaults to serivceaccount user
                pub user: String,
                /// Volume is a string that references an already created Quobyte volume by name.
                pub volume: String,
            }

            /// RBD represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/rbd/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Rbd {
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// The rados image name. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub image: String,
                /// Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub keyring: String,
                /// A collection of Ceph monitors. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub monitors: Vec<String>,
                /// The rados pool name. Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub pool: String,
                /// ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub read_only: bool,
                /// SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub secret_ref: RbdSecretRef,
                /// The rados user name. Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub user: String,
            }

            /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbe {
                /// Exec specifies the action to take.
                pub exec: ContainersItemReadinessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: ContainersItemReadinessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemReadinessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: ContainersItemReadinessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbe {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemReadinessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: InitContainersItemReadinessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemReadinessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: InitContainersItemReadinessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// RemoteReadSpec defines the configuration for Prometheus to read back samples from a remote endpoint.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItem {
                /// Authorization section for remote read
                pub authorization: RemoteReadItemAuthorization,
                /// BasicAuth for the URL.
                pub basic_auth: RemoteReadItemBasicAuth,
                /// Bearer token for remote read.
                pub bearer_token: String,
                /// File to read bearer token for remote read.
                pub bearer_token_file: String,
                /// Custom HTTP headers to be sent along with each remote read request. Be aware that headers that are set by Prometheus itself can't be overwritten. Only valid in Prometheus versions 2.26.0 and newer.
                pub headers: RemoteReadItemHeaders,
                /// The name of the remote read queue, it must be unique if specified. The name is used in metrics and logging in order to differentiate read configurations.  Only valid in Prometheus versions 2.15.0 and newer.
                pub name: String,
                /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
                pub oauth2: RemoteReadItemOauth2,
                /// Optional ProxyURL.
                pub proxy_url: String,
                /// Whether reads should be made for queries for time ranges that the local storage should have complete data for.
                pub read_recent: bool,
                /// Timeout for requests to the remote read endpoint.
                pub remote_timeout: String,
                /// An optional list of equality matchers which have to be present in a selector to query the remote read endpoint.
                pub required_matchers: RequiredMatchers,
                /// TLS Config to use for remote read.
                pub tls_config: RemoteReadItemTlsConfig,
                /// The URL of the endpoint to query from.
                pub url: String,
            }

            /// RemoteWriteSpec defines the configuration to write samples from Prometheus to a remote endpoint.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItem {
                /// Authorization section for remote write
                pub authorization: RemoteWriteItemAuthorization,
                /// BasicAuth for the URL.
                pub basic_auth: RemoteWriteItemBasicAuth,
                /// Bearer token for remote write.
                pub bearer_token: String,
                /// File to read bearer token for remote write.
                pub bearer_token_file: String,
                /// Custom HTTP headers to be sent along with each remote write request. Be aware that headers that are set by Prometheus itself can't be overwritten. Only valid in Prometheus versions 2.25.0 and newer.
                pub headers: RemoteWriteItemHeaders,
                /// MetadataConfig configures the sending of series metadata to the remote storage.
                pub metadata_config: MetadataConfig,
                /// The name of the remote write queue, it must be unique if specified. The name is used in metrics and logging in order to differentiate queues. Only valid in Prometheus versions 2.15.0 and newer.
                pub name: String,
                /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
                pub oauth2: RemoteWriteItemOauth2,
                /// Optional ProxyURL.
                pub proxy_url: String,
                /// QueueConfig allows tuning of the remote write queue parameters.
                pub queue_config: QueueConfig,
                /// Timeout for requests to the remote write endpoint.
                pub remote_timeout: String,
                /// Enables sending of exemplars over remote write. Note that exemplar-storage itself must be enabled using the enableFeature option for exemplars to be scraped in the first place.  Only valid in Prometheus versions 2.27.0 and newer.
                pub send_exemplars: bool,
                /// Sigv4 allows to configures AWS's Signature Verification 4
                pub sigv4: Sigv4,
                /// TLS Config to use for remote write.
                pub tls_config: RemoteWriteItemTlsConfig,
                /// The URL of the endpoint to send samples to.
                pub url: String,
                /// The list of remote write relabel configurations.
                pub write_relabel_configs: Vec<WriteRelabelConfigsItem>,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ThanosResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RequiredDuringSchedulingIgnoredDuringExecution {
                /// Required. A list of node selector terms. The terms are ORed.
                pub node_selector_terms: Vec<NodeSelectorTermsItem>,
            }

            /// Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem {
                /// A label query over a set of resources, in this case pods.
                pub label_selector:
                    PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector,
                /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
                pub namespace_selector:
                    PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector,
                /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
                pub namespaces: Vec<String>,
                /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
                pub topology_key: String,
            }

            /// Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem {
            /// A label query over a set of resources, in this case pods.
            pub label_selector: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector,
            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            pub namespace_selector: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector,
            /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
            pub namespaces: Vec<String>,
            /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
            pub topology_key: String,
        }

            /// An optional list of equality matchers which have to be present in a selector to query the remote read endpoint.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RequiredMatchers {
                /// An optional list of equality matchers which have to be present in a selector to query the remote read endpoint.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPIItemsItemResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPIItemsItemResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Define resources requests and limits for single Pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: SpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: SpecResourcesRequests,
            }

            /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: ContainersItemResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: ContainersItemResourcesRequests,
            }

            /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: InitContainersItemResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: InitContainersItemResourcesRequests,
            }

            /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: StorageEphemeralVolumeClaimTemplateSpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: StorageEphemeralVolumeClaimTemplateSpecResourcesRequests,
            }

            /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: StorageVolumeClaimTemplateSpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: StorageVolumeClaimTemplateSpecResourcesRequests,
            }

            /// Resources defines the resource requirements for the Thanos sidecar. If not provided, no requests/limits will be set
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ThanosResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: ThanosResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: ThanosResourcesRequests,
            }

            /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: VolumesItemEphemeralVolumeClaimTemplateSpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: VolumesItemEphemeralVolumeClaimTemplateSpecResourcesRequests,
            }

            /// Namespaces to be selected for PrometheusRules discovery. If unspecified, only the same namespace as the Prometheus object is in is used.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleNamespaceSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<RuleNamespaceSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: RuleNamespaceSelectorMatchLabels,
            }

            /// A selector to select which PrometheusRules to mount for loading alerting/recording rules from. Until (excluding) Prometheus Operator v0.24.0 Prometheus Operator will migrate any legacy rule ConfigMaps to PrometheusRule custom resources selected by RuleSelector. Make sure it does not match any config maps that you do not want to be migrated.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<RuleSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: RuleSelectorMatchLabels,
            }

            /// /--rules.*/ command-line arguments.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Rules {
                /// /--rules.alert.*/ command-line arguments
                pub alert: Alert,
            }

            /// ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ScaleIO {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs".
                pub fs_type: String,
                /// The host address of the ScaleIO API Gateway.
                pub gateway: String,
                /// The name of the ScaleIO Protection Domain for the configured storage.
                pub protection_domain: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.
                pub secret_ref: ScaleIOSecretRef,
                /// Flag to enable/disable SSL communication with Gateway, default false
                pub ssl_enabled: bool,
                /// Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. Default is ThinProvisioned.
                pub storage_mode: String,
                /// The ScaleIO Storage Pool associated with the protection domain.
                pub storage_pool: String,
                /// The name of the storage system as configured in ScaleIO.
                pub system: String,
                /// The name of a volume already created in the ScaleIO system that is associated with this volume source.
                pub volume_name: String,
            }

            /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextSeLinuxOptions {
                /// Level is SELinux level label that applies to the container.
                pub level: String,
                /// Role is a SELinux role label that applies to the container.
                pub role: String,
                /// Type is a SELinux type label that applies to the container.
                pub r#type: String,
                /// User is a SELinux user label that applies to the container.
                pub user: String,
            }

            /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextSeLinuxOptions {
                /// Level is SELinux level label that applies to the container.
                pub level: String,
                /// Role is a SELinux role label that applies to the container.
                pub role: String,
                /// Type is a SELinux type label that applies to the container.
                pub r#type: String,
                /// User is a SELinux user label that applies to the container.
                pub user: String,
            }

            /// The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContextSeLinuxOptions {
                /// Level is SELinux level label that applies to the container.
                pub level: String,
                /// Role is a SELinux role label that applies to the container.
                pub role: String,
                /// Type is a SELinux type label that applies to the container.
                pub r#type: String,
                /// User is a SELinux user label that applies to the container.
                pub user: String,
            }

            /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextSeccompProfile {
                /// localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".
                pub localhost_profile: String,
                /// type indicates which kind of seccomp profile will be applied. Valid options are:
                ///  Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.
                pub r#type: String,
            }

            /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextSeccompProfile {
                /// localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".
                pub localhost_profile: String,
                /// type indicates which kind of seccomp profile will be applied. Valid options are:
                ///  Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.
                pub r#type: String,
            }

            /// The seccomp options to use by the containers in this pod. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContextSeccompProfile {
                /// localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".
                pub localhost_profile: String,
                /// type indicates which kind of seccomp profile will be applied. Valid options are:
                ///  Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.
                pub r#type: String,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GrpcServerTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GrpcServerTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret represents a secret that should populate this volume. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemSecret {
                /// Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<VolumesItemSecretItemsItem>,
                /// Specify whether the Secret or its keys must be defined
                pub optional: bool,
                /// Name of the secret in the pod's namespace to use. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
                pub secret_name: String,
            }

            /// information about the secret data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemSecret {
                /// If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<SourcesItemSecretItemsItem>,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// SecretKey is the AWS API secret. If blank, the environment variable `AWS_SECRET_ACCESS_KEY` is used.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SecretKey {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a secret in the pod's namespace
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromSecretKeyRef {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a secret in the pod's namespace
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromSecretKeyRef {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The Secret to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvFromItemSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret must be defined
                pub optional: bool,
            }

            /// The Secret to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvFromItemSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret must be defined
                pub optional: bool,
            }

            /// Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CephfsSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// Optional: points to a secret object containing parameters used to connect to OpenStack.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CinderSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct FlexVolumeSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// CHAP Secret for iSCSI target and initiator authentication
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct IscsiSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RbdSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ScaleIOSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageosSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecurityContext holds pod-level security attributes and common container settings. This defaults to the default PodSecurityContext.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContext {
                /// A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:
                ///  1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----
                ///  If unset, the Kubelet will not modify the ownership and permissions of any volume. Note that this field cannot be set when spec.os.name is windows.
                pub fs_group: i64,
                /// fsGroupChangePolicy defines behavior of changing ownership and permission of the volume before being exposed inside Pod. This field will only apply to volume types which support fsGroup based ownership(and permissions). It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir. Valid values are "OnRootMismatch" and "Always". If not specified, "Always" is used. Note that this field cannot be set when spec.os.name is windows.
                pub fs_group_change_policy: String,
                /// The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_group: i64,
                /// Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_non_root: bool,
                /// The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_user: i64,
                /// The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
                pub se_linux_options: SpecSecurityContextSeLinuxOptions,
                /// The seccomp options to use by the containers in this pod. Note that this field cannot be set when spec.os.name is windows.
                pub seccomp_profile: SpecSecurityContextSeccompProfile,
                /// A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container. Note that this field cannot be set when spec.os.name is windows.
                pub supplemental_groups: Vec<i64>,
                /// Sysctls hold a list of namespaced sysctls used for the pod. Pods with unsupported sysctls (by the container runtime) might fail to launch. Note that this field cannot be set when spec.os.name is windows.
                pub sysctls: Vec<SysctlsItem>,
                /// The Windows specific settings applied to all containers. If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
                pub windows_options: SpecSecurityContextWindowsOptions,
            }

            /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContext {
                /// AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.
                pub allow_privilege_escalation: bool,
                /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
                pub capabilities: ContainersItemSecurityContextCapabilities,
                /// Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.
                pub privileged: bool,
                /// procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.
                pub proc_mount: String,
                /// Whether this container has a read-only root filesystem. Default is false. Note that this field cannot be set when spec.os.name is windows.
                pub read_only_root_filesystem: bool,
                /// The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_group: i64,
                /// Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_non_root: bool,
                /// The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_user: i64,
                /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub se_linux_options: ContainersItemSecurityContextSeLinuxOptions,
                /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
                pub seccomp_profile: ContainersItemSecurityContextSeccompProfile,
                /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
                pub windows_options: ContainersItemSecurityContextWindowsOptions,
            }

            /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContext {
                /// AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.
                pub allow_privilege_escalation: bool,
                /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
                pub capabilities: InitContainersItemSecurityContextCapabilities,
                /// Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.
                pub privileged: bool,
                /// procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.
                pub proc_mount: String,
                /// Whether this container has a read-only root filesystem. Default is false. Note that this field cannot be set when spec.os.name is windows.
                pub read_only_root_filesystem: bool,
                /// The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_group: i64,
                /// Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_non_root: bool,
                /// The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_user: i64,
                /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub se_linux_options: InitContainersItemSecurityContextSeLinuxOptions,
                /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
                pub seccomp_profile: InitContainersItemSecurityContextSeccompProfile,
                /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
                pub windows_options: InitContainersItemSecurityContextWindowsOptions,
            }

            /// A label query over volumes to consider for binding.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<StorageEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: StorageEphemeralVolumeClaimTemplateSpecSelectorMatchLabels,
            }

            /// A label query over volumes to consider for binding.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<StorageVolumeClaimTemplateSpecSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: StorageVolumeClaimTemplateSpecSelectorMatchLabels,
            }

            /// A label query over volumes to consider for binding.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchLabels,
            }

            /// information about the serviceAccountToken data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceAccountToken {
                /// Audience is the intended audience of the token. A recipient of a token must identify itself with an identifier specified in the audience of the token, and otherwise should reject the token. The audience defaults to the identifier of the apiserver.
                pub audience: String,
                /// ExpirationSeconds is the requested duration of validity of the service account token. As the token approaches expiration, the kubelet volume plugin will proactively rotate the service account token. The kubelet will start trying to rotate the token if the token is older than 80 percent of its time to live or if the token is older than 24 hours.Defaults to 1 hour and must be at least 10 minutes.
                pub expiration_seconds: i64,
                /// Path is the path relative to the mount point of the file to project the token into.
                pub path: String,
            }

            /// Namespace's labels to match for ServiceMonitor discovery. If nil, only check own namespace.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceMonitorNamespaceSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<ServiceMonitorNamespaceSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: ServiceMonitorNamespaceSelectorMatchLabels,
            }

            /// ServiceMonitors to be selected for target discovery. *Deprecated:* if neither this nor podMonitorSelector are specified, configuration is unmanaged.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceMonitorSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<ServiceMonitorSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: ServiceMonitorSelectorMatchLabels,
            }

            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ShardStatusesItem {
                /// Total number of available pods (ready for at least minReadySeconds) targeted by this shard.
                pub available_replicas: i32,
                /// Total number of pods targeted by this shard.
                pub replicas: i32,
                /// Identifier of the shard.
                pub shard_i_d: String,
                /// Total number of unavailable pods targeted by this shard.
                pub unavailable_replicas: i32,
                /// Total number of non-terminated pods targeted by this shard that have the desired spec.
                pub updated_replicas: i32,
            }

            /// Sigv4 allows to configures AWS's Signature Verification 4
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Sigv4 {
                /// AccessKey is the AWS API key. If blank, the environment variable `AWS_ACCESS_KEY_ID` is used.
                pub access_key: AccessKey,
                /// Profile is the named AWS profile used to authenticate.
                pub profile: String,
                /// Region is the AWS region. If blank, the region from the default credentials chain used.
                pub region: String,
                /// RoleArn is the named AWS profile used to authenticate.
                pub role_arn: String,
                /// SecretKey is the AWS API secret. If blank, the environment variable `AWS_SECRET_ACCESS_KEY` is used.
                pub secret_key: SecretKey,
            }

            /// Projection that may be projected along with other supported volume types
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItem {
                /// information about the configMap data to project
                pub config_map: SourcesItemConfigMap,
                /// information about the downwardAPI data to project
                pub downward_a_p_i: SourcesItemDownwardAPI,
                /// information about the secret data to project
                pub secret: SourcesItemSecret,
                /// information about the serviceAccountToken data to project
                pub service_account_token: ServiceAccountToken,
            }

            /// Specification of the desired behavior of the Prometheus cluster. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Spec {
                /// AdditionalAlertManagerConfigs allows specifying a key of a Secret containing additional Prometheus AlertManager configurations. AlertManager configurations specified are appended to the configurations generated by the Prometheus Operator. Job configurations specified must have the form as specified in the official Prometheus documentation: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#alertmanager_config. As AlertManager configs are appended, the user is responsible to make sure it is valid. Note that using this feature may expose the possibility to break upgrades of Prometheus. It is advised to review Prometheus release notes to ensure that no incompatible AlertManager configs are going to break Prometheus after the upgrade.
                pub additional_alert_manager_configs: AdditionalAlertManagerConfigs,
                /// AdditionalAlertRelabelConfigs allows specifying a key of a Secret containing additional Prometheus alert relabel configurations. Alert relabel configurations specified are appended to the configurations generated by the Prometheus Operator. Alert relabel configurations specified must have the form as specified in the official Prometheus documentation: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#alert_relabel_configs. As alert relabel configs are appended, the user is responsible to make sure it is valid. Note that using this feature may expose the possibility to break upgrades of Prometheus. It is advised to review Prometheus release notes to ensure that no incompatible alert relabel configs are going to break Prometheus after the upgrade.
                pub additional_alert_relabel_configs: AdditionalAlertRelabelConfigs,
                /// AdditionalScrapeConfigs allows specifying a key of a Secret containing additional Prometheus scrape configurations. Scrape configurations specified are appended to the configurations generated by the Prometheus Operator. Job configurations specified must have the form as specified in the official Prometheus documentation: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#scrape_config. As scrape configs are appended, the user is responsible to make sure it is valid. Note that using this feature may expose the possibility to break upgrades of Prometheus. It is advised to review Prometheus release notes to ensure that no incompatible scrape configs are going to break Prometheus after the upgrade.
                pub additional_scrape_configs: AdditionalScrapeConfigs,
                /// If specified, the pod's scheduling constraints.
                pub affinity: Affinity,
                /// Define details regarding alerting.
                pub alerting: Alerting,
                /// AllowOverlappingBlocks enables vertical compaction and vertical query merge in Prometheus. This is still experimental in Prometheus so it may change in any upcoming release.
                pub allow_overlapping_blocks: bool,
                /// APIServerConfig allows specifying a host and auth methods to access apiserver. If left empty, Prometheus is assumed to run inside of the cluster and will discover API servers automatically and use the pod's CA certificate and bearer token file at /var/run/secrets/kubernetes.io/serviceaccount/.
                pub apiserver_config: ApiserverConfig,
                /// ArbitraryFSAccessThroughSMs configures whether configuration based on a service monitor can access arbitrary files on the file system of the Prometheus container e.g. bearer token files.
                pub arbitrary_f_s_access_through_s_ms: ArbitraryFSAccessThroughSMs,
                /// Base image to use for a Prometheus deployment. Deprecated: use 'image' instead
                pub base_image: String,
                /// ConfigMaps is a list of ConfigMaps in the same namespace as the Prometheus object, which shall be mounted into the Prometheus Pods. The ConfigMaps are mounted into /etc/prometheus/configmaps/<configmap-name>.
                pub config_maps: Vec<String>,
                /// Containers allows injecting additional containers or modifying operator generated containers. This can be used to allow adding an authentication proxy to a Prometheus pod or to change the behavior of an operator generated container. Containers described here modify an operator generated container if they share the same name and modifications are done via a strategic merge patch. The current container names are: `prometheus`, `config-reloader`, and `thanos-sidecar`. Overriding containers is entirely outside the scope of what the maintainers will support and by doing so, you accept that this behaviour may break at any time without notice.
                pub containers: Vec<ContainersItem>,
                /// Disable prometheus compaction.
                pub disable_compaction: bool,
                /// Enable access to prometheus web admin API. Defaults to the value of `false`. WARNING: Enabling the admin APIs enables mutating endpoints, to delete data, shutdown Prometheus, and more. Enabling this should be done with care and the user is advised to add additional authentication authorization via a proxy to ensure only clients authorized to perform these actions can do so. For more information see https://prometheus.io/docs/prometheus/latest/querying/api/#tsdb-admin-apis
                pub enable_admin_a_p_i: bool,
                /// Enable access to Prometheus disabled features. By default, no features are enabled. Enabling disabled features is entirely outside the scope of what the maintainers will support and by doing so, you accept that this behaviour may break at any time without notice. For more information see https://prometheus.io/docs/prometheus/latest/disabled_features/
                pub enable_features: Vec<String>,
                /// Enable Prometheus to be used as a receiver for the Prometheus remote write protocol. Defaults to the value of `false`. WARNING: This is not considered an efficient way of ingesting samples. Use it with caution for specific low-volume use cases. It is not suitable for replacing the ingestion via scraping and turning Prometheus into a push-based metrics collection system. For more information see https://prometheus.io/docs/prometheus/latest/querying/api/#remote-write-receiver Only valid in Prometheus versions 2.33.0 and newer.
                pub enable_remote_write_receiver: bool,
                /// EnforcedBodySizeLimit defines the maximum size of uncompressed response body that will be accepted by Prometheus. Targets responding with a body larger than this many bytes will cause the scrape to fail. Example: 100MB. If defined, the limit will apply to all service/pod monitors and probes. This is an experimental feature, this behaviour could change or be removed in the future. Only valid in Prometheus versions 2.28.0 and newer.
                pub enforced_body_size_limit: String,
                /// Per-scrape limit on number of labels that will be accepted for a sample. If more than this number of labels are present post metric-relabeling, the entire scrape will be treated as failed. 0 means no limit. Only valid in Prometheus versions 2.27.0 and newer.
                pub enforced_label_limit: i64,
                /// Per-scrape limit on length of labels name that will be accepted for a sample. If a label name is longer than this number post metric-relabeling, the entire scrape will be treated as failed. 0 means no limit. Only valid in Prometheus versions 2.27.0 and newer.
                pub enforced_label_name_length_limit: i64,
                /// Per-scrape limit on length of labels value that will be accepted for a sample. If a label value is longer than this number post metric-relabeling, the entire scrape will be treated as failed. 0 means no limit. Only valid in Prometheus versions 2.27.0 and newer.
                pub enforced_label_value_length_limit: i64,
                /// EnforcedNamespaceLabel If set, a label will be added to
                ///  1. all user-metrics (created by `ServiceMonitor`, `PodMonitor` and `Probe` objects) and 2. in all `PrometheusRule` objects (except the ones excluded in `prometheusRulesExcludedFromEnforce`) to * alerting & recording rules and * the metrics used in their expressions (`expr`).
                ///  Label name is this field's value. Label value is the namespace of the created object (mentioned above).
                pub enforced_namespace_label: String,
                /// EnforcedSampleLimit defines global limit on number of scraped samples that will be accepted. This overrides any SampleLimit set per ServiceMonitor or/and PodMonitor. It is meant to be used by admins to enforce the SampleLimit to keep overall number of samples/series under the desired limit. Note that if SampleLimit is lower that value will be taken instead.
                pub enforced_sample_limit: i64,
                /// EnforcedTargetLimit defines a global limit on the number of scraped targets.  This overrides any TargetLimit set per ServiceMonitor or/and PodMonitor.  It is meant to be used by admins to enforce the TargetLimit to keep the overall number of targets under the desired limit. Note that if TargetLimit is lower, that value will be taken instead, except if either value is zero, in which case the non-zero value will be used.  If both values are zero, no limit is enforced.
                pub enforced_target_limit: i64,
                /// Interval between consecutive evaluations. Default: `30s`
                pub evaluation_interval: String,
                /// List of references to PodMonitor, ServiceMonitor, Probe and PrometheusRule objects to be excluded from enforcing a namespace label of origin. Applies only if enforcedNamespaceLabel set to true.
                pub excluded_from_enforcement: Vec<ExcludedFromEnforcementItem>,
                /// The labels to add to any time series or alerts when communicating with external systems (federation, remote storage, Alertmanager).
                pub external_labels: ExternalLabels,
                /// The external URL the Prometheus instances will be available under. This is necessary to generate correct URLs. This is necessary if Prometheus is not served from root of a DNS name.
                pub external_url: String,
                /// Pods' hostAliases configuration
                pub host_aliases: Vec<HostAliasesItem>,
                /// IgnoreNamespaceSelectors if set to true will ignore NamespaceSelector settings from all PodMonitor, ServiceMonitor and Probe objects. They will only discover endpoints within their current namespace. Defaults to false.
                pub ignore_namespace_selectors: bool,
                /// Image if specified has precedence over baseImage, tag and sha combinations. Specifying the version is still necessary to ensure the Prometheus Operator knows what version of Prometheus is being configured.
                pub image: String,
                /// An optional list of references to secrets in the same namespace to use for pulling prometheus and alertmanager images from registries see http://kubernetes.io/docs/user-guide/images#specifying-imagepullsecrets-on-a-pod
                pub image_pull_secrets: Vec<ImagePullSecretsItem>,
                /// InitContainers allows adding initContainers to the pod definition. Those can be used to e.g. fetch secrets for injection into the Prometheus configuration from external sources. Any errors during the execution of an initContainer will lead to a restart of the Pod. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/ InitContainers described here modify an operator generated init containers if they share the same name and modifications are done via a strategic merge patch. The current init container name is: `init-config-reloader`. Overriding init containers is entirely outside the scope of what the maintainers will support and by doing so, you accept that this behaviour may break at any time without notice.
                pub init_containers: Vec<InitContainersItem>,
                /// ListenLocal makes the Prometheus server listen on loopback, so that it does not bind against the Pod IP.
                pub listen_local: bool,
                /// Log format for Prometheus to be configured with.
                pub log_format: String,
                /// Log level for Prometheus to be configured with.
                pub log_level: String,
                /// Minimum number of seconds for which a newly created pod should be ready without any of its container crashing for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready) This is an alpha field and requires enabling StatefulSetMinReadySeconds feature gate.
                pub min_ready_seconds: i32,
                /// Define which Nodes the Pods are scheduled on.
                pub node_selector: NodeSelector,
                /// When true, Prometheus resolves label conflicts by renaming the labels in the scraped data to "exported_<label value>" for all targets created from service and pod monitors. Otherwise the HonorLabels field of the service or pod monitor applies.
                pub override_honor_labels: bool,
                /// When true, Prometheus ignores the timestamps for all the targets created from service and pod monitors. Otherwise the HonorTimestamps field of the service or pod monitor applies.
                pub override_honor_timestamps: bool,
                /// When a Prometheus deployment is paused, no actions except for deletion will be performed on the underlying objects.
                pub paused: bool,
                /// PodMetadata configures Labels and Annotations which are propagated to the prometheus pods.
                pub pod_metadata: PodMetadata,
                /// Namespace's labels to match for PodMonitor discovery. If nil, only check own namespace.
                pub pod_monitor_namespace_selector: PodMonitorNamespaceSelector,
                /// *Experimental* PodMonitors to be selected for target discovery. *Deprecated:* if neither this nor serviceMonitorSelector are specified, configuration is unmanaged.
                pub pod_monitor_selector: PodMonitorSelector,
                /// Port name used for the pods and governing service. This defaults to web
                pub port_name: String,
                /// Priority class assigned to the Pods
                pub priority_class_name: String,
                /// *Experimental* Namespaces to be selected for Probe discovery. If nil, only check own namespace.
                pub probe_namespace_selector: ProbeNamespaceSelector,
                /// *Experimental* Probes to be selected for target discovery.
                pub probe_selector: ProbeSelector,
                /// Name of Prometheus external label used to denote Prometheus instance name. Defaults to the value of `prometheus`. External label will _not_ be added when value is set to empty string (`""`).
                pub prometheus_external_label_name: String,
                /// PrometheusRulesExcludedFromEnforce - list of prometheus rules to be excluded from enforcing of adding namespace labels. Works only if enforcedNamespaceLabel set to true. Make sure both ruleNamespace and ruleName are set for each pair. Deprecated: use excludedFromEnforcement instead.
                pub prometheus_rules_excluded_from_enforce:
                    Vec<PrometheusRulesExcludedFromEnforceItem>,
                /// QuerySpec defines the query command line flags when starting Prometheus.
                pub query: Query,
                /// QueryLogFile specifies the file to which PromQL queries are logged. If the filename has an empty path, e.g. 'query.log', prometheus-operator will mount the file into an emptyDir volume at `/var/log/prometheus`. If a full path is provided, e.g. /var/log/prometheus/query.log, you must mount a volume in the specified directory and it must be writable. This is because the prometheus container runs with a read-only root filesystem for security reasons. Alternatively, the location can be set to a stdout location such as `/dev/stdout` to log query information to the default Prometheus log stream. This is only available in versions of Prometheus >= 2.16.0. For more details, see the Prometheus docs (https://prometheus.io/docs/guides/query-log/)
                pub query_log_file: String,
                /// remoteRead is the list of remote read configurations.
                pub remote_read: Vec<RemoteReadItem>,
                /// remoteWrite is the list of remote write configurations.
                pub remote_write: Vec<RemoteWriteItem>,
                /// Name of Prometheus external label used to denote replica name. Defaults to the value of `prometheus_replica`. External label will _not_ be added when value is set to empty string (`""`).
                pub replica_external_label_name: String,
                /// Number of replicas of each shard to deploy for a Prometheus deployment. Number of replicas multiplied by shards is the total number of Pods created.
                pub replicas: i32,
                /// Define resources requests and limits for single Pods.
                pub resources: SpecResources,
                /// Time duration Prometheus shall retain data for. Default is '24h' if retentionSize is not set, and must match the regular expression `[0-9]+(ms|s|m|h|d|w|y)` (milliseconds seconds minutes hours days weeks years).
                pub retention: String,
                /// Maximum amount of disk space used by blocks.
                pub retention_size: String,
                /// The route prefix Prometheus registers HTTP handlers for. This is useful, if using ExternalURL and a proxy is rewriting HTTP routes of a request, and the actual ExternalURL is still true, but the server serves requests under a different route prefix. For example for use with `kubectl proxy`.
                pub route_prefix: String,
                /// Namespaces to be selected for PrometheusRules discovery. If unspecified, only the same namespace as the Prometheus object is in is used.
                pub rule_namespace_selector: RuleNamespaceSelector,
                /// A selector to select which PrometheusRules to mount for loading alerting/recording rules from. Until (excluding) Prometheus Operator v0.24.0 Prometheus Operator will migrate any legacy rule ConfigMaps to PrometheusRule custom resources selected by RuleSelector. Make sure it does not match any config maps that you do not want to be migrated.
                pub rule_selector: RuleSelector,
                /// /--rules.*/ command-line arguments.
                pub rules: Rules,
                /// Interval between consecutive scrapes. Default: `30s`
                pub scrape_interval: String,
                /// Number of seconds to wait for target to respond before erroring.
                pub scrape_timeout: String,
                /// Secrets is a list of Secrets in the same namespace as the Prometheus object, which shall be mounted into the Prometheus Pods. The Secrets are mounted into /etc/prometheus/secrets/<secret-name>.
                pub secrets: Vec<String>,
                /// SecurityContext holds pod-level security attributes and common container settings. This defaults to the default PodSecurityContext.
                pub security_context: SpecSecurityContext,
                /// ServiceAccountName is the name of the ServiceAccount to use to run the Prometheus Pods.
                pub service_account_name: String,
                /// Namespace's labels to match for ServiceMonitor discovery. If nil, only check own namespace.
                pub service_monitor_namespace_selector: ServiceMonitorNamespaceSelector,
                /// ServiceMonitors to be selected for target discovery. *Deprecated:* if neither this nor podMonitorSelector are specified, configuration is unmanaged.
                pub service_monitor_selector: ServiceMonitorSelector,
                /// SHA of Prometheus container image to be deployed. Defaults to the value of `version`. Similar to a tag, but the SHA explicitly deploys an immutable container image. Version and Tag are ignored if SHA is set. Deprecated: use 'image' instead.  The image digest can be specified as part of the image URL.
                pub sha: String,
                /// EXPERIMENTAL: Number of shards to distribute targets onto. Number of replicas multiplied by shards is the total number of Pods created. Note that scaling down shards will not reshard data onto remaining instances, it must be manually moved. Increasing shards will not reshard data either but it will continue to be available from the same instances. To query globally use Thanos sidecar and Thanos querier or remote write data to a central location. Sharding is done on the content of the `__address__` target meta-label.
                pub shards: i32,
                /// Storage spec to specify how storage shall be used.
                pub storage: Storage,
                /// Tag of Prometheus container image to be deployed. Defaults to the value of `version`. Version is ignored if Tag is set. Deprecated: use 'image' instead.  The image tag can be specified as part of the image URL.
                pub tag: String,
                /// Thanos configuration allows configuring various aspects of a Prometheus server in a Thanos environment.
                ///  This section is experimental, it may change significantly without deprecation notice in any release.
                ///  This is experimental and may change significantly without backward compatibility in any release.
                pub thanos: Thanos,
                /// If specified, the pod's tolerations.
                pub tolerations: Vec<TolerationsItem>,
                /// If specified, the pod's topology spread constraints.
                pub topology_spread_constraints: Vec<TopologySpreadConstraintsItem>,
                /// Version of Prometheus to be deployed.
                pub version: String,
                /// VolumeMounts allows configuration of additional VolumeMounts on the output StatefulSet definition. VolumeMounts specified will be appended to other VolumeMounts in the prometheus container, that are generated as a result of StorageSpec objects.
                pub volume_mounts: Vec<SpecVolumeMountsItem>,
                /// Volumes allows configuration of additional volumes on the output StatefulSet definition. Volumes specified will be appended to other volumes that are generated as a result of StorageSpec objects.
                pub volumes: Vec<VolumesItem>,
                /// Enable compression of the write-ahead log using Snappy. This flag is only available in versions of Prometheus >= 2.11.0.
                pub wal_compression: bool,
                /// WebSpec defines the web command line flags when starting Prometheus.
                pub web: Web,
            }

            /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpec {
                /// AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
                pub data_source: StorageEphemeralVolumeClaimTemplateSpecDataSource,
                /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
                pub data_source_ref: StorageEphemeralVolumeClaimTemplateSpecDataSourceRef,
                /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
                pub resources: StorageEphemeralVolumeClaimTemplateSpecResources,
                /// A label query over volumes to consider for binding.
                pub selector: StorageEphemeralVolumeClaimTemplateSpecSelector,
                /// Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
                pub storage_class_name: String,
                /// volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.
                pub volume_mode: String,
                /// VolumeName is the binding reference to the PersistentVolume backing this claim.
                pub volume_name: String,
            }

            /// Spec defines the desired characteristics of a volume requested by a pod author. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpec {
                /// AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
                pub data_source: StorageVolumeClaimTemplateSpecDataSource,
                /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
                pub data_source_ref: StorageVolumeClaimTemplateSpecDataSourceRef,
                /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
                pub resources: StorageVolumeClaimTemplateSpecResources,
                /// A label query over volumes to consider for binding.
                pub selector: StorageVolumeClaimTemplateSpecSelector,
                /// Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
                pub storage_class_name: String,
                /// volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.
                pub volume_mode: String,
                /// VolumeName is the binding reference to the PersistentVolume backing this claim.
                pub volume_name: String,
            }

            /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpec {
                /// AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
                pub data_source: VolumesItemEphemeralVolumeClaimTemplateSpecDataSource,
                /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
                pub data_source_ref: VolumesItemEphemeralVolumeClaimTemplateSpecDataSourceRef,
                /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
                pub resources: VolumesItemEphemeralVolumeClaimTemplateSpecResources,
                /// A label query over volumes to consider for binding.
                pub selector: VolumesItemEphemeralVolumeClaimTemplateSpecSelector,
                /// Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
                pub storage_class_name: String,
                /// volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.
                pub volume_mode: String,
                /// VolumeName is the binding reference to the PersistentVolume backing this claim.
                pub volume_name: String,
            }

            /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbe {
                /// Exec specifies the action to take.
                pub exec: ContainersItemStartupProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: ContainersItemStartupProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemStartupProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: ContainersItemStartupProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbe {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemStartupProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: InitContainersItemStartupProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemStartupProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: InitContainersItemStartupProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Most recent observed status of the Prometheus cluster. Read-only. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Status {
                /// Total number of available pods (ready for at least minReadySeconds) targeted by this Prometheus deployment.
                pub available_replicas: i32,
                /// The current state of the Prometheus deployment.
                pub conditions: Vec<StatusConditionsItem>,
                /// Represents whether any actions on the underlying managed objects are being performed. Only delete actions will be performed.
                pub paused: bool,
                /// Total number of non-terminated pods targeted by this Prometheus deployment (their labels match the selector).
                pub replicas: i32,
                /// The list has one entry per shard. Each entry provides a summary of the shard status.
                pub shard_statuses: Vec<ShardStatusesItem>,
                /// Total number of unavailable pods targeted by this Prometheus deployment.
                pub unavailable_replicas: i32,
                /// Total number of non-terminated pods targeted by this Prometheus deployment that have the desired version spec.
                pub updated_replicas: i32,
            }

            /// Status represents the current information/status of a persistent volume claim. Read-only. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumeClaimTemplateStatus {
                /// AccessModes contains the actual access modes the volume backing the PVC has. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// The storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
                pub allocated_resources: AllocatedResources,
                /// Represents the actual resources of the underlying volume.
                pub capacity: Capacity,
                /// Current Condition of persistent volume claim. If underlying persistent volume is being resized then the Condition will be set to 'ResizeStarted'.
                pub conditions: Vec<VolumeClaimTemplateStatusConditionsItem>,
                /// Phase represents the current phase of PersistentVolumeClaim.
                pub phase: String,
                /// ResizeStatus stores status of resize operation. ResizeStatus is not set by default but when expansion is complete resizeStatus is set to empty string by resize controller or kubelet. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
                pub resize_status: String,
            }

            /// Storage spec to specify how storage shall be used.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Storage {
                /// Deprecated: subPath usage will be disabled by default in a future release, this option will become unnecessary. DisableMountSubPath allows to remove any subPath usage in volume mounts.
                pub disable_mount_sub_path: bool,
                /// EmptyDirVolumeSource to be used by the Prometheus StatefulSets. If specified, used in place of any volumeClaimTemplate. More info: https://kubernetes.io/docs/concepts/storage/volumes/#emptydir
                pub empty_dir: StorageEmptyDir,
                /// EphemeralVolumeSource to be used by the Prometheus StatefulSets. This is a beta field in k8s 1.21, for lower versions, starting with k8s 1.19, it requires enabling the GenericEphemeralVolume feature gate. More info: https://kubernetes.io/docs/concepts/storage/ephemeral-volumes/#generic-ephemeral-volumes
                pub ephemeral: StorageEphemeral,
                /// A PVC spec to be used by the Prometheus StatefulSets.
                pub volume_claim_template: StorageVolumeClaimTemplate,
            }

            /// StorageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Storageos {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.
                pub secret_ref: StorageosSecretRef,
                /// VolumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.
                pub volume_name: String,
                /// VolumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.
                pub volume_namespace: String,
            }

            /// Sysctl defines a kernel parameter to be set
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SysctlsItem {
                /// Name of a property to set
                pub name: String,
                /// Value of a property to set
                pub value: String,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Thanos configuration allows configuring various aspects of a Prometheus server in a Thanos environment.
            ///  This section is experimental, it may change significantly without deprecation notice in any release.
            ///  This is experimental and may change significantly without backward compatibility in any release.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Thanos {
                /// Thanos base image if other than default. Deprecated: use 'image' instead
                pub base_image: String,
                /// GRPCServerTLSConfig configures the gRPC server from which Thanos Querier reads recorded rule data. Note: Currently only the CAFile, CertFile, and KeyFile fields are supported. Maps to the '--grpc-server-tls-*' CLI args.
                pub grpc_server_tls_config: GrpcServerTlsConfig,
                /// Image if specified has precedence over baseImage, tag and sha combinations. Specifying the version is still necessary to ensure the Prometheus Operator knows what version of Thanos is being configured.
                pub image: String,
                /// ListenLocal makes the Thanos sidecar listen on loopback, so that it does not bind against the Pod IP.
                pub listen_local: bool,
                /// LogFormat for Thanos sidecar to be configured with.
                pub log_format: String,
                /// LogLevel for Thanos sidecar to be configured with.
                pub log_level: String,
                /// MinTime for Thanos sidecar to be configured with. Option can be a constant time in RFC3339 format or time duration relative to current time, such as -1d or 2h45m. Valid duration units are ms, s, m, h, d, w, y.
                pub min_time: String,
                /// ObjectStorageConfig configures object storage in Thanos. Alternative to ObjectStorageConfigFile, and lower order priority.
                pub object_storage_config: ObjectStorageConfig,
                /// ObjectStorageConfigFile specifies the path of the object storage configuration file. When used alongside with ObjectStorageConfig, ObjectStorageConfigFile takes precedence.
                pub object_storage_config_file: String,
                /// ReadyTimeout is the maximum time Thanos sidecar will wait for Prometheus to start. Eg 10m
                pub ready_timeout: String,
                /// Resources defines the resource requirements for the Thanos sidecar. If not provided, no requests/limits will be set
                pub resources: ThanosResources,
                /// SHA of Thanos container image to be deployed. Defaults to the value of `version`. Similar to a tag, but the SHA explicitly deploys an immutable container image. Version and Tag are ignored if SHA is set. Deprecated: use 'image' instead.  The image digest can be specified as part of the image URL.
                pub sha: String,
                /// Tag of Thanos sidecar container image to be deployed. Defaults to the value of `version`. Version is ignored if Tag is set. Deprecated: use 'image' instead.  The image tag can be specified as part of the image URL.
                pub tag: String,
                /// TracingConfig configures tracing in Thanos. This is an experimental feature, it may change in any upcoming release in a breaking way.
                pub tracing_config: TracingConfig,
                /// TracingConfig specifies the path of the tracing configuration file. When used alongside with TracingConfig, TracingConfigFile takes precedence.
                pub tracing_config_file: String,
                /// Version describes the version of Thanos to use.
                pub version: String,
                /// VolumeMounts allows configuration of additional VolumeMounts on the output StatefulSet definition. VolumeMounts specified will be appended to other VolumeMounts in the thanos-sidecar container.
                pub volume_mounts: Vec<ThanosVolumeMountsItem>,
            }

            /// TLS Config to use for alertmanager connection.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersItemTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: AlertmanagersItemTlsConfigCa,
                /// Path to the CA cert in the Prometheus container to use for the targets.
                pub ca_file: String,
                /// Struct containing the client cert file for the targets.
                pub cert: AlertmanagersItemTlsConfigCert,
                /// Path to the client cert file in the Prometheus container for the targets.
                pub cert_file: String,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Path to the client key file in the Prometheus container for the targets.
                pub key_file: String,
                /// Secret containing the client key file for the targets.
                pub key_secret: AlertmanagersItemTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS Config to use for accessing apiserver.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: ApiserverConfigTlsConfigCa,
                /// Path to the CA cert in the Prometheus container to use for the targets.
                pub ca_file: String,
                /// Struct containing the client cert file for the targets.
                pub cert: ApiserverConfigTlsConfigCert,
                /// Path to the client cert file in the Prometheus container for the targets.
                pub cert_file: String,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Path to the client key file in the Prometheus container for the targets.
                pub key_file: String,
                /// Secret containing the client key file for the targets.
                pub key_secret: ApiserverConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS Config to use for remote read.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: RemoteReadItemTlsConfigCa,
                /// Path to the CA cert in the Prometheus container to use for the targets.
                pub ca_file: String,
                /// Struct containing the client cert file for the targets.
                pub cert: RemoteReadItemTlsConfigCert,
                /// Path to the client cert file in the Prometheus container for the targets.
                pub cert_file: String,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Path to the client key file in the Prometheus container for the targets.
                pub key_file: String,
                /// Secret containing the client key file for the targets.
                pub key_secret: RemoteReadItemTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS Config to use for remote write.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: RemoteWriteItemTlsConfigCa,
                /// Path to the CA cert in the Prometheus container to use for the targets.
                pub ca_file: String,
                /// Struct containing the client cert file for the targets.
                pub cert: RemoteWriteItemTlsConfigCert,
                /// Path to the client cert file in the Prometheus container for the targets.
                pub cert_file: String,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Path to the client key file in the Prometheus container for the targets.
                pub key_file: String,
                /// Secret containing the client key file for the targets.
                pub key_secret: RemoteWriteItemTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// WebTLSConfig defines the TLS parameters for HTTPS.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebTlsConfig {
                /// Contains the TLS certificate for the server.
                pub cert: WebTlsConfigCert,
                /// List of supported cipher suites for TLS versions up to TLS 1.2. If empty, Go default cipher suites are used. Available cipher suites are documented in the go documentation: https://golang.org/pkg/crypto/tls/#pkg-constants
                pub cipher_suites: Vec<String>,
                /// Server policy for client authentication. Maps to ClientAuth Policies. For more detail on clientAuth options: https://golang.org/pkg/crypto/tls/#ClientAuthType
                pub client_auth_type: String,
                /// Contains the CA certificate for client certificate authentication to the server.
                pub client_ca: ClientCa,
                /// Elliptic curves that will be used in an ECDHE handshake, in preference order. Available curves are documented in the go documentation: https://golang.org/pkg/crypto/tls/#CurveID
                pub curve_preferences: Vec<String>,
                /// Secret containing the TLS key for the server.
                pub key_secret: WebTlsConfigKeySecret,
                /// Maximum TLS version that is acceptable. Defaults to TLS13.
                pub max_version: String,
                /// Minimum TLS version that is acceptable. Defaults to TLS12.
                pub min_version: String,
                /// Controls whether the server selects the client's most preferred cipher suite, or the server's most preferred cipher suite. If true then the server's preference, as expressed in the order of elements in cipherSuites, is used.
                pub prefer_server_cipher_suites: bool,
            }

            /// The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TolerationsItem {
                /// Effect indicates the taint effect to match. Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.
                pub effect: String,
                /// Key is the taint key that the toleration applies to. Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.
                pub key: String,
                /// Operator represents a key's relationship to the value. Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.
                pub operator: String,
                /// TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.
                pub toleration_seconds: i64,
                /// Value is the taint value the toleration matches to. If the operator is Exists, the value should be empty, otherwise just a regular string.
                pub value: String,
            }

            /// TopologySpreadConstraint specifies how to spread matching pods among the given topology.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItem {
                /// LabelSelector is used to find matching pods. Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.
                pub label_selector: TopologySpreadConstraintsItemLabelSelector,
                /// MaxSkew describes the degree to which pods may be unevenly distributed. When `whenUnsatisfiable=DoNotSchedule`, it is the maximum permitted difference between the number of matching pods in the target topology and the global minimum. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 1/1/0: | zone1 | zone2 | zone3 | |   P   |   P   |       | - if MaxSkew is 1, incoming pod can only be scheduled to zone3 to become 1/1/1; scheduling it onto zone1(zone2) would make the ActualSkew(2-0) on zone1(zone2) violate MaxSkew(1). - if MaxSkew is 2, incoming pod can be scheduled onto any zone. When `whenUnsatisfiable=ScheduleAnyway`, it is used to give higher precedence to topologies that satisfy it. It's a required field. Default value is 1 and 0 is not allowed.
                pub max_skew: i32,
                /// TopologyKey is the key of node labels. Nodes that have a label with this key and identical values are considered to be in the same topology. We consider each <key, value> as a "bucket", and try to put balanced number of pods into each bucket. It's a required field.
                pub topology_key: String,
                /// WhenUnsatisfiable indicates how to deal with a pod if it doesn't satisfy the spread constraint. - DoNotSchedule (default) tells the scheduler not to schedule it. - ScheduleAnyway tells the scheduler to schedule the pod in any location, but giving higher precedence to topologies that would help reduce the skew. A constraint is considered "Unsatisfiable" for an incoming pod if and only if every possible node assignment for that pod would violate "MaxSkew" on some topology. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 3/1/1: | zone1 | zone2 | zone3 | | P P P |   P   |   P   | If WhenUnsatisfiable is set to DoNotSchedule, incoming pod can only be scheduled to zone2(zone3) to become 3/2/1(3/1/2) as ActualSkew(2-1) on zone2(zone3) satisfies MaxSkew(1). In other words, the cluster can still be imbalanced, but scheduler won't make it *more* imbalanced. It's a required field.
                pub when_unsatisfiable: String,
            }

            /// TracingConfig configures tracing in Thanos. This is an experimental feature, it may change in any upcoming release in a breaking way.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TracingConfig {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiserverConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteReadItemBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RemoteWriteItemBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Source for the environment variable's value. Cannot be used if value is not empty.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFrom {
                /// Selects a key of a ConfigMap.
                pub config_map_key_ref: ContainersItemEnvItemValueFromConfigMapKeyRef,
                /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
                pub field_ref: ContainersItemEnvItemValueFromFieldRef,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
                pub resource_field_ref: ContainersItemEnvItemValueFromResourceFieldRef,
                /// Selects a key of a secret in the pod's namespace
                pub secret_key_ref: ContainersItemEnvItemValueFromSecretKeyRef,
            }

            /// Source for the environment variable's value. Cannot be used if value is not empty.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFrom {
                /// Selects a key of a ConfigMap.
                pub config_map_key_ref: InitContainersItemEnvItemValueFromConfigMapKeyRef,
                /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
                pub field_ref: InitContainersItemEnvItemValueFromFieldRef,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
                pub resource_field_ref: InitContainersItemEnvItemValueFromResourceFieldRef,
                /// Selects a key of a secret in the pod's namespace
                pub secret_key_ref: InitContainersItemEnvItemValueFromSecretKeyRef,
            }

            /// VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumeAttributes {
                /// VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// A PVC spec to be used by the Prometheus StatefulSets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplate {
                /// APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
                pub api_version: String,
                /// Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
                pub kind: String,
                /// EmbeddedMetadata contains metadata relevant to an EmbeddedResource.
                pub metadata: StorageVolumeClaimTemplateMetadata,
                /// Spec defines the desired characteristics of a volume requested by a pod author. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub spec: StorageVolumeClaimTemplateSpec,
                /// Status represents the current information/status of a persistent volume claim. Read-only. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub status: VolumeClaimTemplateStatus,
            }

            /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
            ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
            ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
            ///  Required, must not be nil.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplate {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub metadata: StorageEphemeralVolumeClaimTemplateMetadata,
                /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
                pub spec: StorageEphemeralVolumeClaimTemplateSpec,
            }

            /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
            ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
            ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
            ///  Required, must not be nil.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplate {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub metadata: VolumesItemEphemeralVolumeClaimTemplateMetadata,
                /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
                pub spec: VolumesItemEphemeralVolumeClaimTemplateSpec,
            }

            /// volumeDevice describes a mapping of a raw block device within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemVolumeDevicesItem {
                /// devicePath is the path inside of the container that the device will be mapped to.
                pub device_path: String,
                /// name must match the name of a persistentVolumeClaim in the pod
                pub name: String,
            }

            /// volumeDevice describes a mapping of a raw block device within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemVolumeDevicesItem {
                /// devicePath is the path inside of the container that the device will be mapped to.
                pub device_path: String,
                /// name must match the name of a persistentVolumeClaim in the pod
                pub name: String,
            }

            /// VolumeMount describes a mounting of a Volume within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecVolumeMountsItem {
                /// Path within the container at which the volume should be mounted.  Must not contain ':'.
                pub mount_path: String,
                /// mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.
                pub mount_propagation: String,
                /// This must match the Name of a Volume.
                pub name: String,
                /// Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.
                pub read_only: bool,
                /// Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).
                pub sub_path: String,
                /// Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.
                pub sub_path_expr: String,
            }

            /// VolumeMount describes a mounting of a Volume within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemVolumeMountsItem {
                /// Path within the container at which the volume should be mounted.  Must not contain ':'.
                pub mount_path: String,
                /// mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.
                pub mount_propagation: String,
                /// This must match the Name of a Volume.
                pub name: String,
                /// Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.
                pub read_only: bool,
                /// Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).
                pub sub_path: String,
                /// Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.
                pub sub_path_expr: String,
            }

            /// VolumeMount describes a mounting of a Volume within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemVolumeMountsItem {
                /// Path within the container at which the volume should be mounted.  Must not contain ':'.
                pub mount_path: String,
                /// mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.
                pub mount_propagation: String,
                /// This must match the Name of a Volume.
                pub name: String,
                /// Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.
                pub read_only: bool,
                /// Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).
                pub sub_path: String,
                /// Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.
                pub sub_path_expr: String,
            }

            /// VolumeMount describes a mounting of a Volume within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ThanosVolumeMountsItem {
                /// Path within the container at which the volume should be mounted.  Must not contain ':'.
                pub mount_path: String,
                /// mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.
                pub mount_propagation: String,
                /// This must match the Name of a Volume.
                pub name: String,
                /// Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.
                pub read_only: bool,
                /// Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).
                pub sub_path: String,
                /// Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.
                pub sub_path_expr: String,
            }

            /// Volume represents a named volume in a pod that may be accessed by any container in the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItem {
                /// AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
                pub aws_elastic_block_store: AwsElasticBlockStore,
                /// AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.
                pub azure_disk: AzureDisk,
                /// AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
                pub azure_file: AzureFile,
                /// CephFS represents a Ceph FS mount on the host that shares a pod's lifetime
                pub cephfs: Cephfs,
                /// Cinder represents a cinder volume attached and mounted on kubelets host machine. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub cinder: Cinder,
                /// ConfigMap represents a configMap that should populate this volume
                pub config_map: VolumesItemConfigMap,
                /// CSI (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).
                pub csi: Csi,
                /// DownwardAPI represents downward API about the pod that should populate this volume
                pub downward_a_p_i: VolumesItemDownwardAPI,
                /// EmptyDir represents a temporary directory that shares a pod's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
                pub empty_dir: VolumesItemEmptyDir,
                /// Ephemeral represents a volume that is handled by a cluster storage driver. The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts, and deleted when the pod is removed.
                ///  Use this if: a) the volume is only needed while the pod runs, b) features of normal volumes like restoring from snapshot or capacity tracking are needed, c) the storage driver is specified through a storage class, and d) the storage driver supports dynamic volume provisioning through a PersistentVolumeClaim (see EphemeralVolumeSource for more information on the connection between this volume type and PersistentVolumeClaim).
                ///  Use PersistentVolumeClaim or one of the vendor-specific APIs for volumes that persist for longer than the lifecycle of an individual pod.
                ///  Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to be used that way - see the documentation of the driver for more information.
                ///  A pod can use both types of ephemeral volumes and persistent volumes at the same time.
                pub ephemeral: VolumesItemEphemeral,
                /// FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.
                pub fc: Fc,
                /// FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.
                pub flex_volume: FlexVolume,
                /// Flocker represents a Flocker volume attached to a kubelet's host machine. This depends on the Flocker control service being running
                pub flocker: Flocker,
                /// GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub gce_persistent_disk: GcePersistentDisk,
                /// GitRepo represents a git repository at a particular revision. DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.
                pub git_repo: GitRepo,
                /// Glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/glusterfs/README.md
                pub glusterfs: Glusterfs,
                /// HostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath --- TODO(jonesdl) We need to restrict who can use host directory mounts and who can/can not mount host directories as read/write.
                pub host_path: HostPath,
                /// ISCSI represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://examples.k8s.io/volumes/iscsi/README.md
                pub iscsi: Iscsi,
                /// Volume's name. Must be a DNS_LABEL and unique within the pod. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
                pub name: String,
                /// NFS represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub nfs: Nfs,
                /// PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub persistent_volume_claim: PersistentVolumeClaim,
                /// PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine
                pub photon_persistent_disk: PhotonPersistentDisk,
                /// PortworxVolume represents a portworx volume attached and mounted on kubelets host machine
                pub portworx_volume: PortworxVolume,
                /// Items for all in one resources secrets, configmaps, and downward API
                pub projected: Projected,
                /// Quobyte represents a Quobyte mount on the host that shares a pod's lifetime
                pub quobyte: Quobyte,
                /// RBD represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/rbd/README.md
                pub rbd: Rbd,
                /// ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.
                pub scale_i_o: ScaleIO,
                /// Secret represents a secret that should populate this volume. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
                pub secret: VolumesItemSecret,
                /// StorageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.
                pub storageos: Storageos,
                /// VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine
                pub vsphere_volume: VsphereVolume,
            }

            /// VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VsphereVolume {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.
                pub storage_policy_i_d: String,
                /// Storage Policy Based Management (SPBM) profile name.
                pub storage_policy_name: String,
                /// Path that identifies vSphere volume vmdk
                pub volume_path: String,
            }

            /// WebSpec defines the web command line flags when starting Prometheus.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Web {
                /// The prometheus web page title
                pub page_title: String,
                /// WebTLSConfig defines the TLS parameters for HTTPS.
                pub tls_config: WebTlsConfig,
            }

            /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextWindowsOptions {
                /// GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.
                pub gmsa_credential_spec: String,
                /// GMSACredentialSpecName is the name of the GMSA credential spec to use.
                pub gmsa_credential_spec_name: String,
                /// HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.
                pub host_process: bool,
                /// The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_user_name: String,
            }

            /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextWindowsOptions {
                /// GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.
                pub gmsa_credential_spec: String,
                /// GMSACredentialSpecName is the name of the GMSA credential spec to use.
                pub gmsa_credential_spec_name: String,
                /// HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.
                pub host_process: bool,
                /// The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_user_name: String,
            }

            /// The Windows specific settings applied to all containers. If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContextWindowsOptions {
                /// GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.
                pub gmsa_credential_spec: String,
                /// GMSACredentialSpecName is the name of the GMSA credential spec to use.
                pub gmsa_credential_spec_name: String,
                /// HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.
                pub host_process: bool,
                /// The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_user_name: String,
            }

            /// RelabelConfig allows dynamic rewriting of the label set, being applied to samples before ingestion. It defines `<metric_relabel_configs>`-section of Prometheus configuration. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#metric_relabel_configs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WriteRelabelConfigsItem {
                /// Action to perform based on regex matching. Default is 'replace'
                pub action: String,
                /// Modulus to take of the hash of the source label values.
                pub modulus: i64,
                /// Regular expression against which the extracted value is matched. Default is '(.*)'
                pub regex: String,
                /// Replacement value against which a regex replace is performed if the regular expression matches. Regex capture groups are available. Default is '$1'
                pub replacement: String,
                /// Separator placed between concatenated source label values. default is ';'.
                pub separator: String,
                /// The source labels select values from existing labels. Their content is concatenated using the configured separator and matched against the configured regular expression for the replace, keep, and drop actions.
                pub source_labels: Vec<String>,
                /// Label to which the resulting value is written in a replace action. It is mandatory for replace actions. Regex capture groups are available.
                pub target_label: String,
            }
        }
        pub mod prometheus_rule {
            /// PrometheusRule defines recording and alerting rules for a Prometheus instance
            #[derive(serde::Deserialize, Debug, PartialEq)]
            pub struct PrometheusRule {
                pub metadata: k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta,
                pub spec: Spec,
            }

            impl k8s_openapi::Resource for PrometheusRule {
                type Scope = k8s_openapi::ClusterResourceScope;

                const API_VERSION: &'static str = "monitoring.coreos.com/v1";
                const GROUP: &'static str = "monitoring.coreos.com";
                const KIND: &'static str = "PrometheusRule";
                const VERSION: &'static str = "v1";
                const URL_PATH_SEGMENT: &'static str = "";
            }

            impl k8s_openapi::Metadata for PrometheusRule {
                type Ty = k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta;

                fn metadata(&self) -> &<Self as k8s_openapi::Metadata>::Ty {
                    &self.metadata
                }

                fn metadata_mut(&mut self) -> &mut <Self as k8s_openapi::Metadata>::Ty {
                    &mut self.metadata
                }
            }

            impl serde::Serialize for PrometheusRule {
                fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
                where
                    S: serde::Serializer,
                {
                    use serde::ser::SerializeStruct;
                    let mut state = serializer.serialize_struct("PrometheusRule", 4)?;
                    state.serialize_field(
                        "apiVersion",
                        <Self as k8s_openapi::Resource>::API_VERSION,
                    )?;
                    state.serialize_field("kind", <Self as k8s_openapi::Resource>::KIND)?;
                    state.serialize_field("metadata", &self.metadata)?;
                    state.serialize_field("spec", &self.spec)?;
                    state.end()
                }
            }

            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Annotations {
                pub properties: std::collections::HashMap<String, String>,
            }

            /// RuleGroup is a list of sequentially evaluated recording and alerting rules. Note: PartialResponseStrategy is only used by ThanosRuler and will be ignored by Prometheus instances.  Valid values for this field are 'warn' or 'abort'.  More info: https://github.com/thanos-io/thanos/blob/main/docs/components/rule.md#partial-response
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GroupsItem {
                pub interval: String,
                pub name: String,
                pub partial_response_strategy: String,
                pub rules: Vec<RulesItem>,
            }

            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Labels {
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Rule describes an alerting or recording rule See Prometheus documentation: [alerting](https://www.prometheus.io/docs/prometheus/latest/configuration/alerting_rules/) or [recording](https://www.prometheus.io/docs/prometheus/latest/configuration/recording_rules/#recording-rules) rule
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RulesItem {
                pub alert: String,
                pub annotations: Annotations,
                pub expr: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                pub r#for: String,
                pub labels: Labels,
                pub record: String,
            }

            /// Specification of desired alerting rule definitions for Prometheus.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Spec {
                /// Content of Prometheus rule file
                pub groups: Vec<GroupsItem>,
            }
        }
        pub mod service_monitor {
            /// ServiceMonitor defines monitoring for a set of services.
            #[derive(serde::Deserialize, Debug, PartialEq)]
            pub struct ServiceMonitor {
                pub metadata: k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta,
                pub spec: Spec,
            }

            impl k8s_openapi::Resource for ServiceMonitor {
                type Scope = k8s_openapi::ClusterResourceScope;

                const API_VERSION: &'static str = "monitoring.coreos.com/v1";
                const GROUP: &'static str = "monitoring.coreos.com";
                const KIND: &'static str = "ServiceMonitor";
                const VERSION: &'static str = "v1";
                const URL_PATH_SEGMENT: &'static str = "";
            }

            impl k8s_openapi::Metadata for ServiceMonitor {
                type Ty = k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta;

                fn metadata(&self) -> &<Self as k8s_openapi::Metadata>::Ty {
                    &self.metadata
                }

                fn metadata_mut(&mut self) -> &mut <Self as k8s_openapi::Metadata>::Ty {
                    &mut self.metadata
                }
            }

            impl serde::Serialize for ServiceMonitor {
                fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
                where
                    S: serde::Serializer,
                {
                    use serde::ser::SerializeStruct;
                    let mut state = serializer.serialize_struct("ServiceMonitor", 4)?;
                    state.serialize_field(
                        "apiVersion",
                        <Self as k8s_openapi::Resource>::API_VERSION,
                    )?;
                    state.serialize_field("kind", <Self as k8s_openapi::Resource>::KIND)?;
                    state.serialize_field("metadata", &self.metadata)?;
                    state.serialize_field("spec", &self.spec)?;
                    state.end()
                }
            }

            /// Authorization section for this endpoint
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Authorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: Credentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// BasicAuth allow an endpoint to authenticate over basic authentication More info: https://prometheus.io/docs/operating/configuration/#endpoints
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct BasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: Password,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: Username,
            }

            /// Secret to mount to read bearer token for scraping targets. The secret needs to be in the same namespace as the service monitor and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct BearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Ca {
                /// ConfigMap containing data to use for the targets.
                pub config_map: CaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: CaSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: CertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: CertSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: ClientIdSecret,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Credentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Endpoint defines a scrapeable endpoint serving Prometheus metrics.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EndpointsItem {
                /// Authorization section for this endpoint
                pub authorization: Authorization,
                /// BasicAuth allow an endpoint to authenticate over basic authentication More info: https://prometheus.io/docs/operating/configuration/#endpoints
                pub basic_auth: BasicAuth,
                /// File to read bearer token for scraping targets.
                pub bearer_token_file: String,
                /// Secret to mount to read bearer token for scraping targets. The secret needs to be in the same namespace as the service monitor and accessible by the Prometheus Operator.
                pub bearer_token_secret: BearerTokenSecret,
                /// FollowRedirects configures whether scrape requests follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// HonorLabels chooses the metric's labels on collisions with target labels.
                pub honor_labels: bool,
                /// HonorTimestamps controls whether Prometheus respects the timestamps present in scraped data.
                pub honor_timestamps: bool,
                /// Interval at which metrics should be scraped If not specified Prometheus' global scrape interval is used.
                pub interval: String,
                /// MetricRelabelConfigs to apply to samples before ingestion.
                pub metric_relabelings: Vec<MetricRelabelingsItem>,
                /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
                pub oauth2: Oauth2,
                /// Optional HTTP URL parameters
                pub params: Params,
                /// HTTP path to scrape for metrics.
                pub path: String,
                /// Name of the service port this endpoint refers to. Mutually exclusive with targetPort.
                pub port: String,
                /// ProxyURL eg http://proxyserver:2195 Directs scrapes to proxy through this endpoint.
                pub proxy_url: String,
                /// RelabelConfigs to apply to samples before scraping. Prometheus Operator automatically adds relabelings for a few standard Kubernetes fields. The original scrape job's name is available via the `__tmp_prometheus_job_name` label. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#relabel_config
                pub relabelings: Vec<RelabelingsItem>,
                /// HTTP scheme to use for scraping.
                pub scheme: String,
                /// Timeout after which the scrape is ended If not specified, the Prometheus global scrape timeout is used unless it is less than `Interval` in which the latter is used.
                pub scrape_timeout: String,
                /// Name or number of the target port of the Pod behind the Service, the port must be specified with container port property. Mutually exclusive with port.
                pub target_port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// TLS configuration to use when scraping the endpoint
                pub tls_config: TlsConfig,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct KeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// RelabelConfig allows dynamic rewriting of the label set, being applied to samples before ingestion. It defines `<metric_relabel_configs>`-section of Prometheus configuration. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#metric_relabel_configs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetricRelabelingsItem {
                /// Action to perform based on regex matching. Default is 'replace'
                pub action: String,
                /// Modulus to take of the hash of the source label values.
                pub modulus: i64,
                /// Regular expression against which the extracted value is matched. Default is '(.*)'
                pub regex: String,
                /// Replacement value against which a regex replace is performed if the regular expression matches. Regex capture groups are available. Default is '$1'
                pub replacement: String,
                /// Separator placed between concatenated source label values. default is ';'.
                pub separator: String,
                /// The source labels select values from existing labels. Their content is concatenated using the configured separator and matched against the configured regular expression for the replace, keep, and drop actions.
                pub source_labels: Vec<String>,
                /// Label to which the resulting value is written in a replace action. It is mandatory for replace actions. Regex capture groups are available.
                pub target_label: String,
            }

            /// Selector to select which namespaces the Kubernetes Endpoints objects are discovered from.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NamespaceSelector {
                /// Boolean describing whether all namespaces are selected in contrast to a list restricting them.
                pub any: bool,
                /// List of namespace names to select from.
                pub match_names: Vec<String>,
            }

            /// OAuth2 for the URL. Only valid in Prometheus versions 2.27.0 and newer.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Oauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// Optional HTTP URL parameters
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Params {
                /// Optional HTTP URL parameters
                pub properties: std::collections::HashMap<String, Vec<String>>,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Password {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// RelabelConfig allows dynamic rewriting of the label set, being applied to samples before ingestion. It defines `<metric_relabel_configs>`-section of Prometheus configuration. More info: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#metric_relabel_configs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RelabelingsItem {
                /// Action to perform based on regex matching. Default is 'replace'
                pub action: String,
                /// Modulus to take of the hash of the source label values.
                pub modulus: i64,
                /// Regular expression against which the extracted value is matched. Default is '(.*)'
                pub regex: String,
                /// Replacement value against which a regex replace is performed if the regular expression matches. Regex capture groups are available. Default is '$1'
                pub replacement: String,
                /// Separator placed between concatenated source label values. default is ';'.
                pub separator: String,
                /// The source labels select values from existing labels. Their content is concatenated using the configured separator and matched against the configured regular expression for the replace, keep, and drop actions.
                pub source_labels: Vec<String>,
                /// Label to which the resulting value is written in a replace action. It is mandatory for replace actions. Regex capture groups are available.
                pub target_label: String,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Selector to select Endpoints objects.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Selector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<MatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: MatchLabels,
            }

            /// Specification of desired Service selection for target discovery by Prometheus.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Spec {
                /// A list of endpoints allowed as part of this ServiceMonitor.
                pub endpoints: Vec<EndpointsItem>,
                /// Chooses the label of the Kubernetes `Endpoints`. Its value will be used for the `job`-label's value of the created metrics.
                ///  Default & fallback value: the name of the respective Kubernetes `Endpoint`.
                pub job_label: String,
                /// Per-scrape limit on number of labels that will be accepted for a sample. Only valid in Prometheus versions 2.27.0 and newer.
                pub label_limit: i64,
                /// Per-scrape limit on length of labels name that will be accepted for a sample. Only valid in Prometheus versions 2.27.0 and newer.
                pub label_name_length_limit: i64,
                /// Per-scrape limit on length of labels value that will be accepted for a sample. Only valid in Prometheus versions 2.27.0 and newer.
                pub label_value_length_limit: i64,
                /// Selector to select which namespaces the Kubernetes Endpoints objects are discovered from.
                pub namespace_selector: NamespaceSelector,
                /// PodTargetLabels transfers labels on the Kubernetes `Pod` onto the created metrics.
                pub pod_target_labels: Vec<String>,
                /// SampleLimit defines per-scrape limit on number of scraped samples that will be accepted.
                pub sample_limit: i64,
                /// Selector to select Endpoints objects.
                pub selector: Selector,
                /// TargetLabels transfers labels from the Kubernetes `Service` onto the created metrics.
                pub target_labels: Vec<String>,
                /// TargetLimit defines a limit on the number of scraped targets that will be accepted.
                pub target_limit: i64,
            }

            /// TLS configuration to use when scraping the endpoint
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: Ca,
                /// Path to the CA cert in the Prometheus container to use for the targets.
                pub ca_file: String,
                /// Struct containing the client cert file for the targets.
                pub cert: Cert,
                /// Path to the client cert file in the Prometheus container for the targets.
                pub cert_file: String,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Path to the client key file in the Prometheus container for the targets.
                pub key_file: String,
                /// Secret containing the client key file for the targets.
                pub key_secret: KeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Username {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }
        }
        pub mod thanos_ruler {
            /// ThanosRuler defines a ThanosRuler deployment.
            #[derive(serde::Deserialize, Debug, PartialEq)]
            pub struct ThanosRuler {
                pub metadata: k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta,
                pub spec: Spec,
                pub status: Status,
            }

            impl k8s_openapi::Resource for ThanosRuler {
                type Scope = k8s_openapi::ClusterResourceScope;

                const API_VERSION: &'static str = "monitoring.coreos.com/v1";
                const GROUP: &'static str = "monitoring.coreos.com";
                const KIND: &'static str = "ThanosRuler";
                const VERSION: &'static str = "v1";
                const URL_PATH_SEGMENT: &'static str = "";
            }

            impl k8s_openapi::Metadata for ThanosRuler {
                type Ty = k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta;

                fn metadata(&self) -> &<Self as k8s_openapi::Metadata>::Ty {
                    &self.metadata
                }

                fn metadata_mut(&mut self) -> &mut <Self as k8s_openapi::Metadata>::Ty {
                    &mut self.metadata
                }
            }

            impl serde::Serialize for ThanosRuler {
                fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
                where
                    S: serde::Serializer,
                {
                    use serde::ser::SerializeStruct;
                    let mut state = serializer.serialize_struct("ThanosRuler", 5)?;
                    state.serialize_field(
                        "apiVersion",
                        <Self as k8s_openapi::Resource>::API_VERSION,
                    )?;
                    state.serialize_field("kind", <Self as k8s_openapi::Resource>::KIND)?;
                    state.serialize_field("metadata", &self.metadata)?;
                    state.serialize_field("spec", &self.spec)?;
                    state.serialize_field("status", &self.status)?;
                    state.end()
                }
            }

            /// If specified, the pod's scheduling constraints.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Affinity {
                /// Describes node affinity scheduling rules for the pod.
                pub node_affinity: NodeAffinity,
                /// Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).
                pub pod_affinity: PodAffinity,
                /// Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).
                pub pod_anti_affinity: PodAntiAffinity,
            }

            /// AlertRelabelConfigs configures alert relabeling in ThanosRuler. Alert relabel configurations must have the form as specified in the official Prometheus documentation: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#alert_relabel_configs Alternative to AlertRelabelConfigFile, and lower order priority.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertRelabelConfigs {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Define configuration for connecting to alertmanager.  Only available with thanos v0.10.0 and higher.  Maps to the `alertmanagers.config` arg.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AlertmanagersConfig {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AllocatedResources {
                /// The storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetadataAnnotations {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetadataAnnotations {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub properties: std::collections::HashMap<String, String>,
            }

            /// AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AwsElasticBlockStore {
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).
                pub partition: i32,
                /// Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". If omitted, the default is "false". More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
                pub read_only: bool,
                /// Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
                pub volume_i_d: String,
            }

            /// AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AzureDisk {
                /// Host Caching mode: None, Read Only, Read Write.
                pub caching_mode: String,
                /// The Name of the data disk in the blob storage
                pub disk_name: String,
                /// The URI the data disk in the blob storage
                pub disk_u_r_i: String,
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Expected values Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set). defaults to shared
                pub kind: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
            }

            /// AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AzureFile {
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// the name of secret that contains Azure Storage Account Name and Key
                pub secret_name: String,
                /// Share Name
                pub share_name: String,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Ca {
                /// ConfigMap containing data to use for the targets.
                pub config_map: CaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: CaSecret,
            }

            /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextCapabilities {
                /// Added capabilities
                pub add: Vec<String>,
                /// Removed capabilities
                pub drop: Vec<String>,
            }

            /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextCapabilities {
                /// Added capabilities
                pub add: Vec<String>,
                /// Removed capabilities
                pub drop: Vec<String>,
            }

            /// Represents the actual resources of the underlying volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Capacity {
                /// Represents the actual resources of the underlying volume.
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// CephFS represents a Ceph FS mount on the host that shares a pod's lifetime
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cephfs {
                /// Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub monitors: Vec<String>,
                /// Optional: Used as the mounted root, rather than the full Ceph tree, default is /
                pub path: String,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub read_only: bool,
                /// Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub secret_file: String,
                /// Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub secret_ref: CephfsSecretRef,
                /// Optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
                pub user: String,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: CertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: CertSecret,
            }

            /// Cinder represents a cinder volume attached and mounted on kubelets host machine. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Cinder {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub fs_type: String,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub read_only: bool,
                /// Optional: points to a secret object containing parameters used to connect to OpenStack.
                pub secret_ref: CinderSecretRef,
                /// volume id used to identify the volume in cinder. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub volume_i_d: String,
            }

            /// PersistentVolumeClaimCondition contails details about state of pvc
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ConditionsItem {
                /// Last time we probed the condition.
                pub last_probe_time: String,
                /// Last time the condition transitioned from one status to another.
                pub last_transition_time: String,
                /// Human-readable message indicating details about last transition.
                pub message: String,
                /// Unique, this should be a short, machine understandable string that gives the reason for condition's last transition. If it reports "ResizeStarted" that means the underlying persistent volume is being resized.
                pub reason: String,
                pub status: String,
                /// PersistentVolumeClaimConditionType is a valid value of PersistentVolumeClaimCondition.Type
                pub r#type: String,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap represents a configMap that should populate this volume
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemConfigMap {
                /// Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<VolumesItemConfigMapItemsItem>,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its keys must be defined
                pub optional: bool,
            }

            /// information about the configMap data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemConfigMap {
                /// If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<SourcesItemConfigMapItemsItem>,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its keys must be defined
                pub optional: bool,
            }

            /// Selects a key of a ConfigMap.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromConfigMapKeyRef {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a ConfigMap.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromConfigMapKeyRef {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// The ConfigMap to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvFromItemConfigMapRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap must be defined
                pub optional: bool,
            }

            /// The ConfigMap to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvFromItemConfigMapRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap must be defined
                pub optional: bool,
            }

            /// A single application container that you want to run within a pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItem {
                /// Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub args: Vec<String>,
                /// Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub command: Vec<String>,
                /// List of environment variables to set in the container. Cannot be updated.
                pub env: Vec<ContainersItemEnvItem>,
                /// List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.
                pub env_from: Vec<ContainersItemEnvFromItem>,
                /// Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.
                pub image: String,
                /// Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images
                pub image_pull_policy: String,
                /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
                pub lifecycle: ContainersItemLifecycle,
                /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub liveness_probe: ContainersItemLivenessProbe,
                /// Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.
                pub name: String,
                /// List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Cannot be updated.
                pub ports: Vec<ContainersItemPortsItem>,
                /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub readiness_probe: ContainersItemReadinessProbe,
                /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub resources: ContainersItemResources,
                /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
                pub security_context: ContainersItemSecurityContext,
                /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub startup_probe: ContainersItemStartupProbe,
                /// Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.
                pub stdin: bool,
                /// Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false
                pub stdin_once: bool,
                /// Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.
                pub termination_message_path: String,
                /// Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.
                pub termination_message_policy: String,
                /// Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.
                pub tty: bool,
                /// volumeDevices is the list of block devices to be used by the container.
                pub volume_devices: Vec<ContainersItemVolumeDevicesItem>,
                /// Pod volumes to mount into the container's filesystem. Cannot be updated.
                pub volume_mounts: Vec<ContainersItemVolumeMountsItem>,
                /// Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.
                pub working_dir: String,
            }

            /// CSI (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Csi {
                /// Driver is the name of the CSI driver that handles this volume. Consult with your admin for the correct name as registered in the cluster.
                pub driver: String,
                /// Filesystem type to mount. Ex. "ext4", "xfs", "ntfs". If not provided, the empty value is passed to the associated CSI driver which will determine the default filesystem to apply.
                pub fs_type: String,
                /// NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.
                pub node_publish_secret_ref: NodePublishSecretRef,
                /// Specifies a read-only configuration for the volume. Defaults to false (read/write).
                pub read_only: bool,
                /// VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
                pub volume_attributes: VolumeAttributes,
            }

            /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecDataSource {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecDataSource {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecDataSource {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecDataSourceRef {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecDataSourceRef {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecDataSourceRef {
                /// APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.
                pub api_group: String,
                /// Kind is the type of resource being referenced
                pub kind: String,
                /// Name is the name of resource being referenced
                pub name: String,
            }

            /// DownwardAPI represents downward API about the pod that should populate this volume
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPI {
                /// Optional: mode bits to use on created files by default. Must be a Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// Items is a list of downward API volume file
                pub items: Vec<VolumesItemDownwardAPIItemsItem>,
            }

            /// information about the downwardAPI data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPI {
                /// Items is a list of DownwardAPIVolume file
                pub items: Vec<SourcesItemDownwardAPIItemsItem>,
            }

            /// EmptyDirVolumeSource to be used by the Prometheus StatefulSets. If specified, used in place of any volumeClaimTemplate. More info: https://kubernetes.io/docs/concepts/storage/volumes/#emptydir
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEmptyDir {
                /// What type of storage medium should back this directory. The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
                pub medium: String,
                /// Total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir
                pub size_limit: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// EmptyDir represents a temporary directory that shares a pod's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEmptyDir {
                /// What type of storage medium should back this directory. The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
                pub medium: String,
                /// Total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir
                pub size_limit: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// EnvFromSource represents the source of a set of ConfigMaps
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvFromItem {
                /// The ConfigMap to select from
                pub config_map_ref: ContainersItemEnvFromItemConfigMapRef,
                /// An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.
                pub prefix: String,
                /// The Secret to select from
                pub secret_ref: ContainersItemEnvFromItemSecretRef,
            }

            /// EnvFromSource represents the source of a set of ConfigMaps
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvFromItem {
                /// The ConfigMap to select from
                pub config_map_ref: InitContainersItemEnvFromItemConfigMapRef,
                /// An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.
                pub prefix: String,
                /// The Secret to select from
                pub secret_ref: InitContainersItemEnvFromItemSecretRef,
            }

            /// EnvVar represents an environment variable present in a Container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItem {
                /// Name of the environment variable. Must be a C_IDENTIFIER.
                pub name: String,
                /// Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "".
                pub value: String,
                /// Source for the environment variable's value. Cannot be used if value is not empty.
                pub value_from: ContainersItemEnvItemValueFrom,
            }

            /// EnvVar represents an environment variable present in a Container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItem {
                /// Name of the environment variable. Must be a C_IDENTIFIER.
                pub name: String,
                /// Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "".
                pub value: String,
                /// Source for the environment variable's value. Cannot be used if value is not empty.
                pub value_from: InitContainersItemEnvItemValueFrom,
            }

            /// EphemeralVolumeSource to be used by the Prometheus StatefulSets. This is a beta field in k8s 1.21, for lower versions, starting with k8s 1.19, it requires enabling the GenericEphemeralVolume feature gate. More info: https://kubernetes.io/docs/concepts/storage/ephemeral-volumes/#generic-ephemeral-volumes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeral {
                /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
                ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
                ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
                ///  Required, must not be nil.
                pub volume_claim_template: StorageEphemeralVolumeClaimTemplate,
            }

            /// Ephemeral represents a volume that is handled by a cluster storage driver. The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts, and deleted when the pod is removed.
            ///  Use this if: a) the volume is only needed while the pod runs, b) features of normal volumes like restoring from snapshot or capacity tracking are needed, c) the storage driver is specified through a storage class, and d) the storage driver supports dynamic volume provisioning through a PersistentVolumeClaim (see EphemeralVolumeSource for more information on the connection between this volume type and PersistentVolumeClaim).
            ///  Use PersistentVolumeClaim or one of the vendor-specific APIs for volumes that persist for longer than the lifecycle of an individual pod.
            ///  Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to be used that way - see the documentation of the driver for more information.
            ///  A pod can use both types of ephemeral volumes and persistent volumes at the same time.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeral {
                /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
                ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
                ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
                ///  Required, must not be nil.
                pub volume_claim_template: VolumesItemEphemeralVolumeClaimTemplate,
            }

            /// ObjectReference references a PodMonitor, ServiceMonitor, Probe or PrometheusRule object.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ExcludedFromEnforcementItem {
                /// Group of the referent. When not specified, it defaults to `monitoring.coreos.com`
                pub group: String,
                /// Name of the referent. When not set, all resources are matched.
                pub name: String,
                /// Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/
                pub namespace: String,
                /// Resource of the referent.
                pub resource: String,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// Exec specifies the action to take.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeExec {
                /// Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
                pub command: Vec<String>,
            }

            /// FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Fc {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// Optional: FC target lun number
                pub lun: i32,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// Optional: FC target worldwide names (WWNs)
                pub target_w_w_ns: Vec<String>,
                /// Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.
                pub wwids: Vec<String>,
            }

            /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPIItemsItemFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPIItemsItemFieldRef {
                /// Version of the schema the FieldPath is written in terms of, defaults to "v1".
                pub api_version: String,
                /// Path of the field to select in the specified API version.
                pub field_path: String,
            }

            /// FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct FlexVolume {
                /// Driver is the name of the driver to use for this volume.
                pub driver: String,
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.
                pub fs_type: String,
                /// Optional: Extra command options if any.
                pub options: Options,
                /// Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.
                pub secret_ref: FlexVolumeSecretRef,
            }

            /// Flocker represents a Flocker volume attached to a kubelet's host machine. This depends on the Flocker control service being running
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Flocker {
                /// Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated
                pub dataset_name: String,
                /// UUID of the dataset. This is unique identifier of a Flocker dataset
                pub dataset_u_u_i_d: String,
            }

            /// GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GcePersistentDisk {
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub partition: i32,
                /// Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub pd_name: String,
                /// ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub read_only: bool,
            }

            /// GitRepo represents a git repository at a particular revision. DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GitRepo {
                /// Target directory name. Must not contain or start with '..'.  If '.' is supplied, the volume directory will be the git repository.  Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name.
                pub directory: String,
                /// Repository URL
                pub repository: String,
                /// Commit hash for the specified revision.
                pub revision: String,
            }

            /// Glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/glusterfs/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Glusterfs {
                /// EndpointsName is the endpoint name that details Glusterfs topology. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
                pub endpoints: String,
                /// Path is the Glusterfs volume path. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
                pub path: String,
                /// ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
                pub read_only: bool,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeGrpc {
                /// Port number of the gRPC service. Number must be in the range 1 to 65535.
                pub port: i32,
                /// Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).
                ///  If this is not specified, the default behavior is defined by gRPC.
                pub service: String,
            }

            /// GRPCServerTLSConfig configures the gRPC server from which Thanos Querier reads recorded rule data. Note: Currently only the CAFile, CertFile, and KeyFile fields are supported. Maps to the '--grpc-server-tls-*' CLI args.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct GrpcServerTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: Ca,
                /// Path to the CA cert in the Prometheus container to use for the targets.
                pub ca_file: String,
                /// Struct containing the client cert file for the targets.
                pub cert: Cert,
                /// Path to the client cert file in the Prometheus container for the targets.
                pub cert_file: String,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Path to the client key file in the Prometheus container for the targets.
                pub key_file: String,
                /// Secret containing the client key file for the targets.
                pub key_secret: KeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct HostAliasesItem {
                /// Hostnames for the above IP address.
                pub hostnames: Vec<String>,
                /// IP address of the host file entry.
                pub ip: String,
            }

            /// HostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath --- TODO(jonesdl) We need to restrict who can use host directory mounts and who can/can not mount host directories as read/write.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct HostPath {
                /// Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
                pub path: String,
                /// Type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
                pub r#type: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemLifecyclePostStartHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemLifecyclePreStopHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemLivenessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemReadinessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<ContainersItemStartupProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemLifecyclePostStartHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemLifecyclePreStopHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemLivenessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemReadinessProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPGet specifies the http request to perform.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeHttpGet {
                /// Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.
                pub host: String,
                /// Custom headers to set in the request. HTTP allows repeated headers.
                pub http_headers: Vec<InitContainersItemStartupProbeHttpGetHttpHeadersItem>,
                /// Path to access on the HTTP server.
                pub path: String,
                /// Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Scheme to use for connecting to the host. Defaults to HTTP.
                pub scheme: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// HTTPHeader describes a custom header to be used in HTTP probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeHttpGetHttpHeadersItem {
                /// The header field name
                pub name: String,
                /// The header field value
                pub value: String,
            }

            /// LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ImagePullSecretsItem {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// A single application container that you want to run within a pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItem {
                /// Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub args: Vec<String>,
                /// Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
                pub command: Vec<String>,
                /// List of environment variables to set in the container. Cannot be updated.
                pub env: Vec<InitContainersItemEnvItem>,
                /// List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.
                pub env_from: Vec<InitContainersItemEnvFromItem>,
                /// Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.
                pub image: String,
                /// Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images
                pub image_pull_policy: String,
                /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
                pub lifecycle: InitContainersItemLifecycle,
                /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub liveness_probe: InitContainersItemLivenessProbe,
                /// Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.
                pub name: String,
                /// List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Cannot be updated.
                pub ports: Vec<InitContainersItemPortsItem>,
                /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub readiness_probe: InitContainersItemReadinessProbe,
                /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub resources: InitContainersItemResources,
                /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
                pub security_context: InitContainersItemSecurityContext,
                /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub startup_probe: InitContainersItemStartupProbe,
                /// Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.
                pub stdin: bool,
                /// Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false
                pub stdin_once: bool,
                /// Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.
                pub termination_message_path: String,
                /// Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.
                pub termination_message_policy: String,
                /// Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.
                pub tty: bool,
                /// volumeDevices is the list of block devices to be used by the container.
                pub volume_devices: Vec<InitContainersItemVolumeDevicesItem>,
                /// Pod volumes to mount into the container's filesystem. Cannot be updated.
                pub volume_mounts: Vec<InitContainersItemVolumeMountsItem>,
                /// Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.
                pub working_dir: String,
            }

            /// ISCSI represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://examples.k8s.io/volumes/iscsi/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Iscsi {
                /// whether support iSCSI Discovery CHAP authentication
                pub chap_auth_discovery: bool,
                /// whether support iSCSI Session CHAP authentication
                pub chap_auth_session: bool,
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.
                pub initiator_name: String,
                /// Target iSCSI Qualified Name.
                pub iqn: String,
                /// iSCSI Interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).
                pub iscsi_interface: String,
                /// iSCSI Target Lun number.
                pub lun: i32,
                /// iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).
                pub portals: Vec<String>,
                /// ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.
                pub read_only: bool,
                /// CHAP Secret for iSCSI target and initiator authentication
                pub secret_ref: IscsiSecretRef,
                /// iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).
                pub target_portal: String,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemConfigMapItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// DownwardAPIVolumeFile represents information to create the file containing the pod field
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPIItemsItem {
                /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
                pub field_ref: VolumesItemDownwardAPIItemsItemFieldRef,
                /// Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'
                pub path: String,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
                pub resource_field_ref: VolumesItemDownwardAPIItemsItemResourceFieldRef,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemConfigMapItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// DownwardAPIVolumeFile represents information to create the file containing the pod field
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPIItemsItem {
                /// Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
                pub field_ref: SourcesItemDownwardAPIItemsItemFieldRef,
                /// Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'
                pub path: String,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
                pub resource_field_ref: SourcesItemDownwardAPIItemsItemResourceFieldRef,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemSecretItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// Maps a string key to a path within a volume.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemSecretItemsItem {
                /// The key to project.
                pub key: String,
                /// Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub mode: i32,
                /// The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.
                pub path: String,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct KeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels,
        }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels,
        }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels,
        }

            /// A label query over a set of resources, in this case pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels,
        }

            /// LabelSelector is used to find matching pods. Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItemLabelSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<TopologySpreadConstraintsItemLabelSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: TopologySpreadConstraintsItemLabelSelectorMatchLabels,
            }

            /// Labels configure the external label pairs to ThanosRuler. A default replica label `thanos_ruler_replica` will be always added  as a label with the value of the pod's name and it will be dropped in the alerts.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecLabels {
                /// Labels configure the external label pairs to ThanosRuler. A default replica label `thanos_ruler_replica` will be always added  as a label with the value of the pod's name and it will be dropped in the alerts.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetadataLabels {
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MetadataLabels {
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecycle {
                /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub post_start: ContainersItemLifecyclePostStart,
                /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub pre_stop: ContainersItemLifecyclePreStop,
            }

            /// Actions that the management system should take in response to container lifecycle events. Cannot be updated.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecycle {
                /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub post_start: InitContainersItemLifecyclePostStart,
                /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
                pub pre_stop: InitContainersItemLifecyclePreStop,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecResourcesLimits {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbe {
                /// Exec specifies the action to take.
                pub exec: ContainersItemLivenessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: ContainersItemLivenessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemLivenessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: ContainersItemLivenessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbe {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemLivenessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: InitContainersItemLivenessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemLivenessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: InitContainersItemLivenessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PreferenceMatchExpressionsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelectorTermsItemMatchExpressionsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem
            {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleNamespaceSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItemLabelSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem {
                /// key is the label key that the selector applies to.
                pub key: String,
                /// operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.
                pub operator: String,
                /// values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PreferenceMatchFieldsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelectorTermsItemMatchFieldsItem {
                /// The label key that the selector applies to.
                pub key: String,
                /// Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
                pub operator: String,
                /// An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
                pub values: Vec<String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels
            {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleNamespaceSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItemLabelSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchLabels {
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateMetadata {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub properties: serde_json::Map<String, serde_json::Value>,
            }

            /// EmbeddedMetadata contains metadata relevant to an EmbeddedResource.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateMetadata {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub annotations: MetadataAnnotations,
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub labels: MetadataLabels,
                /// Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
                pub name: String,
            }

            /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateMetadata {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub properties: serde_json::Map<String, serde_json::Value>,
            }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels,
        }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels,
        }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelectorMatchLabels,
        }

            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector {
            /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
            pub match_expressions: Vec<PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchExpressionsItem>,
            /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
            pub match_labels: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelectorMatchLabels,
        }

            /// NFS represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Nfs {
                /// Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub path: String,
                /// ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub read_only: bool,
                /// Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub server: String,
            }

            /// Describes node affinity scheduling rules for the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeAffinity {
                /// The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.
                pub preferred_during_scheduling_ignored_during_execution:
                    Vec<NodeAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem>,
                /// If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.
                pub required_during_scheduling_ignored_during_execution:
                    RequiredDuringSchedulingIgnoredDuringExecution,
            }

            /// NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodePublishSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// Define which Nodes the Pods are scheduled on.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelector {
                /// Define which Nodes the Pods are scheduled on.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// A null or empty node selector term matches no objects. The requirements of them are ANDed. The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeSelectorTermsItem {
                /// A list of node selector requirements by node's labels.
                pub match_expressions: Vec<NodeSelectorTermsItemMatchExpressionsItem>,
                /// A list of node selector requirements by node's fields.
                pub match_fields: Vec<NodeSelectorTermsItemMatchFieldsItem>,
            }

            /// ObjectStorageConfig configures object storage in Thanos. Alternative to ObjectStorageConfigFile, and lower order priority.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ObjectStorageConfig {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Optional: Extra command options if any.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Options {
                /// Optional: Extra command options if any.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PersistentVolumeClaim {
                /// ClaimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub claim_name: String,
                /// Will force the ReadOnly setting in VolumeMounts. Default false.
                pub read_only: bool,
            }

            /// PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PhotonPersistentDisk {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// ID that identifies Photon Controller persistent disk
                pub pd_i_d: String,
            }

            /// Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinity {
                /// The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.
                pub preferred_during_scheduling_ignored_during_execution:
                    Vec<PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem>,
                /// If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.
                pub required_during_scheduling_ignored_during_execution:
                    Vec<PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem>,
            }

            /// Required. A pod affinity term, associated with the corresponding weight.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm {
            /// A label query over a set of resources, in this case pods.
            pub label_selector: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector,
            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            pub namespace_selector: PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector,
            /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
            pub namespaces: Vec<String>,
            /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
            pub topology_key: String,
        }

            /// Required. A pod affinity term, associated with the corresponding weight.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm {
            /// A label query over a set of resources, in this case pods.
            pub label_selector: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermLabelSelector,
            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            pub namespace_selector: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTermNamespaceSelector,
            /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
            pub namespaces: Vec<String>,
            /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
            pub topology_key: String,
        }

            /// Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinity {
                /// The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.
                pub preferred_during_scheduling_ignored_during_execution:
                    Vec<PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem>,
                /// If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.
                pub required_during_scheduling_ignored_during_execution:
                    Vec<PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem>,
            }

            /// PodMetadata contains Labels and Annotations gets propagated to the thanos ruler pods.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodMetadata {
                /// Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations
                pub annotations: PodMetadataAnnotations,
                /// Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
                pub labels: PodMetadataLabels,
                /// Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
                pub name: String,
            }

            /// ContainerPort represents a network port in a single container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemPortsItem {
                /// Number of port to expose on the pod's IP address. This must be a valid port number, 0 < x < 65536.
                pub container_port: i32,
                /// What host IP to bind the external port to.
                pub host_i_p: String,
                /// Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.
                pub host_port: i32,
                /// If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services.
                pub name: String,
                /// Protocol for port. Must be UDP, TCP, or SCTP. Defaults to "TCP".
                pub protocol: String,
            }

            /// ContainerPort represents a network port in a single container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemPortsItem {
                /// Number of port to expose on the pod's IP address. This must be a valid port number, 0 < x < 65536.
                pub container_port: i32,
                /// What host IP to bind the external port to.
                pub host_i_p: String,
                /// Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.
                pub host_port: i32,
                /// If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services.
                pub name: String,
                /// Protocol for port. Must be UDP, TCP, or SCTP. Defaults to "TCP".
                pub protocol: String,
            }

            /// PortworxVolume represents a portworx volume attached and mounted on kubelets host machine
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PortworxVolume {
                /// FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// VolumeID uniquely identifies a Portworx volume
                pub volume_i_d: String,
            }

            /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStart {
                /// Exec specifies the action to take.
                pub exec: ContainersItemLifecyclePostStartExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemLifecyclePostStartHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: ContainersItemLifecyclePostStartTcpSocket,
            }

            /// PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStart {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemLifecyclePostStartExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemLifecyclePostStartHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: InitContainersItemLifecyclePostStartTcpSocket,
            }

            /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStop {
                /// Exec specifies the action to take.
                pub exec: ContainersItemLifecyclePreStopExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemLifecyclePreStopHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: ContainersItemLifecyclePreStopTcpSocket,
            }

            /// PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStop {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemLifecyclePreStopExec,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemLifecyclePreStopHttpGet,
                /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
                pub tcp_socket: InitContainersItemLifecyclePreStopTcpSocket,
            }

            /// A node selector term, associated with the corresponding weight.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Preference {
                /// A list of node selector requirements by node's labels.
                pub match_expressions: Vec<PreferenceMatchExpressionsItem>,
                /// A list of node selector requirements by node's fields.
                pub match_fields: Vec<PreferenceMatchFieldsItem>,
            }

            /// An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it's a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct NodeAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem {
                /// A node selector term, associated with the corresponding weight.
                pub preference: Preference,
                /// Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100.
                pub weight: i32,
            }

            /// The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem {
                /// Required. A pod affinity term, associated with the corresponding weight.
                pub pod_affinity_term:
                    PodAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm,
                /// weight associated with matching the corresponding podAffinityTerm, in the range 1-100.
                pub weight: i32,
            }

            /// The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItem {
            /// Required. A pod affinity term, associated with the corresponding weight.
            pub pod_affinity_term: PodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionItemPodAffinityTerm,
            /// weight associated with matching the corresponding podAffinityTerm, in the range 1-100.
            pub weight: i32,
        }

            /// Items for all in one resources secrets, configmaps, and downward API
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Projected {
                /// Mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// list of volume projections
                pub sources: Vec<SourcesItem>,
            }

            /// PrometheusRuleExcludeConfig enables users to configure excluded PrometheusRule names and their namespaces to be ignored while enforcing namespace label for alerts and metrics.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PrometheusRulesExcludedFromEnforceItem {
                /// RuleNamespace - name of excluded rule
                pub rule_name: String,
                /// RuleNamespace - namespace of excluded rule
                pub rule_namespace: String,
            }

            /// Define configuration for connecting to thanos query instances. If this is defined, the QueryEndpoints field will be ignored. Maps to the `query.config` CLI argument. Only available with thanos v0.11.0 and higher.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct QueryConfig {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Quobyte represents a Quobyte mount on the host that shares a pod's lifetime
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Quobyte {
                /// Group to map volume access to Default is no group
                pub group: String,
                /// ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false.
                pub read_only: bool,
                /// Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes
                pub registry: String,
                /// Tenant owning the given Quobyte volume in the Backend Used with dynamically provisioned Quobyte volumes, value is set by the plugin
                pub tenant: String,
                /// User to map volume access to Defaults to serivceaccount user
                pub user: String,
                /// Volume is a string that references an already created Quobyte volume by name.
                pub volume: String,
            }

            /// RBD represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/rbd/README.md
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Rbd {
                /// Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd TODO: how do we prevent errors in the filesystem from compromising the machine
                pub fs_type: String,
                /// The rados image name. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub image: String,
                /// Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub keyring: String,
                /// A collection of Ceph monitors. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub monitors: Vec<String>,
                /// The rados pool name. Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub pool: String,
                /// ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub read_only: bool,
                /// SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub secret_ref: RbdSecretRef,
                /// The rados user name. Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
                pub user: String,
            }

            /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbe {
                /// Exec specifies the action to take.
                pub exec: ContainersItemReadinessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: ContainersItemReadinessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemReadinessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: ContainersItemReadinessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbe {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemReadinessProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: InitContainersItemReadinessProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemReadinessProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: InitContainersItemReadinessProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecResourcesRequests {
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub properties: std::collections::HashMap<
                    String,
                    k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                >,
            }

            /// If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RequiredDuringSchedulingIgnoredDuringExecution {
                /// Required. A list of node selector terms. The terms are ORed.
                pub node_selector_terms: Vec<NodeSelectorTermsItem>,
            }

            /// Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem {
                /// A label query over a set of resources, in this case pods.
                pub label_selector:
                    PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector,
                /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
                pub namespace_selector:
                    PodAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector,
                /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
                pub namespaces: Vec<String>,
                /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
                pub topology_key: String,
            }

            /// Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItem {
            /// A label query over a set of resources, in this case pods.
            pub label_selector: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemLabelSelector,
            /// A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces. This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
            pub namespace_selector: PodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionItemNamespaceSelector,
            /// namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace"
            pub namespaces: Vec<String>,
            /// This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.
            pub topology_key: String,
        }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemDownwardAPIItemsItemResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemDownwardAPIItemsItemResourceFieldRef {
                /// Container name: required for volumes, optional for env vars
                pub container_name: String,
                /// Specifies the output format of the exposed resources, defaults to "1"
                pub divisor: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
                /// Required: resource to select
                pub resource: String,
            }

            /// Resources defines the resource requirements for single Pods. If not provided, no requests/limits will be set
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: SpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: SpecResourcesRequests,
            }

            /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: ContainersItemResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: ContainersItemResourcesRequests,
            }

            /// Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: InitContainersItemResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: InitContainersItemResourcesRequests,
            }

            /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: StorageEphemeralVolumeClaimTemplateSpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: StorageEphemeralVolumeClaimTemplateSpecResourcesRequests,
            }

            /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: StorageVolumeClaimTemplateSpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: StorageVolumeClaimTemplateSpecResourcesRequests,
            }

            /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecResources {
                /// Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub limits: VolumesItemEphemeralVolumeClaimTemplateSpecResourcesLimits,
                /// Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
                pub requests: VolumesItemEphemeralVolumeClaimTemplateSpecResourcesRequests,
            }

            /// Namespaces to be selected for Rules discovery. If unspecified, only the same namespace as the ThanosRuler object is in is used.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleNamespaceSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<RuleNamespaceSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: RuleNamespaceSelectorMatchLabels,
            }

            /// A label selector to select which PrometheusRules to mount for alerting and recording.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RuleSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions: Vec<RuleSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: RuleSelectorMatchLabels,
            }

            /// ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ScaleIO {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs".
                pub fs_type: String,
                /// The host address of the ScaleIO API Gateway.
                pub gateway: String,
                /// The name of the ScaleIO Protection Domain for the configured storage.
                pub protection_domain: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.
                pub secret_ref: ScaleIOSecretRef,
                /// Flag to enable/disable SSL communication with Gateway, default false
                pub ssl_enabled: bool,
                /// Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. Default is ThinProvisioned.
                pub storage_mode: String,
                /// The ScaleIO Storage Pool associated with the protection domain.
                pub storage_pool: String,
                /// The name of the storage system as configured in ScaleIO.
                pub system: String,
                /// The name of a volume already created in the ScaleIO system that is associated with this volume source.
                pub volume_name: String,
            }

            /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextSeLinuxOptions {
                /// Level is SELinux level label that applies to the container.
                pub level: String,
                /// Role is a SELinux role label that applies to the container.
                pub role: String,
                /// Type is a SELinux type label that applies to the container.
                pub r#type: String,
                /// User is a SELinux user label that applies to the container.
                pub user: String,
            }

            /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextSeLinuxOptions {
                /// Level is SELinux level label that applies to the container.
                pub level: String,
                /// Role is a SELinux role label that applies to the container.
                pub role: String,
                /// Type is a SELinux type label that applies to the container.
                pub r#type: String,
                /// User is a SELinux user label that applies to the container.
                pub user: String,
            }

            /// The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContextSeLinuxOptions {
                /// Level is SELinux level label that applies to the container.
                pub level: String,
                /// Role is a SELinux role label that applies to the container.
                pub role: String,
                /// Type is a SELinux type label that applies to the container.
                pub r#type: String,
                /// User is a SELinux user label that applies to the container.
                pub user: String,
            }

            /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextSeccompProfile {
                /// localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".
                pub localhost_profile: String,
                /// type indicates which kind of seccomp profile will be applied. Valid options are:
                ///  Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.
                pub r#type: String,
            }

            /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextSeccompProfile {
                /// localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".
                pub localhost_profile: String,
                /// type indicates which kind of seccomp profile will be applied. Valid options are:
                ///  Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.
                pub r#type: String,
            }

            /// The seccomp options to use by the containers in this pod. Note that this field cannot be set when spec.os.name is windows.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContextSeccompProfile {
                /// localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".
                pub localhost_profile: String,
                /// type indicates which kind of seccomp profile will be applied. Valid options are:
                ///  Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.
                pub r#type: String,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret represents a secret that should populate this volume. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemSecret {
                /// Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
                pub default_mode: i32,
                /// If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<VolumesItemSecretItemsItem>,
                /// Specify whether the Secret or its keys must be defined
                pub optional: bool,
                /// Name of the secret in the pod's namespace to use. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
                pub secret_name: String,
            }

            /// information about the secret data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItemSecret {
                /// If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
                pub items: Vec<SourcesItemSecretItemsItem>,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a secret in the pod's namespace
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFromSecretKeyRef {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Selects a key of a secret in the pod's namespace
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFromSecretKeyRef {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The Secret to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvFromItemSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret must be defined
                pub optional: bool,
            }

            /// The Secret to select from
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvFromItemSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret must be defined
                pub optional: bool,
            }

            /// Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CephfsSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// Optional: points to a secret object containing parameters used to connect to OpenStack.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CinderSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct FlexVolumeSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// CHAP Secret for iSCSI target and initiator authentication
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct IscsiSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RbdSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ScaleIOSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageosSecretRef {
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
            }

            /// SecurityContext holds pod-level security attributes and common container settings. This defaults to the default PodSecurityContext.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContext {
                /// A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:
                ///  1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----
                ///  If unset, the Kubelet will not modify the ownership and permissions of any volume. Note that this field cannot be set when spec.os.name is windows.
                pub fs_group: i64,
                /// fsGroupChangePolicy defines behavior of changing ownership and permission of the volume before being exposed inside Pod. This field will only apply to volume types which support fsGroup based ownership(and permissions). It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir. Valid values are "OnRootMismatch" and "Always". If not specified, "Always" is used. Note that this field cannot be set when spec.os.name is windows.
                pub fs_group_change_policy: String,
                /// The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_group: i64,
                /// Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_non_root: bool,
                /// The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_user: i64,
                /// The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.
                pub se_linux_options: SpecSecurityContextSeLinuxOptions,
                /// The seccomp options to use by the containers in this pod. Note that this field cannot be set when spec.os.name is windows.
                pub seccomp_profile: SpecSecurityContextSeccompProfile,
                /// A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container. Note that this field cannot be set when spec.os.name is windows.
                pub supplemental_groups: Vec<i64>,
                /// Sysctls hold a list of namespaced sysctls used for the pod. Pods with unsupported sysctls (by the container runtime) might fail to launch. Note that this field cannot be set when spec.os.name is windows.
                pub sysctls: Vec<SysctlsItem>,
                /// The Windows specific settings applied to all containers. If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
                pub windows_options: SpecSecurityContextWindowsOptions,
            }

            /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContext {
                /// AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.
                pub allow_privilege_escalation: bool,
                /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
                pub capabilities: ContainersItemSecurityContextCapabilities,
                /// Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.
                pub privileged: bool,
                /// procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.
                pub proc_mount: String,
                /// Whether this container has a read-only root filesystem. Default is false. Note that this field cannot be set when spec.os.name is windows.
                pub read_only_root_filesystem: bool,
                /// The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_group: i64,
                /// Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_non_root: bool,
                /// The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_user: i64,
                /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub se_linux_options: ContainersItemSecurityContextSeLinuxOptions,
                /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
                pub seccomp_profile: ContainersItemSecurityContextSeccompProfile,
                /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
                pub windows_options: ContainersItemSecurityContextWindowsOptions,
            }

            /// SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContext {
                /// AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.
                pub allow_privilege_escalation: bool,
                /// The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.
                pub capabilities: InitContainersItemSecurityContextCapabilities,
                /// Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.
                pub privileged: bool,
                /// procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.
                pub proc_mount: String,
                /// Whether this container has a read-only root filesystem. Default is false. Note that this field cannot be set when spec.os.name is windows.
                pub read_only_root_filesystem: bool,
                /// The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_group: i64,
                /// Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_non_root: bool,
                /// The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub run_as_user: i64,
                /// The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.
                pub se_linux_options: InitContainersItemSecurityContextSeLinuxOptions,
                /// The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.
                pub seccomp_profile: InitContainersItemSecurityContextSeccompProfile,
                /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
                pub windows_options: InitContainersItemSecurityContextWindowsOptions,
            }

            /// A label query over volumes to consider for binding.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpecSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<StorageEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: StorageEphemeralVolumeClaimTemplateSpecSelectorMatchLabels,
            }

            /// A label query over volumes to consider for binding.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpecSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<StorageVolumeClaimTemplateSpecSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: StorageVolumeClaimTemplateSpecSelectorMatchLabels,
            }

            /// A label query over volumes to consider for binding.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpecSelector {
                /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
                pub match_expressions:
                    Vec<VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchExpressionsItem>,
                /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
                pub match_labels: VolumesItemEphemeralVolumeClaimTemplateSpecSelectorMatchLabels,
            }

            /// information about the serviceAccountToken data to project
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceAccountToken {
                /// Audience is the intended audience of the token. A recipient of a token must identify itself with an identifier specified in the audience of the token, and otherwise should reject the token. The audience defaults to the identifier of the apiserver.
                pub audience: String,
                /// ExpirationSeconds is the requested duration of validity of the service account token. As the token approaches expiration, the kubelet volume plugin will proactively rotate the service account token. The kubelet will start trying to rotate the token if the token is older than 80 percent of its time to live or if the token is older than 24 hours.Defaults to 1 hour and must be at least 10 minutes.
                pub expiration_seconds: i64,
                /// Path is the path relative to the mount point of the file to project the token into.
                pub path: String,
            }

            /// Projection that may be projected along with other supported volume types
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourcesItem {
                /// information about the configMap data to project
                pub config_map: SourcesItemConfigMap,
                /// information about the downwardAPI data to project
                pub downward_a_p_i: SourcesItemDownwardAPI,
                /// information about the secret data to project
                pub secret: SourcesItemSecret,
                /// information about the serviceAccountToken data to project
                pub service_account_token: ServiceAccountToken,
            }

            /// Specification of the desired behavior of the ThanosRuler cluster. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Spec {
                /// If specified, the pod's scheduling constraints.
                pub affinity: Affinity,
                /// AlertDropLabels configure the label names which should be dropped in ThanosRuler alerts. The replica label `thanos_ruler_replica` will always be dropped in alerts.
                pub alert_drop_labels: Vec<String>,
                /// The external Query URL the Thanos Ruler will set in the 'Source' field of all alerts. Maps to the '--alert.query-url' CLI arg.
                pub alert_query_url: String,
                /// AlertRelabelConfigFile specifies the path of the alert relabeling configuration file. When used alongside with AlertRelabelConfigs, alertRelabelConfigFile takes precedence.
                pub alert_relabel_config_file: String,
                /// AlertRelabelConfigs configures alert relabeling in ThanosRuler. Alert relabel configurations must have the form as specified in the official Prometheus documentation: https://prometheus.io/docs/prometheus/latest/configuration/configuration/#alert_relabel_configs Alternative to AlertRelabelConfigFile, and lower order priority.
                pub alert_relabel_configs: AlertRelabelConfigs,
                /// Define configuration for connecting to alertmanager.  Only available with thanos v0.10.0 and higher.  Maps to the `alertmanagers.config` arg.
                pub alertmanagers_config: AlertmanagersConfig,
                /// Define URLs to send alerts to Alertmanager.  For Thanos v0.10.0 and higher, AlertManagersConfig should be used instead.  Note: this field will be ignored if AlertManagersConfig is specified. Maps to the `alertmanagers.url` arg.
                pub alertmanagers_url: Vec<String>,
                /// Containers allows injecting additional containers or modifying operator generated containers. This can be used to allow adding an authentication proxy to a ThanosRuler pod or to change the behavior of an operator generated container. Containers described here modify an operator generated container if they share the same name and modifications are done via a strategic merge patch. The current container names are: `thanos-ruler` and `config-reloader`. Overriding containers is entirely outside the scope of what the maintainers will support and by doing so, you accept that this behaviour may break at any time without notice.
                pub containers: Vec<ContainersItem>,
                /// EnforcedNamespaceLabel enforces adding a namespace label of origin for each alert and metric that is user created. The label value will always be the namespace of the object that is being created.
                pub enforced_namespace_label: String,
                /// Interval between consecutive evaluations.
                pub evaluation_interval: String,
                /// List of references to PrometheusRule objects to be excluded from enforcing a namespace label of origin. Applies only if enforcedNamespaceLabel set to true.
                pub excluded_from_enforcement: Vec<ExcludedFromEnforcementItem>,
                /// The external URL the Thanos Ruler instances will be available under. This is necessary to generate correct URLs. This is necessary if Thanos Ruler is not served from root of a DNS name.
                pub external_prefix: String,
                /// GRPCServerTLSConfig configures the gRPC server from which Thanos Querier reads recorded rule data. Note: Currently only the CAFile, CertFile, and KeyFile fields are supported. Maps to the '--grpc-server-tls-*' CLI args.
                pub grpc_server_tls_config: GrpcServerTlsConfig,
                /// Pods' hostAliases configuration
                pub host_aliases: Vec<HostAliasesItem>,
                /// Thanos container image URL.
                pub image: String,
                /// An optional list of references to secrets in the same namespace to use for pulling thanos images from registries see http://kubernetes.io/docs/user-guide/images#specifying-imagepullsecrets-on-a-pod
                pub image_pull_secrets: Vec<ImagePullSecretsItem>,
                /// InitContainers allows adding initContainers to the pod definition. Those can be used to e.g. fetch secrets for injection into the ThanosRuler configuration from external sources. Any errors during the execution of an initContainer will lead to a restart of the Pod. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/ Using initContainers for any use case other then secret fetching is entirely outside the scope of what the maintainers will support and by doing so, you accept that this behaviour may break at any time without notice.
                pub init_containers: Vec<InitContainersItem>,
                /// Labels configure the external label pairs to ThanosRuler. A default replica label `thanos_ruler_replica` will be always added  as a label with the value of the pod's name and it will be dropped in the alerts.
                pub labels: SpecLabels,
                /// ListenLocal makes the Thanos ruler listen on loopback, so that it does not bind against the Pod IP.
                pub listen_local: bool,
                /// Log format for ThanosRuler to be configured with.
                pub log_format: String,
                /// Log level for ThanosRuler to be configured with.
                pub log_level: String,
                /// Minimum number of seconds for which a newly created pod should be ready without any of its container crashing for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready) This is an alpha field and requires enabling StatefulSetMinReadySeconds feature gate.
                pub min_ready_seconds: i32,
                /// Define which Nodes the Pods are scheduled on.
                pub node_selector: NodeSelector,
                /// ObjectStorageConfig configures object storage in Thanos. Alternative to ObjectStorageConfigFile, and lower order priority.
                pub object_storage_config: ObjectStorageConfig,
                /// ObjectStorageConfigFile specifies the path of the object storage configuration file. When used alongside with ObjectStorageConfig, ObjectStorageConfigFile takes precedence.
                pub object_storage_config_file: String,
                /// When a ThanosRuler deployment is paused, no actions except for deletion will be performed on the underlying objects.
                pub paused: bool,
                /// PodMetadata contains Labels and Annotations gets propagated to the thanos ruler pods.
                pub pod_metadata: PodMetadata,
                /// Port name used for the pods and governing service. This defaults to web
                pub port_name: String,
                /// Priority class assigned to the Pods
                pub priority_class_name: String,
                /// PrometheusRulesExcludedFromEnforce - list of Prometheus rules to be excluded from enforcing of adding namespace labels. Works only if enforcedNamespaceLabel set to true. Make sure both ruleNamespace and ruleName are set for each pair Deprecated: use excludedFromEnforcement instead.
                pub prometheus_rules_excluded_from_enforce:
                    Vec<PrometheusRulesExcludedFromEnforceItem>,
                /// Define configuration for connecting to thanos query instances. If this is defined, the QueryEndpoints field will be ignored. Maps to the `query.config` CLI argument. Only available with thanos v0.11.0 and higher.
                pub query_config: QueryConfig,
                /// QueryEndpoints defines Thanos querier endpoints from which to query metrics. Maps to the --query flag of thanos ruler.
                pub query_endpoints: Vec<String>,
                /// Number of thanos ruler instances to deploy.
                pub replicas: i32,
                /// Resources defines the resource requirements for single Pods. If not provided, no requests/limits will be set
                pub resources: SpecResources,
                /// Time duration ThanosRuler shall retain data for. Default is '24h', and must match the regular expression `[0-9]+(ms|s|m|h|d|w|y)` (milliseconds seconds minutes hours days weeks years).
                pub retention: String,
                /// The route prefix ThanosRuler registers HTTP handlers for. This allows thanos UI to be served on a sub-path.
                pub route_prefix: String,
                /// Namespaces to be selected for Rules discovery. If unspecified, only the same namespace as the ThanosRuler object is in is used.
                pub rule_namespace_selector: RuleNamespaceSelector,
                /// A label selector to select which PrometheusRules to mount for alerting and recording.
                pub rule_selector: RuleSelector,
                /// SecurityContext holds pod-level security attributes and common container settings. This defaults to the default PodSecurityContext.
                pub security_context: SpecSecurityContext,
                /// ServiceAccountName is the name of the ServiceAccount to use to run the Thanos Ruler Pods.
                pub service_account_name: String,
                /// Storage spec to specify how storage shall be used.
                pub storage: Storage,
                /// If specified, the pod's tolerations.
                pub tolerations: Vec<TolerationsItem>,
                /// If specified, the pod's topology spread constraints.
                pub topology_spread_constraints: Vec<TopologySpreadConstraintsItem>,
                /// TracingConfig configures tracing in Thanos. This is an experimental feature, it may change in any upcoming release in a breaking way.
                pub tracing_config: TracingConfig,
                /// Volumes allows configuration of additional volumes on the output StatefulSet definition. Volumes specified will be appended to other volumes that are generated as a result of StorageSpec objects.
                pub volumes: Vec<VolumesItem>,
            }

            /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplateSpec {
                /// AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
                pub data_source: StorageEphemeralVolumeClaimTemplateSpecDataSource,
                /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
                pub data_source_ref: StorageEphemeralVolumeClaimTemplateSpecDataSourceRef,
                /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
                pub resources: StorageEphemeralVolumeClaimTemplateSpecResources,
                /// A label query over volumes to consider for binding.
                pub selector: StorageEphemeralVolumeClaimTemplateSpecSelector,
                /// Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
                pub storage_class_name: String,
                /// volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.
                pub volume_mode: String,
                /// VolumeName is the binding reference to the PersistentVolume backing this claim.
                pub volume_name: String,
            }

            /// Spec defines the desired characteristics of a volume requested by a pod author. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplateSpec {
                /// AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
                pub data_source: StorageVolumeClaimTemplateSpecDataSource,
                /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
                pub data_source_ref: StorageVolumeClaimTemplateSpecDataSourceRef,
                /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
                pub resources: StorageVolumeClaimTemplateSpecResources,
                /// A label query over volumes to consider for binding.
                pub selector: StorageVolumeClaimTemplateSpecSelector,
                /// Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
                pub storage_class_name: String,
                /// volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.
                pub volume_mode: String,
                /// VolumeName is the binding reference to the PersistentVolume backing this claim.
                pub volume_name: String,
            }

            /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplateSpec {
                /// AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// This field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. If the AnyVolumeDataSource feature gate is enabled, this field will always have the same contents as the DataSourceRef field.
                pub data_source: VolumesItemEphemeralVolumeClaimTemplateSpecDataSource,
                /// Specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any local object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the DataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, both fields (DataSource and DataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. There are two important differences between DataSource and DataSourceRef: * While DataSource only allows two specific types of objects, DataSourceRef allows any non-core object, as well as PersistentVolumeClaim objects. * While DataSource ignores disallowed values (dropping them), DataSourceRef preserves all values, and generates an error if a disallowed value is specified. (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
                pub data_source_ref: VolumesItemEphemeralVolumeClaimTemplateSpecDataSourceRef,
                /// Resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
                pub resources: VolumesItemEphemeralVolumeClaimTemplateSpecResources,
                /// A label query over volumes to consider for binding.
                pub selector: VolumesItemEphemeralVolumeClaimTemplateSpecSelector,
                /// Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
                pub storage_class_name: String,
                /// volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.
                pub volume_mode: String,
                /// VolumeName is the binding reference to the PersistentVolume backing this claim.
                pub volume_name: String,
            }

            /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbe {
                /// Exec specifies the action to take.
                pub exec: ContainersItemStartupProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: ContainersItemStartupProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: ContainersItemStartupProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: ContainersItemStartupProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbe {
                /// Exec specifies the action to take.
                pub exec: InitContainersItemStartupProbeExec,
                /// Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.
                pub failure_threshold: i32,
                /// GRPC specifies an action involving a GRPC port. This is an alpha field and requires enabling GRPCContainerProbe feature gate.
                pub grpc: InitContainersItemStartupProbeGrpc,
                /// HTTPGet specifies the http request to perform.
                pub http_get: InitContainersItemStartupProbeHttpGet,
                /// Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub initial_delay_seconds: i32,
                /// How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.
                pub period_seconds: i32,
                /// Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
                pub success_threshold: i32,
                /// TCPSocket specifies an action involving a TCP port.
                pub tcp_socket: InitContainersItemStartupProbeTcpSocket,
                /// Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
                pub termination_grace_period_seconds: i64,
                /// Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
                pub timeout_seconds: i32,
            }

            /// Most recent observed status of the ThanosRuler cluster. Read-only. Not included when requesting from the apiserver, only from the ThanosRuler Operator API itself. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Status {
                /// Total number of available pods (ready for at least minReadySeconds) targeted by this ThanosRuler deployment.
                pub available_replicas: i32,
                /// Represents whether any actions on the underlying managed objects are being performed. Only delete actions will be performed.
                pub paused: bool,
                /// Total number of non-terminated pods targeted by this ThanosRuler deployment (their labels match the selector).
                pub replicas: i32,
                /// Total number of unavailable pods targeted by this ThanosRuler deployment.
                pub unavailable_replicas: i32,
                /// Total number of non-terminated pods targeted by this ThanosRuler deployment that have the desired version spec.
                pub updated_replicas: i32,
            }

            /// Status represents the current information/status of a persistent volume claim. Read-only. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumeClaimTemplateStatus {
                /// AccessModes contains the actual access modes the volume backing the PVC has. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
                pub access_modes: Vec<String>,
                /// The storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
                pub allocated_resources: AllocatedResources,
                /// Represents the actual resources of the underlying volume.
                pub capacity: Capacity,
                /// Current Condition of persistent volume claim. If underlying persistent volume is being resized then the Condition will be set to 'ResizeStarted'.
                pub conditions: Vec<ConditionsItem>,
                /// Phase represents the current phase of PersistentVolumeClaim.
                pub phase: String,
                /// ResizeStatus stores status of resize operation. ResizeStatus is not set by default but when expansion is complete resizeStatus is set to empty string by resize controller or kubelet. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.
                pub resize_status: String,
            }

            /// Storage spec to specify how storage shall be used.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Storage {
                /// Deprecated: subPath usage will be disabled by default in a future release, this option will become unnecessary. DisableMountSubPath allows to remove any subPath usage in volume mounts.
                pub disable_mount_sub_path: bool,
                /// EmptyDirVolumeSource to be used by the Prometheus StatefulSets. If specified, used in place of any volumeClaimTemplate. More info: https://kubernetes.io/docs/concepts/storage/volumes/#emptydir
                pub empty_dir: StorageEmptyDir,
                /// EphemeralVolumeSource to be used by the Prometheus StatefulSets. This is a beta field in k8s 1.21, for lower versions, starting with k8s 1.19, it requires enabling the GenericEphemeralVolume feature gate. More info: https://kubernetes.io/docs/concepts/storage/ephemeral-volumes/#generic-ephemeral-volumes
                pub ephemeral: StorageEphemeral,
                /// A PVC spec to be used by the Prometheus StatefulSets.
                pub volume_claim_template: StorageVolumeClaimTemplate,
            }

            /// StorageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Storageos {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.
                pub read_only: bool,
                /// SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.
                pub secret_ref: StorageosSecretRef,
                /// VolumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.
                pub volume_name: String,
                /// VolumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.
                pub volume_namespace: String,
            }

            /// Sysctl defines a kernel parameter to be set
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SysctlsItem {
                /// Name of a property to set
                pub name: String,
                /// Value of a property to set
                pub value: String,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePostStartTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLifecyclePreStopTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemLivenessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemReadinessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemStartupProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePostStartTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLifecyclePreStopTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemLivenessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemReadinessProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// TCPSocket specifies an action involving a TCP port.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemStartupProbeTcpSocket {
                /// Optional: Host name to connect to, defaults to the pod IP.
                pub host: String,
                /// Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
                pub port: k8s_openapi::apimachinery::pkg::util::intstr::IntOrString,
            }

            /// The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TolerationsItem {
                /// Effect indicates the taint effect to match. Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.
                pub effect: String,
                /// Key is the taint key that the toleration applies to. Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.
                pub key: String,
                /// Operator represents a key's relationship to the value. Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.
                pub operator: String,
                /// TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.
                pub toleration_seconds: i64,
                /// Value is the taint value the toleration matches to. If the operator is Exists, the value should be empty, otherwise just a regular string.
                pub value: String,
            }

            /// TopologySpreadConstraint specifies how to spread matching pods among the given topology.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TopologySpreadConstraintsItem {
                /// LabelSelector is used to find matching pods. Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.
                pub label_selector: TopologySpreadConstraintsItemLabelSelector,
                /// MaxSkew describes the degree to which pods may be unevenly distributed. When `whenUnsatisfiable=DoNotSchedule`, it is the maximum permitted difference between the number of matching pods in the target topology and the global minimum. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 1/1/0: | zone1 | zone2 | zone3 | |   P   |   P   |       | - if MaxSkew is 1, incoming pod can only be scheduled to zone3 to become 1/1/1; scheduling it onto zone1(zone2) would make the ActualSkew(2-0) on zone1(zone2) violate MaxSkew(1). - if MaxSkew is 2, incoming pod can be scheduled onto any zone. When `whenUnsatisfiable=ScheduleAnyway`, it is used to give higher precedence to topologies that satisfy it. It's a required field. Default value is 1 and 0 is not allowed.
                pub max_skew: i32,
                /// TopologyKey is the key of node labels. Nodes that have a label with this key and identical values are considered to be in the same topology. We consider each <key, value> as a "bucket", and try to put balanced number of pods into each bucket. It's a required field.
                pub topology_key: String,
                /// WhenUnsatisfiable indicates how to deal with a pod if it doesn't satisfy the spread constraint. - DoNotSchedule (default) tells the scheduler not to schedule it. - ScheduleAnyway tells the scheduler to schedule the pod in any location, but giving higher precedence to topologies that would help reduce the skew. A constraint is considered "Unsatisfiable" for an incoming pod if and only if every possible node assignment for that pod would violate "MaxSkew" on some topology. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 3/1/1: | zone1 | zone2 | zone3 | | P P P |   P   |   P   | If WhenUnsatisfiable is set to DoNotSchedule, incoming pod can only be scheduled to zone2(zone3) to become 3/2/1(3/1/2) as ActualSkew(2-1) on zone2(zone3) satisfies MaxSkew(1). In other words, the cluster can still be imbalanced, but scheduler won't make it *more* imbalanced. It's a required field.
                pub when_unsatisfiable: String,
            }

            /// TracingConfig configures tracing in Thanos. This is an experimental feature, it may change in any upcoming release in a breaking way.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TracingConfig {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Source for the environment variable's value. Cannot be used if value is not empty.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemEnvItemValueFrom {
                /// Selects a key of a ConfigMap.
                pub config_map_key_ref: ContainersItemEnvItemValueFromConfigMapKeyRef,
                /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
                pub field_ref: ContainersItemEnvItemValueFromFieldRef,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
                pub resource_field_ref: ContainersItemEnvItemValueFromResourceFieldRef,
                /// Selects a key of a secret in the pod's namespace
                pub secret_key_ref: ContainersItemEnvItemValueFromSecretKeyRef,
            }

            /// Source for the environment variable's value. Cannot be used if value is not empty.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemEnvItemValueFrom {
                /// Selects a key of a ConfigMap.
                pub config_map_key_ref: InitContainersItemEnvItemValueFromConfigMapKeyRef,
                /// Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
                pub field_ref: InitContainersItemEnvItemValueFromFieldRef,
                /// Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
                pub resource_field_ref: InitContainersItemEnvItemValueFromResourceFieldRef,
                /// Selects a key of a secret in the pod's namespace
                pub secret_key_ref: InitContainersItemEnvItemValueFromSecretKeyRef,
            }

            /// VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumeAttributes {
                /// VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// A PVC spec to be used by the Prometheus StatefulSets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageVolumeClaimTemplate {
                /// APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
                pub api_version: String,
                /// Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
                pub kind: String,
                /// EmbeddedMetadata contains metadata relevant to an EmbeddedResource.
                pub metadata: StorageVolumeClaimTemplateMetadata,
                /// Spec defines the desired characteristics of a volume requested by a pod author. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub spec: StorageVolumeClaimTemplateSpec,
                /// Status represents the current information/status of a persistent volume claim. Read-only. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub status: VolumeClaimTemplateStatus,
            }

            /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
            ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
            ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
            ///  Required, must not be nil.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct StorageEphemeralVolumeClaimTemplate {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub metadata: StorageEphemeralVolumeClaimTemplateMetadata,
                /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
                pub spec: StorageEphemeralVolumeClaimTemplateSpec,
            }

            /// Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).
            ///  An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.
            ///  This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.
            ///  Required, must not be nil.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItemEphemeralVolumeClaimTemplate {
                /// May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.
                pub metadata: VolumesItemEphemeralVolumeClaimTemplateMetadata,
                /// The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.
                pub spec: VolumesItemEphemeralVolumeClaimTemplateSpec,
            }

            /// volumeDevice describes a mapping of a raw block device within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemVolumeDevicesItem {
                /// devicePath is the path inside of the container that the device will be mapped to.
                pub device_path: String,
                /// name must match the name of a persistentVolumeClaim in the pod
                pub name: String,
            }

            /// volumeDevice describes a mapping of a raw block device within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemVolumeDevicesItem {
                /// devicePath is the path inside of the container that the device will be mapped to.
                pub device_path: String,
                /// name must match the name of a persistentVolumeClaim in the pod
                pub name: String,
            }

            /// VolumeMount describes a mounting of a Volume within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemVolumeMountsItem {
                /// Path within the container at which the volume should be mounted.  Must not contain ':'.
                pub mount_path: String,
                /// mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.
                pub mount_propagation: String,
                /// This must match the Name of a Volume.
                pub name: String,
                /// Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.
                pub read_only: bool,
                /// Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).
                pub sub_path: String,
                /// Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.
                pub sub_path_expr: String,
            }

            /// VolumeMount describes a mounting of a Volume within a container.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemVolumeMountsItem {
                /// Path within the container at which the volume should be mounted.  Must not contain ':'.
                pub mount_path: String,
                /// mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.
                pub mount_propagation: String,
                /// This must match the Name of a Volume.
                pub name: String,
                /// Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.
                pub read_only: bool,
                /// Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).
                pub sub_path: String,
                /// Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.
                pub sub_path_expr: String,
            }

            /// Volume represents a named volume in a pod that may be accessed by any container in the pod.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VolumesItem {
                /// AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
                pub aws_elastic_block_store: AwsElasticBlockStore,
                /// AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.
                pub azure_disk: AzureDisk,
                /// AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
                pub azure_file: AzureFile,
                /// CephFS represents a Ceph FS mount on the host that shares a pod's lifetime
                pub cephfs: Cephfs,
                /// Cinder represents a cinder volume attached and mounted on kubelets host machine. More info: https://examples.k8s.io/mysql-cinder-pd/README.md
                pub cinder: Cinder,
                /// ConfigMap represents a configMap that should populate this volume
                pub config_map: VolumesItemConfigMap,
                /// CSI (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).
                pub csi: Csi,
                /// DownwardAPI represents downward API about the pod that should populate this volume
                pub downward_a_p_i: VolumesItemDownwardAPI,
                /// EmptyDir represents a temporary directory that shares a pod's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
                pub empty_dir: VolumesItemEmptyDir,
                /// Ephemeral represents a volume that is handled by a cluster storage driver. The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts, and deleted when the pod is removed.
                ///  Use this if: a) the volume is only needed while the pod runs, b) features of normal volumes like restoring from snapshot or capacity tracking are needed, c) the storage driver is specified through a storage class, and d) the storage driver supports dynamic volume provisioning through a PersistentVolumeClaim (see EphemeralVolumeSource for more information on the connection between this volume type and PersistentVolumeClaim).
                ///  Use PersistentVolumeClaim or one of the vendor-specific APIs for volumes that persist for longer than the lifecycle of an individual pod.
                ///  Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to be used that way - see the documentation of the driver for more information.
                ///  A pod can use both types of ephemeral volumes and persistent volumes at the same time.
                pub ephemeral: VolumesItemEphemeral,
                /// FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.
                pub fc: Fc,
                /// FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.
                pub flex_volume: FlexVolume,
                /// Flocker represents a Flocker volume attached to a kubelet's host machine. This depends on the Flocker control service being running
                pub flocker: Flocker,
                /// GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
                pub gce_persistent_disk: GcePersistentDisk,
                /// GitRepo represents a git repository at a particular revision. DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.
                pub git_repo: GitRepo,
                /// Glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/glusterfs/README.md
                pub glusterfs: Glusterfs,
                /// HostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath --- TODO(jonesdl) We need to restrict who can use host directory mounts and who can/can not mount host directories as read/write.
                pub host_path: HostPath,
                /// ISCSI represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://examples.k8s.io/volumes/iscsi/README.md
                pub iscsi: Iscsi,
                /// Volume's name. Must be a DNS_LABEL and unique within the pod. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
                pub name: String,
                /// NFS represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
                pub nfs: Nfs,
                /// PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
                pub persistent_volume_claim: PersistentVolumeClaim,
                /// PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine
                pub photon_persistent_disk: PhotonPersistentDisk,
                /// PortworxVolume represents a portworx volume attached and mounted on kubelets host machine
                pub portworx_volume: PortworxVolume,
                /// Items for all in one resources secrets, configmaps, and downward API
                pub projected: Projected,
                /// Quobyte represents a Quobyte mount on the host that shares a pod's lifetime
                pub quobyte: Quobyte,
                /// RBD represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/rbd/README.md
                pub rbd: Rbd,
                /// ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.
                pub scale_i_o: ScaleIO,
                /// Secret represents a secret that should populate this volume. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
                pub secret: VolumesItemSecret,
                /// StorageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.
                pub storageos: Storageos,
                /// VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine
                pub vsphere_volume: VsphereVolume,
            }

            /// VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VsphereVolume {
                /// Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
                pub fs_type: String,
                /// Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.
                pub storage_policy_i_d: String,
                /// Storage Policy Based Management (SPBM) profile name.
                pub storage_policy_name: String,
                /// Path that identifies vSphere volume vmdk
                pub volume_path: String,
            }

            /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ContainersItemSecurityContextWindowsOptions {
                /// GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.
                pub gmsa_credential_spec: String,
                /// GMSACredentialSpecName is the name of the GMSA credential spec to use.
                pub gmsa_credential_spec_name: String,
                /// HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.
                pub host_process: bool,
                /// The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_user_name: String,
            }

            /// The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InitContainersItemSecurityContextWindowsOptions {
                /// GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.
                pub gmsa_credential_spec: String,
                /// GMSACredentialSpecName is the name of the GMSA credential spec to use.
                pub gmsa_credential_spec_name: String,
                /// HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.
                pub host_process: bool,
                /// The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_user_name: String,
            }

            /// The Windows specific settings applied to all containers. If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SpecSecurityContextWindowsOptions {
                /// GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.
                pub gmsa_credential_spec: String,
                /// GMSACredentialSpecName is the name of the GMSA credential spec to use.
                pub gmsa_credential_spec_name: String,
                /// HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.
                pub host_process: bool,
                /// The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
                pub run_as_user_name: String,
            }
        }
    }
    pub mod v1alpha1 {
        pub mod alertmanager_config {
            /// AlertmanagerConfig defines a namespaced AlertmanagerConfig to be aggregated across multiple namespaces configuring one Alertmanager cluster.
            #[derive(serde::Deserialize, Debug, PartialEq)]
            pub struct AlertmanagerConfig {
                pub metadata: k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta,
                pub spec: Spec,
            }

            impl k8s_openapi::Resource for AlertmanagerConfig {
                type Scope = k8s_openapi::ClusterResourceScope;

                const API_VERSION: &'static str = "monitoring.coreos.com/v1alpha1";
                const GROUP: &'static str = "monitoring.coreos.com";
                const KIND: &'static str = "AlertmanagerConfig";
                const VERSION: &'static str = "v1alpha1";
                const URL_PATH_SEGMENT: &'static str = "";
            }

            impl k8s_openapi::Metadata for AlertmanagerConfig {
                type Ty = k8s_openapi::apimachinery::pkg::apis::meta::v1::ObjectMeta;

                fn metadata(&self) -> &<Self as k8s_openapi::Metadata>::Ty {
                    &self.metadata
                }

                fn metadata_mut(&mut self) -> &mut <Self as k8s_openapi::Metadata>::Ty {
                    &mut self.metadata
                }
            }

            impl serde::Serialize for AlertmanagerConfig {
                fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
                where
                    S: serde::Serializer,
                {
                    use serde::ser::SerializeStruct;
                    let mut state = serializer.serialize_struct("AlertmanagerConfig", 4)?;
                    state.serialize_field(
                        "apiVersion",
                        <Self as k8s_openapi::Resource>::API_VERSION,
                    )?;
                    state.serialize_field("kind", <Self as k8s_openapi::Resource>::KIND)?;
                    state.serialize_field("metadata", &self.metadata)?;
                    state.serialize_field("spec", &self.spec)?;
                    state.end()
                }
            }

            /// AccessKey is the AWS API key. If blank, the environment variable `AWS_ACCESS_KEY_ID` is used.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AccessKey {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// SlackAction configures a single Slack action that is sent with each notification. See https://api.slack.com/docs/message-attachments#action_fields and https://api.slack.com/docs/message-buttons for more information.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ActionsItem {
                /// SlackConfirmationField protect users from destructive actions or particularly distinguished decisions by asking them to confirm their button click one more time. See https://api.slack.com/docs/interactive-message-field-guide#confirmation_fields for more information.
                pub confirm: Confirm,
                pub name: String,
                pub style: String,
                pub text: String,
                pub r#type: String,
                pub url: String,
                pub value: String,
            }

            /// The secret's key that contains the OpsGenie API key. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemApiKey {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the API key to use when talking to the VictorOps API. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemApiKey {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the WeChat API key. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the Slack webhook URL. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ApiURL {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// SNS message attributes.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Attributes {
                /// SNS message attributes.
                pub properties: std::collections::HashMap<String, String>,
            }

            /// The secret's key that contains the password to use for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the CRAM-MD5 secret. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct AuthSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: OpsgenieConfigsItemHttpConfigAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: PagerdutyConfigsItemHttpConfigAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: PushoverConfigsItemHttpConfigAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: SlackConfigsItemHttpConfigAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: SnsConfigsItemHttpConfigAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: TelegramConfigsItemHttpConfigAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: VictoropsConfigsItemHttpConfigAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: WebhookConfigsItemHttpConfigAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigAuthorization {
                /// The secret's key that contains the credentials of the request
                pub credentials: WechatConfigsItemHttpConfigAuthorizationCredentials,
                /// Set the authentication type. Defaults to Bearer, Basic will cause an error
                pub r#type: String,
            }

            /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: OpsgenieConfigsItemHttpConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: OpsgenieConfigsItemHttpConfigBasicAuthUsername,
            }

            /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: PagerdutyConfigsItemHttpConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: PagerdutyConfigsItemHttpConfigBasicAuthUsername,
            }

            /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: PushoverConfigsItemHttpConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: PushoverConfigsItemHttpConfigBasicAuthUsername,
            }

            /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: SlackConfigsItemHttpConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: SlackConfigsItemHttpConfigBasicAuthUsername,
            }

            /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: SnsConfigsItemHttpConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: SnsConfigsItemHttpConfigBasicAuthUsername,
            }

            /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: TelegramConfigsItemHttpConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: TelegramConfigsItemHttpConfigBasicAuthUsername,
            }

            /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: VictoropsConfigsItemHttpConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: VictoropsConfigsItemHttpConfigBasicAuthUsername,
            }

            /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: WebhookConfigsItemHttpConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: WebhookConfigsItemHttpConfigBasicAuthUsername,
            }

            /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigBasicAuth {
                /// The secret in the service monitor namespace that contains the password for authentication.
                pub password: WechatConfigsItemHttpConfigBasicAuthPassword,
                /// The secret in the service monitor namespace that contains the username for authentication.
                pub username: WechatConfigsItemHttpConfigBasicAuthUsername,
            }

            /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigBearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigBearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigBearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigBearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigBearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigBearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigBearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigBearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigBearerTokenSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Telegram bot token The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct BotToken {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EmailConfigsItemTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: EmailConfigsItemTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: EmailConfigsItemTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: OpsgenieConfigsItemHttpConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: OpsgenieConfigsItemHttpConfigTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: PagerdutyConfigsItemHttpConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: PagerdutyConfigsItemHttpConfigTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: PushoverConfigsItemHttpConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: PushoverConfigsItemHttpConfigTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: SlackConfigsItemHttpConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: SlackConfigsItemHttpConfigTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: SnsConfigsItemHttpConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: SnsConfigsItemHttpConfigTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: TelegramConfigsItemHttpConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: TelegramConfigsItemHttpConfigTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: VictoropsConfigsItemHttpConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: VictoropsConfigsItemHttpConfigTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: WebhookConfigsItemHttpConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: WebhookConfigsItemHttpConfigTlsConfigCaSecret,
            }

            /// Struct containing the CA cert to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigTlsConfigCa {
                /// ConfigMap containing data to use for the targets.
                pub config_map: WechatConfigsItemHttpConfigTlsConfigCaConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: WechatConfigsItemHttpConfigTlsConfigCaSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EmailConfigsItemTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: EmailConfigsItemTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: EmailConfigsItemTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: OpsgenieConfigsItemHttpConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: OpsgenieConfigsItemHttpConfigTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: PagerdutyConfigsItemHttpConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: PagerdutyConfigsItemHttpConfigTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: PushoverConfigsItemHttpConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: PushoverConfigsItemHttpConfigTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: SlackConfigsItemHttpConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: SlackConfigsItemHttpConfigTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: SnsConfigsItemHttpConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: SnsConfigsItemHttpConfigTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: TelegramConfigsItemHttpConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: TelegramConfigsItemHttpConfigTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: VictoropsConfigsItemHttpConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: VictoropsConfigsItemHttpConfigTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: WebhookConfigsItemHttpConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: WebhookConfigsItemHttpConfigTlsConfigCertSecret,
            }

            /// Struct containing the client cert file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigTlsConfigCert {
                /// ConfigMap containing data to use for the targets.
                pub config_map: WechatConfigsItemHttpConfigTlsConfigCertConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: WechatConfigsItemHttpConfigTlsConfigCertSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: OpsgenieConfigsItemHttpConfigOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: OpsgenieConfigsItemHttpConfigOauth2ClientIdSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: PagerdutyConfigsItemHttpConfigOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: PagerdutyConfigsItemHttpConfigOauth2ClientIdSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: PushoverConfigsItemHttpConfigOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: PushoverConfigsItemHttpConfigOauth2ClientIdSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: SlackConfigsItemHttpConfigOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: SlackConfigsItemHttpConfigOauth2ClientIdSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: SnsConfigsItemHttpConfigOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: SnsConfigsItemHttpConfigOauth2ClientIdSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: TelegramConfigsItemHttpConfigOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: TelegramConfigsItemHttpConfigOauth2ClientIdSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: VictoropsConfigsItemHttpConfigOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: VictoropsConfigsItemHttpConfigOauth2ClientIdSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: WebhookConfigsItemHttpConfigOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: WebhookConfigsItemHttpConfigOauth2ClientIdSecret,
            }

            /// The secret or configmap containing the OAuth2 client id
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigOauth2ClientId {
                /// ConfigMap containing data to use for the targets.
                pub config_map: WechatConfigsItemHttpConfigOauth2ClientIdConfigMap,
                /// Secret containing data to use for the targets.
                pub secret: WechatConfigsItemHttpConfigOauth2ClientIdSecret,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret containing the OAuth2 client secret
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigOauth2ClientSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EmailConfigsItemTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EmailConfigsItemTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigOauth2ClientIdConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigTlsConfigCaConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// ConfigMap containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigTlsConfigCertConfigMap {
                /// The key to select.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the ConfigMap or its key must be defined
                pub optional: bool,
            }

            /// SlackConfirmationField protect users from destructive actions or particularly distinguished decisions by asking them to confirm their button click one more time. See https://api.slack.com/docs/interactive-message-field-guide#confirmation_fields for more information.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Confirm {
                pub dismiss_text: String,
                pub ok_text: String,
                pub text: String,
                pub title: String,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the credentials of the request
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigAuthorizationCredentials {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// KeyValue defines a (key, value) tuple.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct CustomFieldsItem {
                /// Key of the tuple.
                pub key: String,
                /// Value of the tuple.
                pub value: String,
            }

            /// DayOfMonthRange is an inclusive range of days of the month beginning at 1
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct DaysOfMonthItem {
                /// End of the inclusive range
                pub end: i64,
                /// Start of the inclusive range
                pub start: i64,
            }

            /// KeyValue defines a (key, value) tuple.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemDetailsItem {
                /// Key of the tuple.
                pub key: String,
                /// Value of the tuple.
                pub value: String,
            }

            /// KeyValue defines a (key, value) tuple.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemDetailsItem {
                /// Key of the tuple.
                pub key: String,
                /// Value of the tuple.
                pub value: String,
            }

            /// EmailConfig configures notifications via Email.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EmailConfigsItem {
                /// The identity to use for authentication.
                pub auth_identity: String,
                /// The secret's key that contains the password to use for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub auth_password: AuthPassword,
                /// The secret's key that contains the CRAM-MD5 secret. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub auth_secret: AuthSecret,
                /// The username to use for authentication.
                pub auth_username: String,
                /// The sender address.
                pub from: String,
                /// Further headers email header key/value pairs. Overrides any headers previously set by the notification implementation.
                pub headers: Vec<HeadersItem>,
                /// The hostname to identify to the SMTP server.
                pub hello: String,
                /// The HTML body of the email notification.
                pub html: String,
                /// The SMTP TLS requirement. Note that Go does not support unencrypted connections to remote SMTP endpoints.
                pub require_t_l_s: bool,
                /// Whether or not to notify about resolved alerts.
                pub send_resolved: bool,
                /// The SMTP host and port through which emails are sent. E.g. example.com:25
                pub smarthost: String,
                /// The text body of the email notification.
                pub text: String,
                /// TLS configuration
                pub tls_config: EmailConfigsItemTlsConfig,
                /// The email address to send notifications to.
                pub to: String,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// Parameters to append to the token URL
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigOauth2EndpointParams {
                /// Parameters to append to the token URL
                pub properties: std::collections::HashMap<String, String>,
            }

            /// SlackField configures a single Slack field that is sent with each notification. Each field must contain a title, value, and optionally, a boolean value to indicate if the field is short enough to be displayed next to other fields designated as short. See https://api.slack.com/docs/message-attachments#fields for more information.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct FieldsItem {
                pub short: bool,
                pub title: String,
                pub value: String,
            }

            /// KeyValue defines a (key, value) tuple.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct HeadersItem {
                /// Key of the tuple.
                pub key: String,
                /// Value of the tuple.
                pub value: String,
            }

            /// HTTP client configuration.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfig {
                /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
                pub authorization: OpsgenieConfigsItemHttpConfigAuthorization,
                /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
                pub basic_auth: OpsgenieConfigsItemHttpConfigBasicAuth,
                /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bearer_token_secret: OpsgenieConfigsItemHttpConfigBearerTokenSecret,
                /// FollowRedirects specifies whether the client should follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// OAuth2 client credentials used to fetch a token for the targets.
                pub oauth2: OpsgenieConfigsItemHttpConfigOauth2,
                /// Optional proxy URL.
                pub proxy_u_r_l: String,
                /// TLS configuration for the client.
                pub tls_config: OpsgenieConfigsItemHttpConfigTlsConfig,
            }

            /// HTTP client configuration.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfig {
                /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
                pub authorization: PagerdutyConfigsItemHttpConfigAuthorization,
                /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
                pub basic_auth: PagerdutyConfigsItemHttpConfigBasicAuth,
                /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bearer_token_secret: PagerdutyConfigsItemHttpConfigBearerTokenSecret,
                /// FollowRedirects specifies whether the client should follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// OAuth2 client credentials used to fetch a token for the targets.
                pub oauth2: PagerdutyConfigsItemHttpConfigOauth2,
                /// Optional proxy URL.
                pub proxy_u_r_l: String,
                /// TLS configuration for the client.
                pub tls_config: PagerdutyConfigsItemHttpConfigTlsConfig,
            }

            /// HTTP client configuration.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfig {
                /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
                pub authorization: PushoverConfigsItemHttpConfigAuthorization,
                /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
                pub basic_auth: PushoverConfigsItemHttpConfigBasicAuth,
                /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bearer_token_secret: PushoverConfigsItemHttpConfigBearerTokenSecret,
                /// FollowRedirects specifies whether the client should follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// OAuth2 client credentials used to fetch a token for the targets.
                pub oauth2: PushoverConfigsItemHttpConfigOauth2,
                /// Optional proxy URL.
                pub proxy_u_r_l: String,
                /// TLS configuration for the client.
                pub tls_config: PushoverConfigsItemHttpConfigTlsConfig,
            }

            /// HTTP client configuration.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfig {
                /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
                pub authorization: SlackConfigsItemHttpConfigAuthorization,
                /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
                pub basic_auth: SlackConfigsItemHttpConfigBasicAuth,
                /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bearer_token_secret: SlackConfigsItemHttpConfigBearerTokenSecret,
                /// FollowRedirects specifies whether the client should follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// OAuth2 client credentials used to fetch a token for the targets.
                pub oauth2: SlackConfigsItemHttpConfigOauth2,
                /// Optional proxy URL.
                pub proxy_u_r_l: String,
                /// TLS configuration for the client.
                pub tls_config: SlackConfigsItemHttpConfigTlsConfig,
            }

            /// HTTP client configuration.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfig {
                /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
                pub authorization: SnsConfigsItemHttpConfigAuthorization,
                /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
                pub basic_auth: SnsConfigsItemHttpConfigBasicAuth,
                /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bearer_token_secret: SnsConfigsItemHttpConfigBearerTokenSecret,
                /// FollowRedirects specifies whether the client should follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// OAuth2 client credentials used to fetch a token for the targets.
                pub oauth2: SnsConfigsItemHttpConfigOauth2,
                /// Optional proxy URL.
                pub proxy_u_r_l: String,
                /// TLS configuration for the client.
                pub tls_config: SnsConfigsItemHttpConfigTlsConfig,
            }

            /// HTTP client configuration.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfig {
                /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
                pub authorization: TelegramConfigsItemHttpConfigAuthorization,
                /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
                pub basic_auth: TelegramConfigsItemHttpConfigBasicAuth,
                /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bearer_token_secret: TelegramConfigsItemHttpConfigBearerTokenSecret,
                /// FollowRedirects specifies whether the client should follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// OAuth2 client credentials used to fetch a token for the targets.
                pub oauth2: TelegramConfigsItemHttpConfigOauth2,
                /// Optional proxy URL.
                pub proxy_u_r_l: String,
                /// TLS configuration for the client.
                pub tls_config: TelegramConfigsItemHttpConfigTlsConfig,
            }

            /// The HTTP client's configuration.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfig {
                /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
                pub authorization: VictoropsConfigsItemHttpConfigAuthorization,
                /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
                pub basic_auth: VictoropsConfigsItemHttpConfigBasicAuth,
                /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bearer_token_secret: VictoropsConfigsItemHttpConfigBearerTokenSecret,
                /// FollowRedirects specifies whether the client should follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// OAuth2 client credentials used to fetch a token for the targets.
                pub oauth2: VictoropsConfigsItemHttpConfigOauth2,
                /// Optional proxy URL.
                pub proxy_u_r_l: String,
                /// TLS configuration for the client.
                pub tls_config: VictoropsConfigsItemHttpConfigTlsConfig,
            }

            /// HTTP client configuration.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfig {
                /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
                pub authorization: WebhookConfigsItemHttpConfigAuthorization,
                /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
                pub basic_auth: WebhookConfigsItemHttpConfigBasicAuth,
                /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bearer_token_secret: WebhookConfigsItemHttpConfigBearerTokenSecret,
                /// FollowRedirects specifies whether the client should follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// OAuth2 client credentials used to fetch a token for the targets.
                pub oauth2: WebhookConfigsItemHttpConfigOauth2,
                /// Optional proxy URL.
                pub proxy_u_r_l: String,
                /// TLS configuration for the client.
                pub tls_config: WebhookConfigsItemHttpConfigTlsConfig,
            }

            /// HTTP client configuration.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfig {
                /// Authorization header configuration for the client. This is mutually exclusive with BasicAuth and is only available starting from Alertmanager v0.22+.
                pub authorization: WechatConfigsItemHttpConfigAuthorization,
                /// BasicAuth for the client. This is mutually exclusive with Authorization. If both are defined, BasicAuth takes precedence.
                pub basic_auth: WechatConfigsItemHttpConfigBasicAuth,
                /// The secret's key that contains the bearer token to be used by the client for authentication. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bearer_token_secret: WechatConfigsItemHttpConfigBearerTokenSecret,
                /// FollowRedirects specifies whether the client should follow HTTP 3xx redirects.
                pub follow_redirects: bool,
                /// OAuth2 client credentials used to fetch a token for the targets.
                pub oauth2: WechatConfigsItemHttpConfigOauth2,
                /// Optional proxy URL.
                pub proxy_u_r_l: String,
                /// TLS configuration for the client.
                pub tls_config: WechatConfigsItemHttpConfigTlsConfig,
            }

            /// InhibitRule defines an inhibition rule that allows to mute alerts when other alerts are already firing. See https://prometheus.io/docs/alerting/latest/configuration/#inhibit_rule
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct InhibitRulesItem {
                /// Labels that must have an equal value in the source and target alert for the inhibition to take effect.
                pub equal: Vec<String>,
                /// Matchers for which one or more alerts have to exist for the inhibition to take effect. The operator enforces that the alert matches the resource’s namespace.
                pub source_match: Vec<SourceMatchItem>,
                /// Matchers that have to be fulfilled in the alerts to be muted. The operator enforces that the alert matches the resource’s namespace.
                pub target_match: Vec<TargetMatchItem>,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EmailConfigsItemTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing the client key file for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigTlsConfigKeySecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Matcher defines how to match on alert's labels.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MatchersItem {
                /// Match operation available with AlertManager >= v0.22.0 and takes precedence over Regex (deprecated) if non-empty.
                pub match_type: String,
                /// Label to match.
                pub name: String,
                /// Whether to match on equality (false) or regular-expression (true). Deprecated as of AlertManager >= v0.22.0 where a user should use MatchType instead.
                pub regex: bool,
                /// Label value to match.
                pub value: String,
            }

            /// MuteTimeInterval specifies the periods in time when notifications will be muted
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct MuteTimeIntervalsItem {
                /// Name of the time interval
                pub name: String,
                /// TimeIntervals is a list of TimeInterval
                pub time_intervals: Vec<TimeIntervalsItem>,
            }

            /// OAuth2 client credentials used to fetch a token for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: OpsgenieConfigsItemHttpConfigOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: OpsgenieConfigsItemHttpConfigOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: OpsgenieConfigsItemHttpConfigOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OAuth2 client credentials used to fetch a token for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: PagerdutyConfigsItemHttpConfigOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: PagerdutyConfigsItemHttpConfigOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: PagerdutyConfigsItemHttpConfigOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OAuth2 client credentials used to fetch a token for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: PushoverConfigsItemHttpConfigOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: PushoverConfigsItemHttpConfigOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: PushoverConfigsItemHttpConfigOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OAuth2 client credentials used to fetch a token for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: SlackConfigsItemHttpConfigOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: SlackConfigsItemHttpConfigOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: SlackConfigsItemHttpConfigOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OAuth2 client credentials used to fetch a token for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: SnsConfigsItemHttpConfigOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: SnsConfigsItemHttpConfigOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: SnsConfigsItemHttpConfigOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OAuth2 client credentials used to fetch a token for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: TelegramConfigsItemHttpConfigOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: TelegramConfigsItemHttpConfigOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: TelegramConfigsItemHttpConfigOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OAuth2 client credentials used to fetch a token for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: VictoropsConfigsItemHttpConfigOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: VictoropsConfigsItemHttpConfigOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: VictoropsConfigsItemHttpConfigOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OAuth2 client credentials used to fetch a token for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: WebhookConfigsItemHttpConfigOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: WebhookConfigsItemHttpConfigOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: WebhookConfigsItemHttpConfigOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OAuth2 client credentials used to fetch a token for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigOauth2 {
                /// The secret or configmap containing the OAuth2 client id
                pub client_id: WechatConfigsItemHttpConfigOauth2ClientId,
                /// The secret containing the OAuth2 client secret
                pub client_secret: WechatConfigsItemHttpConfigOauth2ClientSecret,
                /// Parameters to append to the token URL
                pub endpoint_params: WechatConfigsItemHttpConfigOauth2EndpointParams,
                /// OAuth2 scopes used for the token request
                pub scopes: Vec<String>,
                /// The URL to fetch the token from
                pub token_url: String,
            }

            /// OpsGenieConfig configures notifications via OpsGenie. See https://prometheus.io/docs/alerting/latest/configuration/#opsgenie_config
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItem {
                /// Comma separated list of actions that will be available for the alert.
                pub actions: String,
                /// The secret's key that contains the OpsGenie API key. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub api_key: OpsgenieConfigsItemApiKey,
                /// The URL to send OpsGenie API requests to.
                pub api_u_r_l: String,
                /// Description of the incident.
                pub description: String,
                /// A set of arbitrary key/value pairs that provide further detail about the incident.
                pub details: Vec<OpsgenieConfigsItemDetailsItem>,
                /// Optional field that can be used to specify which domain alert is related to.
                pub entity: String,
                /// HTTP client configuration.
                pub http_config: OpsgenieConfigsItemHttpConfig,
                /// Alert text limited to 130 characters.
                pub message: String,
                /// Additional alert note.
                pub note: String,
                /// Priority level of alert. Possible values are P1, P2, P3, P4, and P5.
                pub priority: String,
                /// List of responders responsible for notifications.
                pub responders: Vec<RespondersItem>,
                /// Whether or not to notify about resolved alerts.
                pub send_resolved: bool,
                /// Backlink to the sender of the notification.
                pub source: String,
                /// Comma separated list of tags attached to the notifications.
                pub tags: String,
                /// Whether to update message and description of the alert in OpsGenie if it already exists By default, the alert is never updated in OpsGenie, the new message only appears in activity log.
                pub update_alerts: bool,
            }

            /// PagerDutyImageConfig attaches images to an incident
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerDutyImageConfigsItem {
                /// Alt is the optional alternative text for the image.
                pub alt: String,
                /// Optional URL; makes the image a clickable link.
                pub href: String,
                /// Src of the image being attached to the incident
                pub src: String,
            }

            /// PagerDutyLinkConfig attaches text links to an incident
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerDutyLinkConfigsItem {
                /// Text that describes the purpose of the link, and can be used as the link's text.
                pub alt: String,
                /// Href is the URL of the link to be attached
                pub href: String,
            }

            /// PagerDutyConfig configures notifications via PagerDuty. See https://prometheus.io/docs/alerting/latest/configuration/#pagerduty_config
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItem {
                /// The class/type of the event.
                pub class: String,
                /// Client identification.
                pub client: String,
                /// Backlink to the sender of notification.
                pub client_u_r_l: String,
                /// The part or component of the affected system that is broken.
                pub component: String,
                /// Description of the incident.
                pub description: String,
                /// Arbitrary key/value pairs that provide further detail about the incident.
                pub details: Vec<PagerdutyConfigsItemDetailsItem>,
                /// A cluster or grouping of sources.
                pub group: String,
                /// HTTP client configuration.
                pub http_config: PagerdutyConfigsItemHttpConfig,
                /// A list of image details to attach that provide further detail about an incident.
                pub pager_duty_image_configs: Vec<PagerDutyImageConfigsItem>,
                /// A list of link details to attach that provide further detail about an incident.
                pub pager_duty_link_configs: Vec<PagerDutyLinkConfigsItem>,
                /// The secret's key that contains the PagerDuty integration key (when using Events API v2). Either this field or `serviceKey` needs to be defined. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub routing_key: RoutingKey,
                /// Whether or not to notify about resolved alerts.
                pub send_resolved: bool,
                /// The secret's key that contains the PagerDuty service key (when using integration type "Prometheus"). Either this field or `routingKey` needs to be defined. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub service_key: ServiceKey,
                /// Severity of the incident.
                pub severity: String,
                /// The URL to send requests to.
                pub url: String,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the password for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigBasicAuthPassword {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// PushoverConfig configures notifications via Pushover. See https://prometheus.io/docs/alerting/latest/configuration/#pushover_config
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItem {
                /// How long your notification will continue to be retried for, unless the user acknowledges the notification.
                pub expire: String,
                /// Whether notification message is HTML or plain text.
                pub html: bool,
                /// HTTP client configuration.
                pub http_config: PushoverConfigsItemHttpConfig,
                /// Notification message.
                pub message: String,
                /// Priority, see https://pushover.net/api#priority
                pub priority: String,
                /// How often the Pushover servers will send the same notification to the user. Must be at least 30 seconds.
                pub retry: String,
                /// Whether or not to notify about resolved alerts.
                pub send_resolved: bool,
                /// The name of one of the sounds supported by device clients to override the user's default sound choice
                pub sound: String,
                /// Notification title.
                pub title: String,
                /// The secret's key that contains the registered application’s API token, see https://pushover.net/apps. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub token: Token,
                /// A supplementary URL shown alongside the message.
                pub url: String,
                /// A title for supplementary URL, otherwise just the URL is shown
                pub url_title: String,
                /// The secret's key that contains the recipient user’s user key. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub user_key: UserKey,
            }

            /// Receiver defines one or more notification integrations.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ReceiversItem {
                /// List of Email configurations.
                pub email_configs: Vec<EmailConfigsItem>,
                /// Name of the receiver. Must be unique across all items from the list.
                pub name: String,
                /// List of OpsGenie configurations.
                pub opsgenie_configs: Vec<OpsgenieConfigsItem>,
                /// List of PagerDuty configurations.
                pub pagerduty_configs: Vec<PagerdutyConfigsItem>,
                /// List of Pushover configurations.
                pub pushover_configs: Vec<PushoverConfigsItem>,
                /// List of Slack configurations.
                pub slack_configs: Vec<SlackConfigsItem>,
                /// List of SNS configurations
                pub sns_configs: Vec<SnsConfigsItem>,
                /// List of Telegram configurations.
                pub telegram_configs: Vec<TelegramConfigsItem>,
                /// List of VictorOps configurations.
                pub victorops_configs: Vec<VictoropsConfigsItem>,
                /// List of webhook configurations.
                pub webhook_configs: Vec<WebhookConfigsItem>,
                /// List of WeChat configurations.
                pub wechat_configs: Vec<WechatConfigsItem>,
            }

            /// OpsGenieConfigResponder defines a responder to an incident. One of `id`, `name` or `username` has to be defined.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RespondersItem {
                /// ID of the responder.
                pub id: String,
                /// Name of the responder.
                pub name: String,
                /// Type of responder.
                pub r#type: String,
                /// Username of the responder.
                pub username: String,
            }

            /// The Alertmanager route definition for alerts matching the resource’s namespace. If present, it will be added to the generated Alertmanager configuration as a first-level route.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Route {
                /// Boolean indicating whether an alert should continue matching subsequent sibling nodes. It will always be overridden to true for the first-level route by the Prometheus operator.
                pub r#continue: bool,
                /// List of labels to group by. Labels must not be repeated (unique list). Special label "..." (aggregate by all possible labels), if provided, must be the only element in the list.
                pub group_by: Vec<String>,
                /// How long to wait before sending an updated notification. Must match the regular expression`^(([0-9]+)y)?(([0-9]+)w)?(([0-9]+)d)?(([0-9]+)h)?(([0-9]+)m)?(([0-9]+)s)?(([0-9]+)ms)?$` Example: "5m"
                pub group_interval: String,
                /// How long to wait before sending the initial notification. Must match the regular expression`^(([0-9]+)y)?(([0-9]+)w)?(([0-9]+)d)?(([0-9]+)h)?(([0-9]+)m)?(([0-9]+)s)?(([0-9]+)ms)?$` Example: "30s"
                pub group_wait: String,
                /// List of matchers that the alert’s labels should match. For the first level route, the operator removes any existing equality and regexp matcher on the `namespace` label and adds a `namespace: <object namespace>` matcher.
                pub matchers: Vec<MatchersItem>,
                /// Note: this comment applies to the field definition above but appears below otherwise it gets included in the generated manifest. CRD schema doesn't support self-referential types for now (see https://github.com/kubernetes/kubernetes/issues/62872). We have to use an alternative type to circumvent the limitation. The downside is that the Kube API can't validate the data beyond the fact that it is a valid JSON representation. MuteTimeIntervals is a list of MuteTimeInterval names that will mute this route when matched,
                pub mute_time_intervals: Vec<String>,
                /// Name of the receiver for this route. If not empty, it should be listed in the `receivers` field.
                pub receiver: String,
                /// How long to wait before repeating the last notification. Must match the regular expression`^(([0-9]+)y)?(([0-9]+)w)?(([0-9]+)d)?(([0-9]+)h)?(([0-9]+)m)?(([0-9]+)s)?(([0-9]+)ms)?$` Example: "4h"
                pub repeat_interval: String,
                /// Child routes.
                pub routes: Vec<serde_json::Map<String, serde_json::Value>>,
            }

            /// The secret's key that contains the PagerDuty integration key (when using Events API v2). Either this field or `serviceKey` needs to be defined. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct RoutingKey {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EmailConfigsItemTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EmailConfigsItemTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigOauth2ClientIdSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigTlsConfigCaSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Secret containing data to use for the targets.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigTlsConfigCertSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// SecretKey is the AWS API secret. If blank, the environment variable `AWS_SECRET_ACCESS_KEY` is used.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SecretKey {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the PagerDuty service key (when using integration type "Prometheus"). Either this field or `routingKey` needs to be defined. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct ServiceKey {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// Configures AWS's Signature Verification 4 signing process to sign requests.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Sigv4 {
                /// AccessKey is the AWS API key. If blank, the environment variable `AWS_ACCESS_KEY_ID` is used.
                pub access_key: AccessKey,
                /// Profile is the named AWS profile used to authenticate.
                pub profile: String,
                /// Region is the AWS region. If blank, the region from the default credentials chain used.
                pub region: String,
                /// RoleArn is the named AWS profile used to authenticate.
                pub role_arn: String,
                /// SecretKey is the AWS API secret. If blank, the environment variable `AWS_SECRET_ACCESS_KEY` is used.
                pub secret_key: SecretKey,
            }

            /// SlackConfig configures notifications via Slack. See https://prometheus.io/docs/alerting/latest/configuration/#slack_config
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItem {
                /// A list of Slack actions that are sent with each notification.
                pub actions: Vec<ActionsItem>,
                /// The secret's key that contains the Slack webhook URL. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub api_u_r_l: ApiURL,
                pub callback_id: String,
                /// The channel or user to send notifications to.
                pub channel: String,
                pub color: String,
                pub fallback: String,
                /// A list of Slack fields that are sent with each notification.
                pub fields: Vec<FieldsItem>,
                pub footer: String,
                /// HTTP client configuration.
                pub http_config: SlackConfigsItemHttpConfig,
                pub icon_emoji: String,
                pub icon_u_r_l: String,
                pub image_u_r_l: String,
                pub link_names: bool,
                pub mrkdwn_in: Vec<String>,
                pub pretext: String,
                /// Whether or not to notify about resolved alerts.
                pub send_resolved: bool,
                pub short_fields: bool,
                pub text: String,
                pub thumb_u_r_l: String,
                pub title: String,
                pub title_link: String,
                pub username: String,
            }

            /// SNSConfig configures notifications via AWS SNS. See https://prometheus.io/docs/alerting/latest/configuration/#sns_configs
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItem {
                /// The SNS API URL i.e. https://sns.us-east-2.amazonaws.com. If not specified, the SNS API URL from the SNS SDK will be used.
                pub api_u_r_l: String,
                /// SNS message attributes.
                pub attributes: Attributes,
                /// HTTP client configuration.
                pub http_config: SnsConfigsItemHttpConfig,
                /// The message content of the SNS notification.
                pub message: String,
                /// Phone number if message is delivered via SMS in E.164 format. If you don't specify this value, you must specify a value for the TopicARN or TargetARN.
                pub phone_number: String,
                /// Whether or not to notify about resolved alerts.
                pub send_resolved: bool,
                /// Configures AWS's Signature Verification 4 signing process to sign requests.
                pub sigv4: Sigv4,
                /// Subject line when the message is delivered to email endpoints.
                pub subject: String,
                /// The  mobile platform endpoint ARN if message is delivered via mobile notifications. If you don't specify this value, you must specify a value for the topic_arn or PhoneNumber.
                pub target_a_r_n: String,
                /// SNS topic ARN, i.e. arn:aws:sns:us-east-2:698519295917:My-Topic If you don't specify this value, you must specify a value for the PhoneNumber or TargetARN.
                pub topic_a_r_n: String,
            }

            /// Matcher defines how to match on alert's labels.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SourceMatchItem {
                /// Match operation available with AlertManager >= v0.22.0 and takes precedence over Regex (deprecated) if non-empty.
                pub match_type: String,
                /// Label to match.
                pub name: String,
                /// Whether to match on equality (false) or regular-expression (true). Deprecated as of AlertManager >= v0.22.0 where a user should use MatchType instead.
                pub regex: bool,
                /// Label value to match.
                pub value: String,
            }

            /// AlertmanagerConfigSpec is a specification of the desired behavior of the Alertmanager configuration. By definition, the Alertmanager configuration only applies to alerts for which the `namespace` label is equal to the namespace of the AlertmanagerConfig resource.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Spec {
                /// List of inhibition rules. The rules will only apply to alerts matching the resource’s namespace.
                pub inhibit_rules: Vec<InhibitRulesItem>,
                /// List of MuteTimeInterval specifying when the routes should be muted.
                pub mute_time_intervals: Vec<MuteTimeIntervalsItem>,
                /// List of receivers.
                pub receivers: Vec<ReceiversItem>,
                /// The Alertmanager route definition for alerts matching the resource’s namespace. If present, it will be added to the generated Alertmanager configuration as a first-level route.
                pub route: Route,
            }

            /// Matcher defines how to match on alert's labels.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TargetMatchItem {
                /// Match operation available with AlertManager >= v0.22.0 and takes precedence over Regex (deprecated) if non-empty.
                pub match_type: String,
                /// Label to match.
                pub name: String,
                /// Whether to match on equality (false) or regular-expression (true). Deprecated as of AlertManager >= v0.22.0 where a user should use MatchType instead.
                pub regex: bool,
                /// Label value to match.
                pub value: String,
            }

            /// TelegramConfig configures notifications via Telegram. See https://prometheus.io/docs/alerting/latest/configuration/#telegram_config
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItem {
                /// The Telegram API URL i.e. https://api.telegram.org. If not specified, default API URL will be used.
                pub api_u_r_l: String,
                /// Telegram bot token The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub bot_token: BotToken,
                /// The Telegram chat ID.
                pub chat_i_d: i64,
                /// Disable telegram notifications
                pub disable_notifications: bool,
                /// HTTP client configuration.
                pub http_config: TelegramConfigsItemHttpConfig,
                /// Message template
                pub message: String,
                /// Parse mode for telegram message
                pub parse_mode: String,
                /// Whether to notify about resolved alerts.
                pub send_resolved: bool,
            }

            /// TimeInterval describes intervals of time
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TimeIntervalsItem {
                /// DaysOfMonth is a list of DayOfMonthRange
                pub days_of_month: Vec<DaysOfMonthItem>,
                /// Months is a list of MonthRange
                pub months: Vec<String>,
                /// Times is a list of TimeRange
                pub times: Vec<TimesItem>,
                /// Weekdays is a list of WeekdayRange
                pub weekdays: Vec<String>,
                /// Years is a list of YearRange
                pub years: Vec<String>,
            }

            /// TimeRange defines a start and end time in 24hr format
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TimesItem {
                /// EndTime is the end time in 24hr format.
                pub end_time: String,
                /// StartTime is the start time in 24hr format.
                pub start_time: String,
            }

            /// TLS configuration
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct EmailConfigsItemTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: EmailConfigsItemTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: EmailConfigsItemTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: EmailConfigsItemTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS configuration for the client.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: OpsgenieConfigsItemHttpConfigTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: OpsgenieConfigsItemHttpConfigTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: OpsgenieConfigsItemHttpConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS configuration for the client.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: PagerdutyConfigsItemHttpConfigTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: PagerdutyConfigsItemHttpConfigTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: PagerdutyConfigsItemHttpConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS configuration for the client.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: PushoverConfigsItemHttpConfigTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: PushoverConfigsItemHttpConfigTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: PushoverConfigsItemHttpConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS configuration for the client.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: SlackConfigsItemHttpConfigTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: SlackConfigsItemHttpConfigTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: SlackConfigsItemHttpConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS configuration for the client.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: SnsConfigsItemHttpConfigTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: SnsConfigsItemHttpConfigTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: SnsConfigsItemHttpConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS configuration for the client.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: TelegramConfigsItemHttpConfigTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: TelegramConfigsItemHttpConfigTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: TelegramConfigsItemHttpConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS configuration for the client.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: VictoropsConfigsItemHttpConfigTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: VictoropsConfigsItemHttpConfigTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: VictoropsConfigsItemHttpConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS configuration for the client.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: WebhookConfigsItemHttpConfigTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: WebhookConfigsItemHttpConfigTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: WebhookConfigsItemHttpConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// TLS configuration for the client.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigTlsConfig {
                /// Struct containing the CA cert to use for the targets.
                pub ca: WechatConfigsItemHttpConfigTlsConfigCa,
                /// Struct containing the client cert file for the targets.
                pub cert: WechatConfigsItemHttpConfigTlsConfigCert,
                /// Disable target certificate validation.
                pub insecure_skip_verify: bool,
                /// Secret containing the client key file for the targets.
                pub key_secret: WechatConfigsItemHttpConfigTlsConfigKeySecret,
                /// Used to verify the hostname for the targets.
                pub server_name: String,
            }

            /// The secret's key that contains the registered application’s API token, see https://pushover.net/apps. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct Token {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the webhook URL to send HTTP requests to. `urlSecret` takes precedence over `url`. One of `urlSecret` and `url` should be defined. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct UrlSecret {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret's key that contains the recipient user’s user key. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct UserKey {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct OpsgenieConfigsItemHttpConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PagerdutyConfigsItemHttpConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct PushoverConfigsItemHttpConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SlackConfigsItemHttpConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct SnsConfigsItemHttpConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct TelegramConfigsItemHttpConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItemHttpConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItemHttpConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// The secret in the service monitor namespace that contains the username for authentication.
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItemHttpConfigBasicAuthUsername {
                /// The key of the secret to select from.  Must be a valid secret key.
                pub key: String,
                /// Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                pub name: String,
                /// Specify whether the Secret or its key must be defined
                pub optional: bool,
            }

            /// VictorOpsConfig configures notifications via VictorOps. See https://prometheus.io/docs/alerting/latest/configuration/#victorops_config
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct VictoropsConfigsItem {
                /// The secret's key that contains the API key to use when talking to the VictorOps API. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub api_key: VictoropsConfigsItemApiKey,
                /// The VictorOps API URL.
                pub api_url: String,
                /// Additional custom fields for notification.
                pub custom_fields: Vec<CustomFieldsItem>,
                /// Contains summary of the alerted problem.
                pub entity_display_name: String,
                /// The HTTP client's configuration.
                pub http_config: VictoropsConfigsItemHttpConfig,
                /// Describes the behavior of the alert (CRITICAL, WARNING, INFO).
                pub message_type: String,
                /// The monitoring tool the state message is from.
                pub monitoring_tool: String,
                /// A key used to map the alert to a team.
                pub routing_key: String,
                /// Whether or not to notify about resolved alerts.
                pub send_resolved: bool,
                /// Contains long explanation of the alerted problem.
                pub state_message: String,
            }

            /// WebhookConfig configures notifications via a generic receiver supporting the webhook payload. See https://prometheus.io/docs/alerting/latest/configuration/#webhook_config
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WebhookConfigsItem {
                /// HTTP client configuration.
                pub http_config: WebhookConfigsItemHttpConfig,
                /// Maximum number of alerts to be sent per webhook message. When 0, all alerts are included.
                pub max_alerts: i32,
                /// Whether or not to notify about resolved alerts.
                pub send_resolved: bool,
                /// The URL to send HTTP POST requests to. `urlSecret` takes precedence over `url`. One of `urlSecret` and `url` should be defined.
                pub url: String,
                /// The secret's key that contains the webhook URL to send HTTP requests to. `urlSecret` takes precedence over `url`. One of `urlSecret` and `url` should be defined. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub url_secret: UrlSecret,
            }

            /// WeChatConfig configures notifications via WeChat. See https://prometheus.io/docs/alerting/latest/configuration/#wechat_config
            #[derive(serde::Serialize, serde::Deserialize, Debug, PartialEq)]
            #[serde(rename_all = "camelCase")]
            pub struct WechatConfigsItem {
                pub agent_i_d: String,
                /// The secret's key that contains the WeChat API key. The secret needs to be in the same namespace as the AlertmanagerConfig object and accessible by the Prometheus Operator.
                pub api_secret: ApiSecret,
                /// The WeChat API URL.
                pub api_u_r_l: String,
                /// The corp id for authentication.
                pub corp_i_d: String,
                /// HTTP client configuration.
                pub http_config: WechatConfigsItemHttpConfig,
                /// API request data as defined by the WeChat API.
                pub message: String,
                pub message_type: String,
                /// Whether or not to notify about resolved alerts.
                pub send_resolved: bool,
                pub to_party: String,
                pub to_tag: String,
                pub to_user: String,
            }
        }
    }
}
